require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__arm__)) {
    require 'arm/asm.ph';
} else {
    unless(defined(&_MACHINE_ASM_H_)) {
	eval 'sub _MACHINE_ASM_H_ () {1;}' unless defined(&_MACHINE_ASM_H_);
	undef(&__FBSDID) if defined(&__FBSDID);
	if(!defined(&lint)  && !defined(&STRIP_FBSDID)) {
	    eval 'sub __FBSDID {
	        my($s) = @_;
    		eval q(. &ident $s);
	    }' unless defined(&__FBSDID);
	} else {
	    eval 'sub __FBSDID {
	        my($s) = @_;
    		eval q();
	    }' unless defined(&__FBSDID);
	}
	eval 'sub _C_LABEL {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&_C_LABEL);
	if(defined(&KDTRACE_HOOKS)) {
	    eval 'sub DTRACE_NOP () { &nop;}' unless defined(&DTRACE_NOP);
	} else {
	    eval 'sub DTRACE_NOP () {1;}' unless defined(&DTRACE_NOP);
	}
	eval 'sub LENTRY {
	    my($sym) = @_;
    	    eval q(. &text; . &align 2; . &type $sym, &function; $sym: . &cfi_startproc;  &BTI_C;  &DTRACE_NOP);
	}' unless defined(&LENTRY);
	eval 'sub ENTRY {
	    my($sym) = @_;
    	    eval q(. &globl $sym;  &LENTRY($sym));
	}' unless defined(&ENTRY);
	eval 'sub EENTRY {
	    my($sym) = @_;
    	    eval q(. &globl $sym; . &text; . &align 2; . &type $sym, &function; $sym:);
	}' unless defined(&EENTRY);
	eval 'sub LEND {
	    my($sym) = @_;
    	    eval q(. &ltorg; . &cfi_endproc; . &size $sym, . - $sym);
	}' unless defined(&LEND);
	eval 'sub END {
	    my($sym) = @_;
    	    eval q( &LEND($sym));
	}' unless defined(&END);
	eval 'sub EEND {
	    my($sym) = @_;
    	    eval q();
	}' unless defined(&EEND);
	eval 'sub WEAK_REFERENCE {
	    my($sym, $alias) = @_;
    	    eval q(. &weak $alias; . &set $alias,$sym);
	}' unless defined(&WEAK_REFERENCE);
	eval 'sub UINT64_C {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&UINT64_C);
	if(defined(&PIC)) {
	    eval 'sub PIC_SYM {
	        my($x,$y) = @_;
    		eval q($x  @  $y);
	    }' unless defined(&PIC_SYM);
	} else {
	    eval 'sub PIC_SYM {
	        my($x,$y) = @_;
    		eval q($x);
	    }' unless defined(&PIC_SYM);
	}
	eval 'sub lr () { &x30;}' unless defined(&lr);
	eval 'sub SET_FAULT_HANDLER {
	    my($handler, $tmp) = @_;
    	    eval q( &ldr $tmp, [ &x18,  &PC_CURTHREAD];  &ldr $tmp, [$tmp,  &TD_PCB];  &str $handler, [$tmp,  &PCB_ONFAULT]);
	}' unless defined(&SET_FAULT_HANDLER);
	eval 'sub ENTER_USER_ACCESS {
	    my($reg, $tmp) = @_;
    	    eval q( &ldr $tmp, = &has_pan;  &ldr $reg, [$tmp];  &cbz $reg, 997 &f; . &inst 0xd500409f | (0<< 8); 997:);
	}' unless defined(&ENTER_USER_ACCESS);
	eval 'sub EXIT_USER_ACCESS {
	    my($reg) = @_;
    	    eval q( &cbz $reg, 998 &f; . &inst 0xd500409f | (1<< 8); 998:);
	}' unless defined(&EXIT_USER_ACCESS);
	eval 'sub EXIT_USER_ACCESS_CHECK {
	    my($reg, $tmp) = @_;
    	    eval q( &ldr $tmp, = &has_pan;  &ldr $reg, [$tmp];  &cbz $reg, 999 &f; . &inst 0xd500409f | (1<< 8); 999:);
	}' unless defined(&EXIT_USER_ACCESS_CHECK);
	eval 'sub ERET () { &eret;  &dsb  &sy;  &isb;}' unless defined(&ERET);
	if(defined(&__ARM_FEATURE_BTI_DEFAULT)) {
	    eval 'sub BTI_C () { &hint 34;}' unless defined(&BTI_C);
	    eval 'sub BTI_J () { &hint 36;}' unless defined(&BTI_J);
	} else {
	    eval 'sub BTI_C () {1;}' unless defined(&BTI_C);
	    eval 'sub BTI_J () {1;}' unless defined(&BTI_J);
	}
	if(defined(&__ARM_FEATURE_PAC_DEFAULT)) {
	    eval 'sub PAC_LR_SIGN () { &hint 25;}' unless defined(&PAC_LR_SIGN);
	    eval 'sub PAC_LR_AUTH () { &hint 29;}' unless defined(&PAC_LR_AUTH);
	} else {
	    eval 'sub PAC_LR_SIGN () {1;}' unless defined(&PAC_LR_SIGN);
	    eval 'sub PAC_LR_AUTH () {1;}' unless defined(&PAC_LR_AUTH);
	}
	if(defined(&__ARM_FEATURE_BTI_DEFAULT)) {
	    if(defined(&__ARM_FEATURE_PAC_DEFAULT)) {
		eval 'sub GNU_PROPERTY_AARCH64_FEATURE_1_VAL () {( &GNU_PROPERTY_AARCH64_FEATURE_1_BTI |  &GNU_PROPERTY_AARCH64_FEATURE_1_PAC);}' unless defined(&GNU_PROPERTY_AARCH64_FEATURE_1_VAL);
	    } else {
		eval 'sub GNU_PROPERTY_AARCH64_FEATURE_1_VAL () {( &GNU_PROPERTY_AARCH64_FEATURE_1_BTI);}' unless defined(&GNU_PROPERTY_AARCH64_FEATURE_1_VAL);
	    }
	}
 elsif(defined(&__ARM_FEATURE_PAC_DEFAULT)) {
	    eval 'sub GNU_PROPERTY_AARCH64_FEATURE_1_VAL () {( &GNU_PROPERTY_AARCH64_FEATURE_1_PAC);}' unless defined(&GNU_PROPERTY_AARCH64_FEATURE_1_VAL);
	} else {
	    eval 'sub GNU_PROPERTY_AARCH64_FEATURE_1_VAL () {0;}' unless defined(&GNU_PROPERTY_AARCH64_FEATURE_1_VAL);
	}
	if(defined(&__ARM_FEATURE_BTI_DEFAULT) || defined(&__ARM_FEATURE_PAC_DEFAULT)) {
	    eval 'sub GNU_PROPERTY_AARCH64_FEATURE_1_NOTE {
	        my($x) = @_;
    		eval q(. &section . ($note->{gnu}->{property}), \\"a\\"; . &balign 8; .4 &byte 0x4; .4 &byte 0x10; .4 &byte ( &NT_GNU_PROPERTY_TYPE_0); . &asciz \\"GNU\\"; .4 &byte ( &GNU_PROPERTY_AARCH64_FEATURE_1_AND); .4 &byte 0x4; .4 &byte ($x); .4 &byte 0);
	    }' unless defined(&GNU_PROPERTY_AARCH64_FEATURE_1_NOTE);
	} else {
	    eval 'sub GNU_PROPERTY_AARCH64_FEATURE_1_NOTE {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&GNU_PROPERTY_AARCH64_FEATURE_1_NOTE);
	}
    }
}
1;
