require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__arm__)) {
    require 'arm/atomic.ph';
} else {
    unless(defined(&_MACHINE_ATOMIC_H_)) {
	eval 'sub _MACHINE_ATOMIC_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_H_);
	eval 'sub isb () {
	    eval q( &__asm  &__volatile(\\"isb\\" : : : \\"memory\\"));
	}' unless defined(&isb);
	eval 'sub dsb {
	    my($opt) = @_;
    	    eval q( &__asm  &__volatile(\\"dsb \\"  &__STRING($opt) : : : \\"memory\\"));
	}' unless defined(&dsb);
	eval 'sub dmb {
	    my($opt) = @_;
    	    eval q( &__asm  &__volatile(\\"dmb \\"  &__STRING($opt) : : : \\"memory\\"));
	}' unless defined(&dmb);
	eval 'sub mb () {
	    eval q( &dmb( &sy));
	}' unless defined(&mb);
	eval 'sub wmb () {
	    eval q( &dmb( &st));
	}' unless defined(&wmb);
	eval 'sub rmb () {
	    eval q( &dmb( &ld));
	}' unless defined(&rmb);
	if(defined(&_KERNEL)) {
	}
	if(defined(&SAN_NEEDS_INTERCEPTORS)  && !defined(&SAN_RUNTIME)) {
	    require 'sys/atomic_san.ph';
	} else {
	    require 'sys/atomic_common.ph';
	    if(defined(&_KERNEL)) {
		if(defined(&LSE_ATOMICS)) {
		    eval 'sub _ATOMIC_LSE_SUPPORTED () {1;}' unless defined(&_ATOMIC_LSE_SUPPORTED);
		} else {
		    eval 'sub _ATOMIC_LSE_SUPPORTED () { &lse_supported;}' unless defined(&_ATOMIC_LSE_SUPPORTED);
		}
	    } else {
		eval 'sub _ATOMIC_LSE_SUPPORTED () {0;}' unless defined(&_ATOMIC_LSE_SUPPORTED);
	    }
	    eval 'sub _ATOMIC_OP_PROTO {
	        my($t, $op, $bar, $flav) = @_;
    		eval q( &static  &__inline  &void  &atomic_$op &_$bar$t$flav( &volatile \'uint\'$t &_t * &p, \'uint\'$t &_t  &val));
	    }' unless defined(&_ATOMIC_OP_PROTO);
	    eval 'sub _ATOMIC_OP_IMPL {
	        my($t, $w, $s, $op, $llsc_asm_op, $lse_asm_op, $pre, $bar, $a, $l) = @_;
    		eval q( &_ATOMIC_OP_PROTO($t, $op, $bar,  &_llsc) { \'uint\'$t &_t  &tmp; \'int\'  &res; $pre;  &__asm  &__volatile( \\"1: ld\\"$a\\"xr\\"$s\\"	%\\"$w\\"0, [%2]\\\\n\\" \\"   \\"$llsc_asm_op\\"	%\\"$w\\"0, %\\"$w\\"0, %\\"$w\\"3\\\\n\\" \\"   st\\"$l\\"xr\\"$s\\"	%w1, %\\"$w\\"0, [%2]\\\\n\\" \\"   cbnz		%w1, 1b\\\\n\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &val) : \\"memory\\" ); }  &_ATOMIC_OP_PROTO($t, $op, $bar,  &_lse) { \'uint\'$t &_t  &tmp; $pre;  &__asm  &__volatile( \\".arch_extension lse\\\\n\\" \\"ld\\"$lse_asm_op$a$l$s\\"	%\\"$w\\"2, %\\"$w\\"0, [%1]\\\\n\\" \\".arch_extension nolse\\\\n\\" : \\"=r\\" ( &tmp) : \\"r\\" ( &p), \\"r\\" ( &val) : \\"memory\\" ); }  &_ATOMIC_OP_PROTO($t, $op, $bar, ) {  &if ( &_ATOMIC_LSE_SUPPORTED)  &atomic_$op &_$bar$t &_lse( &p,  &val);  &else  &atomic_$op &_$bar$t &_llsc( &p,  &val); });
	    }' unless defined(&_ATOMIC_OP_IMPL);
	    eval 'sub __ATOMIC_OP {
	        my($op, $llsc_asm_op, $lse_asm_op, $pre, $bar, $a, $l) = @_;
    		eval q( &_ATOMIC_OP_IMPL(8,  &w,  &b, $op, $llsc_asm_op, $lse_asm_op, $pre, $bar, $a, $l)  &_ATOMIC_OP_IMPL(16,  &w,  &h, $op, $llsc_asm_op, $lse_asm_op, $pre, $bar, $a, $l)  &_ATOMIC_OP_IMPL(32,  &w, , $op, $llsc_asm_op, $lse_asm_op, $pre, $bar, $a, $l)  &_ATOMIC_OP_IMPL(64, , , $op, $llsc_asm_op, $lse_asm_op, $pre, $bar, $a, $l));
	    }' unless defined(&__ATOMIC_OP);
	    eval 'sub _ATOMIC_OP {
	        my($op, $llsc_asm_op, $lse_asm_op, $pre) = @_;
    		eval q( &__ATOMIC_OP($op, $llsc_asm_op, $lse_asm_op, $pre, , , )  &__ATOMIC_OP($op, $llsc_asm_op, $lse_asm_op, $pre,  &acq_,  &a, )  &__ATOMIC_OP($op, $llsc_asm_op, $lse_asm_op, $pre,  &rel_, ,  &l));
	    }' unless defined(&_ATOMIC_OP);
	    eval 'sub _ATOMIC_CMPSET_PROTO {
	        my($t, $bar, $flav) = @_;
    		eval q( &static  &__inline \'int\'  &atomic_cmpset_$bar$t$flav( &volatile \'uint\'$t &_t * &p, \'uint\'$t &_t  &cmpval, \'uint\'$t &_t  &newval));
	    }' unless defined(&_ATOMIC_CMPSET_PROTO);
	    eval 'sub _ATOMIC_FCMPSET_PROTO {
	        my($t, $bar, $flav) = @_;
    		eval q( &static  &__inline \'int\'  &atomic_fcmpset_$bar$t$flav( &volatile \'uint\'$t &_t * &p, \'uint\'$t &_t * &cmpval, \'uint\'$t &_t  &newval));
	    }' unless defined(&_ATOMIC_FCMPSET_PROTO);
	    eval 'sub _ATOMIC_CMPSET_IMPL {
	        my($t, $w, $s, $bar, $a, $l) = @_;
    		eval q( &_ATOMIC_CMPSET_PROTO($t, $bar,  &_llsc) { \'uint\'$t &_t  &tmp; \'int\'  &res;  &__asm  &__volatile( \\"1: mov		%w1, #1\\\\n\\" \\"   ld\\"$a\\"xr\\"$s\\"	%\\"$w\\"0, [%2]\\\\n\\" \\"   cmp		%\\"$w\\"0, %\\"$w\\"3\\\\n\\" \\"   b.ne		2f\\\\n\\" \\"   st\\"$l\\"xr\\"$s\\"	%w1, %\\"$w\\"4, [%2]\\\\n\\" \\"   cbnz		%w1, 1b\\\\n\\" \\"2:\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &cmpval), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" );  &return (! &res); }  &_ATOMIC_CMPSET_PROTO($t, $bar,  &_lse) { \'uint\'$t &_t  &oldval; \'int\'  &res;  &oldval =  &cmpval;  &__asm  &__volatile( \\".arch_extension lse\\\\n\\" \\"cas\\"$a$l$s\\"	%\\"$w\\"1, %\\"$w\\"4, [%3]\\\\n\\" \\"cmp		%\\"$w\\"1, %\\"$w\\"2\\\\n\\" \\"cset		%w0, eq\\\\n\\" \\".arch_extension nolse\\\\n\\" : \\"=r\\" ( &res), \\"+&r\\" ( &cmpval) : \\"r\\" ( &oldval), \\"r\\" ( &p), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" );  &return ( &res); }  &_ATOMIC_CMPSET_PROTO($t, $bar, ) {  &if ( &_ATOMIC_LSE_SUPPORTED)  &return ( &atomic_cmpset_$bar$t &_lse( &p,  &cmpval,  &newval));  &else  &return ( &atomic_cmpset_$bar$t &_llsc( &p,  &cmpval,  &newval)); }  &_ATOMIC_FCMPSET_PROTO($t, $bar,  &_llsc) { \'uint\'$t &_t  &_cmpval,  &tmp; \'int\'  &res;  &_cmpval = * &cmpval;  &__asm  &__volatile( \\"   mov		%w1, #1\\\\n\\" \\"   ld\\"$a\\"xr\\"$s\\"	%\\"$w\\"0, [%2]\\\\n\\" \\"   cmp		%\\"$w\\"0, %\\"$w\\"3\\\\n\\" \\"   b.ne		1f\\\\n\\" \\"   st\\"$l\\"xr\\"$s\\"	%w1, %\\"$w\\"4, [%2]\\\\n\\" \\"1:\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &_cmpval), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" ); * &cmpval =  &tmp;  &return (! &res); }  &_ATOMIC_FCMPSET_PROTO($t, $bar,  &_lse) { \'uint\'$t &_t  &_cmpval,  &tmp; \'int\'  &res;  &_cmpval =  &tmp = * &cmpval;  &__asm  &__volatile( \\".arch_extension lse\\\\n\\" \\"cas\\"$a$l$s\\"	%\\"$w\\"1, %\\"$w\\"4, [%3]\\\\n\\" \\"cmp		%\\"$w\\"1, %\\"$w\\"2\\\\n\\" \\"cset		%w0, eq\\\\n\\" \\".arch_extension nolse\\\\n\\" : \\"=r\\" ( &res), \\"+&r\\" ( &tmp) : \\"r\\" ( &_cmpval), \\"r\\" ( &p), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" ); * &cmpval =  &tmp;  &return ( &res); }  &_ATOMIC_FCMPSET_PROTO($t, $bar, ) {  &if ( &_ATOMIC_LSE_SUPPORTED)  &return ( &atomic_fcmpset_$bar$t &_lse( &p,  &cmpval,  &newval));  &else  &return ( &atomic_fcmpset_$bar$t &_llsc( &p,  &cmpval,  &newval)); });
	    }' unless defined(&_ATOMIC_CMPSET_IMPL);
	    eval 'sub _ATOMIC_CMPSET {
	        my($bar, $a, $l) = @_;
    		eval q( &_ATOMIC_CMPSET_IMPL(8,  &w,  &b, $bar, $a, $l)  &_ATOMIC_CMPSET_IMPL(16,  &w,  &h, $bar, $a, $l)  &_ATOMIC_CMPSET_IMPL(32,  &w, , $bar, $a, $l)  &_ATOMIC_CMPSET_IMPL(64, , , $bar, $a, $l));
	    }' unless defined(&_ATOMIC_CMPSET);
	    eval 'sub _ATOMIC_FETCHADD_PROTO {
	        my($t, $flav) = @_;
    		eval q( &static  &__inline \'uint\'$t &_t  &atomic_fetchadd_$t$flav( &volatile \'uint\'$t &_t * &p, \'uint\'$t &_t  &val));
	    }' unless defined(&_ATOMIC_FETCHADD_PROTO);
	    eval 'sub _ATOMIC_FETCHADD_IMPL {
	        my($t, $w) = @_;
    		eval q( &_ATOMIC_FETCHADD_PROTO($t,  &_llsc) { \'uint\'$t &_t  &ret,  &tmp; \'int\'  &res;  &__asm  &__volatile( \\"1: ldxr	%\\"$w\\"2, [%3]\\\\n\\" \\"   add	%\\"$w\\"0, %\\"$w\\"2, %\\"$w\\"4\\\\n\\" \\"   stxr	%w1, %\\"$w\\"0, [%3]\\\\n\\" \\"   cbnz	%w1, 1b\\\\n\\" : \\"=&r\\" ( &tmp), \\"=&r\\" ( &res), \\"=&r\\" ( &ret) : \\"r\\" ( &p), \\"r\\" ( &val) : \\"memory\\" );  &return ( &ret); }  &_ATOMIC_FETCHADD_PROTO($t,  &_lse) { \'uint\'$t &_t  &ret;  &__asm  &__volatile( \\".arch_extension lse\\\\n\\" \\"ldadd	%\\"$w\\"2, %\\"$w\\"0, [%1]\\\\n\\" \\".arch_extension nolse\\\\n\\" : \\"=r\\" ( &ret) : \\"r\\" ( &p), \\"r\\" ( &val) : \\"memory\\" );  &return ( &ret); }  &_ATOMIC_FETCHADD_PROTO($t, ) {  &if ( &_ATOMIC_LSE_SUPPORTED)  &return ( &atomic_fetchadd_$t &_lse( &p,  &val));  &else  &return ( &atomic_fetchadd_$t &_llsc( &p,  &val)); });
	    }' unless defined(&_ATOMIC_FETCHADD_IMPL);
	    eval 'sub _ATOMIC_SWAP_PROTO {
	        my($t, $flav) = @_;
    		eval q( &static  &__inline \'uint\'$t &_t  &atomic_swap_$t$flav( &volatile \'uint\'$t &_t * &p, \'uint\'$t &_t  &val));
	    }' unless defined(&_ATOMIC_SWAP_PROTO);
	    eval 'sub _ATOMIC_READANDCLEAR_PROTO {
	        my($t, $flav) = @_;
    		eval q( &static  &__inline \'uint\'$t &_t  &atomic_readandclear_$t$flav( &volatile \'uint\'$t &_t * &p));
	    }' unless defined(&_ATOMIC_READANDCLEAR_PROTO);
	    eval 'sub _ATOMIC_SWAP_IMPL {
	        my($t, $w, $zreg) = @_;
    		eval q( &_ATOMIC_SWAP_PROTO($t,  &_llsc) { \'uint\'$t &_t  &ret; \'int\'  &res;  &__asm  &__volatile( \\"1: ldxr	%\\"$w\\"1, [%2]\\\\n\\" \\"   stxr	%w0, %\\"$w\\"3, [%2]\\\\n\\" \\"   cbnz	%w0, 1b\\\\n\\" : \\"=&r\\" ( &res), \\"=&r\\" ( &ret) : \\"r\\" ( &p), \\"r\\" ( &val) : \\"memory\\" );  &return ( &ret); }  &_ATOMIC_SWAP_PROTO($t,  &_lse) { \'uint\'$t &_t  &ret;  &__asm  &__volatile( \\".arch_extension lse\\\\n\\" \\"swp	%\\"$w\\"2, %\\"$w\\"0, [%1]\\\\n\\" \\".arch_extension nolse\\\\n\\" : \\"=r\\" ( &ret) : \\"r\\" ( &p), \\"r\\" ( &val) : \\"memory\\" );  &return ( &ret); }  &_ATOMIC_SWAP_PROTO($t, ) {  &if ( &_ATOMIC_LSE_SUPPORTED)  &return ( &atomic_swap_$t &_lse( &p,  &val));  &else  &return ( &atomic_swap_$t &_llsc( &p,  &val)); }  &_ATOMIC_READANDCLEAR_PROTO($t,  &_llsc) { \'uint\'$t &_t  &ret; \'int\'  &res;  &__asm  &__volatile( \\"1: ldxr	%\\"$w\\"1, [%2]\\\\n\\" \\"   stxr	%w0, \\"$zreg\\", [%2]\\\\n\\" \\"   cbnz	%w0, 1b\\\\n\\" : \\"=&r\\" ( &res), \\"=&r\\" ( &ret) : \\"r\\" ( &p) : \\"memory\\" );  &return ( &ret); }  &_ATOMIC_READANDCLEAR_PROTO($t,  &_lse) {  &return ( &atomic_swap_$t &_lse( &p, 0)); }  &_ATOMIC_READANDCLEAR_PROTO($t, ) {  &if ( &_ATOMIC_LSE_SUPPORTED)  &return ( &atomic_readandclear_$t &_lse( &p));  &else  &return ( &atomic_readandclear_$t &_llsc( &p)); });
	    }' unless defined(&_ATOMIC_SWAP_IMPL);
	    eval 'sub _ATOMIC_TEST_OP_PROTO {
	        my($t, $op, $bar, $flav) = @_;
    		eval q( &static  &__inline \'int\'  &atomic_testand$op &_$bar$t$flav( &volatile \'uint\'$t &_t * &p, \'u_int\'  &val));
	    }' unless defined(&_ATOMIC_TEST_OP_PROTO);
	    eval 'sub _ATOMIC_TEST_OP_IMPL {
	        my($t, $w, $op, $llsc_asm_op, $lse_asm_op, $bar, $a) = @_;
    		eval q( &_ATOMIC_TEST_OP_PROTO($t, $op, $bar,  &_llsc) { \'uint\'$t &_t  &mask,  &old,  &tmp; \'int\'  &res;  &mask = ((\'uint\'$t &_t)1) << ( &val & ($t - 1));  &__asm  &__volatile( \\"1: ld\\"$a\\"xr	%\\"$w\\"2, [%3]\\\\n\\" \\"  \\"$llsc_asm_op\\"	%\\"$w\\"0, %\\"$w\\"2, %\\"$w\\"4\\\\n\\" \\"   stxr		%w1, %\\"$w\\"0, [%3]\\\\n\\" \\"   cbnz		%w1, 1b\\\\n\\" : \\"=&r\\" ( &tmp), \\"=&r\\" ( &res), \\"=&r\\" ( &old) : \\"r\\" ( &p), \\"r\\" ( &mask) : \\"memory\\" );  &return (( &old &  &mask) != 0); }  &_ATOMIC_TEST_OP_PROTO($t, $op, $bar,  &_lse) { \'uint\'$t &_t  &mask,  &old;  &mask = ((\'uint\'$t &_t)1) << ( &val & ($t - 1));  &__asm  &__volatile( \\".arch_extension lse\\\\n\\" \\"ld\\"$lse_asm_op$a\\"	%\\"$w\\"2, %\\"$w\\"0, [%1]\\\\n\\" \\".arch_extension nolse\\\\n\\" : \\"=r\\" ( &old) : \\"r\\" ( &p), \\"r\\" ( &mask) : \\"memory\\" );  &return (( &old &  &mask) != 0); }  &_ATOMIC_TEST_OP_PROTO($t, $op, $bar, ) {  &if ( &_ATOMIC_LSE_SUPPORTED)  &return ( &atomic_testand$op &_$bar$t &_lse( &p,  &val));  &else  &return ( &atomic_testand$op &_$bar$t &_llsc( &p,  &val)); });
	    }' unless defined(&_ATOMIC_TEST_OP_IMPL);
	    eval 'sub _ATOMIC_TEST_OP {
	        my($op, $llsc_asm_op, $lse_asm_op) = @_;
    		eval q( &_ATOMIC_TEST_OP_IMPL(32,  &w, $op, $llsc_asm_op, $lse_asm_op, , )  &_ATOMIC_TEST_OP_IMPL(32,  &w, $op, $llsc_asm_op, $lse_asm_op,  &acq_,  &a)  &_ATOMIC_TEST_OP_IMPL(64, , $op, $llsc_asm_op, $lse_asm_op, , )  &_ATOMIC_TEST_OP_IMPL(64, , $op, $llsc_asm_op, $lse_asm_op,  &acq_,  &a));
	    }' unless defined(&_ATOMIC_TEST_OP);
	    eval 'sub _ATOMIC_LOAD_ACQ_IMPL {
	        my($t, $w, $s) = @_;
    		eval q( &static  &__inline \'uint\'$t &_t  &atomic_load_acq_$t( &volatile \'uint\'$t &_t * &p) { \'uint\'$t &_t  &ret;  &__asm  &__volatile( \\"ldar\\"$s\\"	%\\"$w\\"0, [%1]\\\\n\\" : \\"=&r\\" ( &ret) : \\"r\\" ( &p) : \\"memory\\");  &return ( &ret); });
	    }' unless defined(&_ATOMIC_LOAD_ACQ_IMPL);
	    eval 'sub _ATOMIC_STORE_REL_IMPL {
	        my($t, $w, $s) = @_;
    		eval q( &static  &__inline  &void  &atomic_store_rel_$t( &volatile \'uint\'$t &_t * &p, \'uint\'$t &_t  &val) {  &__asm  &__volatile( \\"stlr\\"$s\\"	%\\"$w\\"0, [%1]\\\\n\\" : : \\"r\\" ( &val), \\"r\\" ( &p) : \\"memory\\"); });
	    }' unless defined(&_ATOMIC_STORE_REL_IMPL);
	    eval 'sub atomic_add_char () { &atomic_add_8;}' unless defined(&atomic_add_char);
	    eval 'sub atomic_fcmpset_char () { &atomic_fcmpset_8;}' unless defined(&atomic_fcmpset_char);
	    eval 'sub atomic_clear_char () { &atomic_clear_8;}' unless defined(&atomic_clear_char);
	    eval 'sub atomic_cmpset_char () { &atomic_cmpset_8;}' unless defined(&atomic_cmpset_char);
	    eval 'sub atomic_fetchadd_char () { &atomic_fetchadd_8;}' unless defined(&atomic_fetchadd_char);
	    eval 'sub atomic_readandclear_char () { &atomic_readandclear_8;}' unless defined(&atomic_readandclear_char);
	    eval 'sub atomic_set_char () { &atomic_set_8;}' unless defined(&atomic_set_char);
	    eval 'sub atomic_swap_char () { &atomic_swap_8;}' unless defined(&atomic_swap_char);
	    eval 'sub atomic_subtract_char () { &atomic_subtract_8;}' unless defined(&atomic_subtract_char);
	    eval 'sub atomic_testandclear_char () { &atomic_testandclear_8;}' unless defined(&atomic_testandclear_char);
	    eval 'sub atomic_testandset_char () { &atomic_testandset_8;}' unless defined(&atomic_testandset_char);
	    eval 'sub atomic_add_acq_char () { &atomic_add_acq_8;}' unless defined(&atomic_add_acq_char);
	    eval 'sub atomic_fcmpset_acq_char () { &atomic_fcmpset_acq_8;}' unless defined(&atomic_fcmpset_acq_char);
	    eval 'sub atomic_clear_acq_char () { &atomic_clear_acq_8;}' unless defined(&atomic_clear_acq_char);
	    eval 'sub atomic_cmpset_acq_char () { &atomic_cmpset_acq_8;}' unless defined(&atomic_cmpset_acq_char);
	    eval 'sub atomic_load_acq_char () { &atomic_load_acq_8;}' unless defined(&atomic_load_acq_char);
	    eval 'sub atomic_set_acq_char () { &atomic_set_acq_8;}' unless defined(&atomic_set_acq_char);
	    eval 'sub atomic_subtract_acq_char () { &atomic_subtract_acq_8;}' unless defined(&atomic_subtract_acq_char);
	    eval 'sub atomic_testandset_acq_char () { &atomic_testandset_acq_8;}' unless defined(&atomic_testandset_acq_char);
	    eval 'sub atomic_add_rel_char () { &atomic_add_rel_8;}' unless defined(&atomic_add_rel_char);
	    eval 'sub atomic_fcmpset_rel_char () { &atomic_fcmpset_rel_8;}' unless defined(&atomic_fcmpset_rel_char);
	    eval 'sub atomic_clear_rel_char () { &atomic_clear_rel_8;}' unless defined(&atomic_clear_rel_char);
	    eval 'sub atomic_cmpset_rel_char () { &atomic_cmpset_rel_8;}' unless defined(&atomic_cmpset_rel_char);
	    eval 'sub atomic_set_rel_char () { &atomic_set_rel_8;}' unless defined(&atomic_set_rel_char);
	    eval 'sub atomic_subtract_rel_char () { &atomic_subtract_rel_8;}' unless defined(&atomic_subtract_rel_char);
	    eval 'sub atomic_store_rel_char () { &atomic_store_rel_8;}' unless defined(&atomic_store_rel_char);
	    eval 'sub atomic_add_short () { &atomic_add_16;}' unless defined(&atomic_add_short);
	    eval 'sub atomic_fcmpset_short () { &atomic_fcmpset_16;}' unless defined(&atomic_fcmpset_short);
	    eval 'sub atomic_clear_short () { &atomic_clear_16;}' unless defined(&atomic_clear_short);
	    eval 'sub atomic_cmpset_short () { &atomic_cmpset_16;}' unless defined(&atomic_cmpset_short);
	    eval 'sub atomic_fetchadd_short () { &atomic_fetchadd_16;}' unless defined(&atomic_fetchadd_short);
	    eval 'sub atomic_readandclear_short () { &atomic_readandclear_16;}' unless defined(&atomic_readandclear_short);
	    eval 'sub atomic_set_short () { &atomic_set_16;}' unless defined(&atomic_set_short);
	    eval 'sub atomic_swap_short () { &atomic_swap_16;}' unless defined(&atomic_swap_short);
	    eval 'sub atomic_subtract_short () { &atomic_subtract_16;}' unless defined(&atomic_subtract_short);
	    eval 'sub atomic_testandclear_short () { &atomic_testandclear_16;}' unless defined(&atomic_testandclear_short);
	    eval 'sub atomic_testandset_short () { &atomic_testandset_16;}' unless defined(&atomic_testandset_short);
	    eval 'sub atomic_add_acq_short () { &atomic_add_acq_16;}' unless defined(&atomic_add_acq_short);
	    eval 'sub atomic_fcmpset_acq_short () { &atomic_fcmpset_acq_16;}' unless defined(&atomic_fcmpset_acq_short);
	    eval 'sub atomic_clear_acq_short () { &atomic_clear_acq_16;}' unless defined(&atomic_clear_acq_short);
	    eval 'sub atomic_cmpset_acq_short () { &atomic_cmpset_acq_16;}' unless defined(&atomic_cmpset_acq_short);
	    eval 'sub atomic_load_acq_short () { &atomic_load_acq_16;}' unless defined(&atomic_load_acq_short);
	    eval 'sub atomic_set_acq_short () { &atomic_set_acq_16;}' unless defined(&atomic_set_acq_short);
	    eval 'sub atomic_subtract_acq_short () { &atomic_subtract_acq_16;}' unless defined(&atomic_subtract_acq_short);
	    eval 'sub atomic_testandset_acq_short () { &atomic_testandset_acq_16;}' unless defined(&atomic_testandset_acq_short);
	    eval 'sub atomic_add_rel_short () { &atomic_add_rel_16;}' unless defined(&atomic_add_rel_short);
	    eval 'sub atomic_fcmpset_rel_short () { &atomic_fcmpset_rel_16;}' unless defined(&atomic_fcmpset_rel_short);
	    eval 'sub atomic_clear_rel_short () { &atomic_clear_rel_16;}' unless defined(&atomic_clear_rel_short);
	    eval 'sub atomic_cmpset_rel_short () { &atomic_cmpset_rel_16;}' unless defined(&atomic_cmpset_rel_short);
	    eval 'sub atomic_set_rel_short () { &atomic_set_rel_16;}' unless defined(&atomic_set_rel_short);
	    eval 'sub atomic_subtract_rel_short () { &atomic_subtract_rel_16;}' unless defined(&atomic_subtract_rel_short);
	    eval 'sub atomic_store_rel_short () { &atomic_store_rel_16;}' unless defined(&atomic_store_rel_short);
	    eval 'sub atomic_add_int () { &atomic_add_32;}' unless defined(&atomic_add_int);
	    eval 'sub atomic_fcmpset_int () { &atomic_fcmpset_32;}' unless defined(&atomic_fcmpset_int);
	    eval 'sub atomic_clear_int () { &atomic_clear_32;}' unless defined(&atomic_clear_int);
	    eval 'sub atomic_cmpset_int () { &atomic_cmpset_32;}' unless defined(&atomic_cmpset_int);
	    eval 'sub atomic_fetchadd_int () { &atomic_fetchadd_32;}' unless defined(&atomic_fetchadd_int);
	    eval 'sub atomic_readandclear_int () { &atomic_readandclear_32;}' unless defined(&atomic_readandclear_int);
	    eval 'sub atomic_set_int () { &atomic_set_32;}' unless defined(&atomic_set_int);
	    eval 'sub atomic_swap_int () { &atomic_swap_32;}' unless defined(&atomic_swap_int);
	    eval 'sub atomic_subtract_int () { &atomic_subtract_32;}' unless defined(&atomic_subtract_int);
	    eval 'sub atomic_testandclear_int () { &atomic_testandclear_32;}' unless defined(&atomic_testandclear_int);
	    eval 'sub atomic_testandset_int () { &atomic_testandset_32;}' unless defined(&atomic_testandset_int);
	    eval 'sub atomic_add_acq_int () { &atomic_add_acq_32;}' unless defined(&atomic_add_acq_int);
	    eval 'sub atomic_fcmpset_acq_int () { &atomic_fcmpset_acq_32;}' unless defined(&atomic_fcmpset_acq_int);
	    eval 'sub atomic_clear_acq_int () { &atomic_clear_acq_32;}' unless defined(&atomic_clear_acq_int);
	    eval 'sub atomic_cmpset_acq_int () { &atomic_cmpset_acq_32;}' unless defined(&atomic_cmpset_acq_int);
	    eval 'sub atomic_load_acq_int () { &atomic_load_acq_32;}' unless defined(&atomic_load_acq_int);
	    eval 'sub atomic_set_acq_int () { &atomic_set_acq_32;}' unless defined(&atomic_set_acq_int);
	    eval 'sub atomic_subtract_acq_int () { &atomic_subtract_acq_32;}' unless defined(&atomic_subtract_acq_int);
	    eval 'sub atomic_testandset_acq_int () { &atomic_testandset_acq_32;}' unless defined(&atomic_testandset_acq_int);
	    eval 'sub atomic_add_rel_int () { &atomic_add_rel_32;}' unless defined(&atomic_add_rel_int);
	    eval 'sub atomic_fcmpset_rel_int () { &atomic_fcmpset_rel_32;}' unless defined(&atomic_fcmpset_rel_int);
	    eval 'sub atomic_clear_rel_int () { &atomic_clear_rel_32;}' unless defined(&atomic_clear_rel_int);
	    eval 'sub atomic_cmpset_rel_int () { &atomic_cmpset_rel_32;}' unless defined(&atomic_cmpset_rel_int);
	    eval 'sub atomic_set_rel_int () { &atomic_set_rel_32;}' unless defined(&atomic_set_rel_int);
	    eval 'sub atomic_subtract_rel_int () { &atomic_subtract_rel_32;}' unless defined(&atomic_subtract_rel_int);
	    eval 'sub atomic_store_rel_int () { &atomic_store_rel_32;}' unless defined(&atomic_store_rel_int);
	    eval 'sub atomic_add_long () { &atomic_add_64;}' unless defined(&atomic_add_long);
	    eval 'sub atomic_fcmpset_long () { &atomic_fcmpset_64;}' unless defined(&atomic_fcmpset_long);
	    eval 'sub atomic_clear_long () { &atomic_clear_64;}' unless defined(&atomic_clear_long);
	    eval 'sub atomic_cmpset_long () { &atomic_cmpset_64;}' unless defined(&atomic_cmpset_long);
	    eval 'sub atomic_fetchadd_long () { &atomic_fetchadd_64;}' unless defined(&atomic_fetchadd_long);
	    eval 'sub atomic_readandclear_long () { &atomic_readandclear_64;}' unless defined(&atomic_readandclear_long);
	    eval 'sub atomic_set_long () { &atomic_set_64;}' unless defined(&atomic_set_long);
	    eval 'sub atomic_swap_long () { &atomic_swap_64;}' unless defined(&atomic_swap_long);
	    eval 'sub atomic_subtract_long () { &atomic_subtract_64;}' unless defined(&atomic_subtract_long);
	    eval 'sub atomic_testandclear_long () { &atomic_testandclear_64;}' unless defined(&atomic_testandclear_long);
	    eval 'sub atomic_testandset_long () { &atomic_testandset_64;}' unless defined(&atomic_testandset_long);
	    eval 'sub atomic_add_ptr () { &atomic_add_64;}' unless defined(&atomic_add_ptr);
	    eval 'sub atomic_fcmpset_ptr () { &atomic_fcmpset_64;}' unless defined(&atomic_fcmpset_ptr);
	    eval 'sub atomic_clear_ptr () { &atomic_clear_64;}' unless defined(&atomic_clear_ptr);
	    eval 'sub atomic_cmpset_ptr () { &atomic_cmpset_64;}' unless defined(&atomic_cmpset_ptr);
	    eval 'sub atomic_fetchadd_ptr () { &atomic_fetchadd_64;}' unless defined(&atomic_fetchadd_ptr);
	    eval 'sub atomic_readandclear_ptr () { &atomic_readandclear_64;}' unless defined(&atomic_readandclear_ptr);
	    eval 'sub atomic_set_ptr () { &atomic_set_64;}' unless defined(&atomic_set_ptr);
	    eval 'sub atomic_swap_ptr () { &atomic_swap_64;}' unless defined(&atomic_swap_ptr);
	    eval 'sub atomic_subtract_ptr () { &atomic_subtract_64;}' unless defined(&atomic_subtract_ptr);
	    eval 'sub atomic_add_acq_long () { &atomic_add_acq_64;}' unless defined(&atomic_add_acq_long);
	    eval 'sub atomic_fcmpset_acq_long () { &atomic_fcmpset_acq_64;}' unless defined(&atomic_fcmpset_acq_long);
	    eval 'sub atomic_clear_acq_long () { &atomic_clear_acq_64;}' unless defined(&atomic_clear_acq_long);
	    eval 'sub atomic_cmpset_acq_long () { &atomic_cmpset_acq_64;}' unless defined(&atomic_cmpset_acq_long);
	    eval 'sub atomic_load_acq_long () { &atomic_load_acq_64;}' unless defined(&atomic_load_acq_long);
	    eval 'sub atomic_set_acq_long () { &atomic_set_acq_64;}' unless defined(&atomic_set_acq_long);
	    eval 'sub atomic_subtract_acq_long () { &atomic_subtract_acq_64;}' unless defined(&atomic_subtract_acq_long);
	    eval 'sub atomic_testandset_acq_long () { &atomic_testandset_acq_64;}' unless defined(&atomic_testandset_acq_long);
	    eval 'sub atomic_add_acq_ptr () { &atomic_add_acq_64;}' unless defined(&atomic_add_acq_ptr);
	    eval 'sub atomic_fcmpset_acq_ptr () { &atomic_fcmpset_acq_64;}' unless defined(&atomic_fcmpset_acq_ptr);
	    eval 'sub atomic_clear_acq_ptr () { &atomic_clear_acq_64;}' unless defined(&atomic_clear_acq_ptr);
	    eval 'sub atomic_cmpset_acq_ptr () { &atomic_cmpset_acq_64;}' unless defined(&atomic_cmpset_acq_ptr);
	    eval 'sub atomic_load_acq_ptr () { &atomic_load_acq_64;}' unless defined(&atomic_load_acq_ptr);
	    eval 'sub atomic_set_acq_ptr () { &atomic_set_acq_64;}' unless defined(&atomic_set_acq_ptr);
	    eval 'sub atomic_subtract_acq_ptr () { &atomic_subtract_acq_64;}' unless defined(&atomic_subtract_acq_ptr);
	    eval 'sub atomic_add_rel_long () { &atomic_add_rel_64;}' unless defined(&atomic_add_rel_long);
	    eval 'sub atomic_fcmpset_rel_long () { &atomic_fcmpset_rel_64;}' unless defined(&atomic_fcmpset_rel_long);
	    eval 'sub atomic_clear_rel_long () { &atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_long);
	    eval 'sub atomic_cmpset_rel_long () { &atomic_cmpset_rel_64;}' unless defined(&atomic_cmpset_rel_long);
	    eval 'sub atomic_set_rel_long () { &atomic_set_rel_64;}' unless defined(&atomic_set_rel_long);
	    eval 'sub atomic_subtract_rel_long () { &atomic_subtract_rel_64;}' unless defined(&atomic_subtract_rel_long);
	    eval 'sub atomic_store_rel_long () { &atomic_store_rel_64;}' unless defined(&atomic_store_rel_long);
	    eval 'sub atomic_add_rel_ptr () { &atomic_add_rel_64;}' unless defined(&atomic_add_rel_ptr);
	    eval 'sub atomic_fcmpset_rel_ptr () { &atomic_fcmpset_rel_64;}' unless defined(&atomic_fcmpset_rel_ptr);
	    eval 'sub atomic_clear_rel_ptr () { &atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_ptr);
	    eval 'sub atomic_cmpset_rel_ptr () { &atomic_cmpset_rel_64;}' unless defined(&atomic_cmpset_rel_ptr);
	    eval 'sub atomic_set_rel_ptr () { &atomic_set_rel_64;}' unless defined(&atomic_set_rel_ptr);
	    eval 'sub atomic_subtract_rel_ptr () { &atomic_subtract_rel_64;}' unless defined(&atomic_subtract_rel_ptr);
	    eval 'sub atomic_store_rel_ptr () { &atomic_store_rel_64;}' unless defined(&atomic_store_rel_ptr);
	    eval 'sub atomic_thread_fence_acq {
	        my($void) = @_;
    		eval q({  &dmb( &ld); });
	    }' unless defined(&atomic_thread_fence_acq);
	    eval 'sub atomic_thread_fence_rel {
	        my($void) = @_;
    		eval q({  &dmb( &sy); });
	    }' unless defined(&atomic_thread_fence_rel);
	    eval 'sub atomic_thread_fence_acq_rel {
	        my($void) = @_;
    		eval q({  &dmb( &sy); });
	    }' unless defined(&atomic_thread_fence_acq_rel);
	    eval 'sub atomic_thread_fence_seq_cst {
	        my($void) = @_;
    		eval q({  &dmb( &sy); });
	    }' unless defined(&atomic_thread_fence_seq_cst);
	}
    }
}
1;
