require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__arm__)) {
    require 'arm/cpu.ph';
} else {
    unless(defined(&_MACHINE_CPU_H_)) {
	eval 'sub _MACHINE_CPU_H_ () {1;}' unless defined(&_MACHINE_CPU_H_);
	require 'machine/atomic.ph';
	require 'machine/frame.ph';
	require 'machine/armreg.ph';
	eval 'sub TRAPF_PC {
	    my($tfp) = @_;
    	    eval q((($tfp)-> &tf_elr));
	}' unless defined(&TRAPF_PC);
	eval 'sub TRAPF_USERMODE {
	    my($tfp) = @_;
    	    eval q(((($tfp)-> &tf_spsr &  &PSR_M_MASK) ==  &PSR_M_EL0t));
	}' unless defined(&TRAPF_USERMODE);
	eval 'sub cpu_getstack {
	    my($td) = @_;
    	    eval q((($td)-> ($td_frame->{tf_sp})));
	}' unless defined(&cpu_getstack);
	eval 'sub cpu_setstack {
	    my($td, $sp) = @_;
    	    eval q((($td)-> ($td_frame->{tf_sp}) = ($sp)));
	}' unless defined(&cpu_setstack);
	eval 'sub cpu_spinwait () {
	    eval q( &__asm  &__volatile(\\"yield\\" ::: \\"memory\\"));
	}' unless defined(&cpu_spinwait);
	eval 'sub cpu_lock_delay () {
	    eval q( &DELAY(1));
	}' unless defined(&cpu_lock_delay);
	eval 'sub CPU_AFF0 {
	    my($mpidr) = @_;
    	    eval q(((($mpidr) >> 0) & 0xff));
	}' unless defined(&CPU_AFF0);
	eval 'sub CPU_AFF1 {
	    my($mpidr) = @_;
    	    eval q(((($mpidr) >> 8) & 0xff));
	}' unless defined(&CPU_AFF1);
	eval 'sub CPU_AFF2 {
	    my($mpidr) = @_;
    	    eval q(((($mpidr) >> 16) & 0xff));
	}' unless defined(&CPU_AFF2);
	eval 'sub CPU_AFF3 {
	    my($mpidr) = @_;
    	    eval q(((($mpidr) >> 32) & 0xff));
	}' unless defined(&CPU_AFF3);
	eval 'sub CPU_AFF0_MASK () {0xff;}' unless defined(&CPU_AFF0_MASK);
	eval 'sub CPU_AFF1_MASK () {0xff00;}' unless defined(&CPU_AFF1_MASK);
	eval 'sub CPU_AFF2_MASK () {0xff0000;}' unless defined(&CPU_AFF2_MASK);
	eval 'sub CPU_AFF3_MASK () {0xff00000000;}' unless defined(&CPU_AFF3_MASK);
	eval 'sub CPU_AFF_MASK () {( &CPU_AFF0_MASK |  &CPU_AFF1_MASK |  &CPU_AFF2_MASK|  &CPU_AFF3_MASK);}' unless defined(&CPU_AFF_MASK);
	if(defined(&_KERNEL)) {
	    eval 'sub CPU_IMPL_ARM () {0x41;}' unless defined(&CPU_IMPL_ARM);
	    eval 'sub CPU_IMPL_BROADCOM () {0x42;}' unless defined(&CPU_IMPL_BROADCOM);
	    eval 'sub CPU_IMPL_CAVIUM () {0x43;}' unless defined(&CPU_IMPL_CAVIUM);
	    eval 'sub CPU_IMPL_DEC () {0x44;}' unless defined(&CPU_IMPL_DEC);
	    eval 'sub CPU_IMPL_FUJITSU () {0x46;}' unless defined(&CPU_IMPL_FUJITSU);
	    eval 'sub CPU_IMPL_INFINEON () {0x49;}' unless defined(&CPU_IMPL_INFINEON);
	    eval 'sub CPU_IMPL_FREESCALE () {0x4d;}' unless defined(&CPU_IMPL_FREESCALE);
	    eval 'sub CPU_IMPL_NVIDIA () {0x4e;}' unless defined(&CPU_IMPL_NVIDIA);
	    eval 'sub CPU_IMPL_APM () {0x50;}' unless defined(&CPU_IMPL_APM);
	    eval 'sub CPU_IMPL_QUALCOMM () {0x51;}' unless defined(&CPU_IMPL_QUALCOMM);
	    eval 'sub CPU_IMPL_MARVELL () {0x56;}' unless defined(&CPU_IMPL_MARVELL);
	    eval 'sub CPU_IMPL_APPLE () {0x61;}' unless defined(&CPU_IMPL_APPLE);
	    eval 'sub CPU_IMPL_INTEL () {0x69;}' unless defined(&CPU_IMPL_INTEL);
	    eval 'sub CPU_IMPL_AMPERE () {0xc0;}' unless defined(&CPU_IMPL_AMPERE);
	    eval 'sub CPU_PART_FOUNDATION () {0xd00;}' unless defined(&CPU_PART_FOUNDATION);
	    eval 'sub CPU_PART_CORTEX_A34 () {0xd02;}' unless defined(&CPU_PART_CORTEX_A34);
	    eval 'sub CPU_PART_CORTEX_A53 () {0xd03;}' unless defined(&CPU_PART_CORTEX_A53);
	    eval 'sub CPU_PART_CORTEX_A35 () {0xd04;}' unless defined(&CPU_PART_CORTEX_A35);
	    eval 'sub CPU_PART_CORTEX_A55 () {0xd05;}' unless defined(&CPU_PART_CORTEX_A55);
	    eval 'sub CPU_PART_CORTEX_A65 () {0xd06;}' unless defined(&CPU_PART_CORTEX_A65);
	    eval 'sub CPU_PART_CORTEX_A57 () {0xd07;}' unless defined(&CPU_PART_CORTEX_A57);
	    eval 'sub CPU_PART_CORTEX_A72 () {0xd08;}' unless defined(&CPU_PART_CORTEX_A72);
	    eval 'sub CPU_PART_CORTEX_A73 () {0xd09;}' unless defined(&CPU_PART_CORTEX_A73);
	    eval 'sub CPU_PART_CORTEX_A75 () {0xd0a;}' unless defined(&CPU_PART_CORTEX_A75);
	    eval 'sub CPU_PART_CORTEX_A76 () {0xd0b;}' unless defined(&CPU_PART_CORTEX_A76);
	    eval 'sub CPU_PART_NEOVERSE_N1 () {0xd0c;}' unless defined(&CPU_PART_NEOVERSE_N1);
	    eval 'sub CPU_PART_CORTEX_A77 () {0xd0d;}' unless defined(&CPU_PART_CORTEX_A77);
	    eval 'sub CPU_PART_CORTEX_A76AE () {0xd0e;}' unless defined(&CPU_PART_CORTEX_A76AE);
	    eval 'sub CPU_PART_AEM_V8 () {0xd0f;}' unless defined(&CPU_PART_AEM_V8);
	    eval 'sub CPU_PART_NEOVERSE_V1 () {0xd40;}' unless defined(&CPU_PART_NEOVERSE_V1);
	    eval 'sub CPU_PART_CORTEX_A78 () {0xd41;}' unless defined(&CPU_PART_CORTEX_A78);
	    eval 'sub CPU_PART_CORTEX_A65AE () {0xd43;}' unless defined(&CPU_PART_CORTEX_A65AE);
	    eval 'sub CPU_PART_CORTEX_X1 () {0xd44;}' unless defined(&CPU_PART_CORTEX_X1);
	    eval 'sub CPU_PART_CORTEX_A510 () {0xd46;}' unless defined(&CPU_PART_CORTEX_A510);
	    eval 'sub CPU_PART_CORTEX_A710 () {0xd47;}' unless defined(&CPU_PART_CORTEX_A710);
	    eval 'sub CPU_PART_CORTEX_X2 () {0xd48;}' unless defined(&CPU_PART_CORTEX_X2);
	    eval 'sub CPU_PART_NEOVERSE_N2 () {0xd49;}' unless defined(&CPU_PART_NEOVERSE_N2);
	    eval 'sub CPU_PART_NEOVERSE_E1 () {0xd4a;}' unless defined(&CPU_PART_NEOVERSE_E1);
	    eval 'sub CPU_PART_CORTEX_A78C () {0xd4b;}' unless defined(&CPU_PART_CORTEX_A78C);
	    eval 'sub CPU_PART_CORTEX_X1C () {0xd4c;}' unless defined(&CPU_PART_CORTEX_X1C);
	    eval 'sub CPU_PART_CORTEX_A715 () {0xd4d;}' unless defined(&CPU_PART_CORTEX_A715);
	    eval 'sub CPU_PART_CORTEX_X3 () {0xd4e;}' unless defined(&CPU_PART_CORTEX_X3);
	    eval 'sub CPU_PART_NEOVERSE_V2 () {0xd4f;}' unless defined(&CPU_PART_NEOVERSE_V2);
	    eval 'sub CPU_PART_THUNDERX () {0xa1;}' unless defined(&CPU_PART_THUNDERX);
	    eval 'sub CPU_PART_THUNDERX_81XX () {0xa2;}' unless defined(&CPU_PART_THUNDERX_81XX);
	    eval 'sub CPU_PART_THUNDERX_83XX () {0xa3;}' unless defined(&CPU_PART_THUNDERX_83XX);
	    eval 'sub CPU_PART_THUNDERX2 () {0xaf;}' unless defined(&CPU_PART_THUNDERX2);
	    eval 'sub CPU_REV_THUNDERX_1_0 () {0x;}' unless defined(&CPU_REV_THUNDERX_1_0);
	    eval 'sub CPU_REV_THUNDERX_1_1 () {0x1;}' unless defined(&CPU_REV_THUNDERX_1_1);
	    eval 'sub CPU_REV_THUNDERX2_0 () {0x;}' unless defined(&CPU_REV_THUNDERX2_0);
	    eval 'sub CPU_PART_EMAG8180 () {0x;}' unless defined(&CPU_PART_EMAG8180);
	    eval 'sub CPU_PART_KRYO400_GOLD () {0x804;}' unless defined(&CPU_PART_KRYO400_GOLD);
	    eval 'sub CPU_PART_KRYO400_SILVER () {0x805;}' unless defined(&CPU_PART_KRYO400_SILVER);
	    eval 'sub CPU_PART_M1_ICESTORM () {0x22;}' unless defined(&CPU_PART_M1_ICESTORM);
	    eval 'sub CPU_PART_M1_FIRESTORM () {0x23;}' unless defined(&CPU_PART_M1_FIRESTORM);
	    eval 'sub CPU_PART_M1_ICESTORM_PRO () {0x24;}' unless defined(&CPU_PART_M1_ICESTORM_PRO);
	    eval 'sub CPU_PART_M1_FIRESTORM_PRO () {0x25;}' unless defined(&CPU_PART_M1_FIRESTORM_PRO);
	    eval 'sub CPU_PART_M1_ICESTORM_MAX () {0x28;}' unless defined(&CPU_PART_M1_ICESTORM_MAX);
	    eval 'sub CPU_PART_M1_FIRESTORM_MAX () {0x29;}' unless defined(&CPU_PART_M1_FIRESTORM_MAX);
	    eval 'sub CPU_PART_M2_BLIZZARD () {0x32;}' unless defined(&CPU_PART_M2_BLIZZARD);
	    eval 'sub CPU_PART_M2_AVALANCHE () {0x33;}' unless defined(&CPU_PART_M2_AVALANCHE);
	    eval 'sub CPU_PART_M2_BLIZZARD_PRO () {0x34;}' unless defined(&CPU_PART_M2_BLIZZARD_PRO);
	    eval 'sub CPU_PART_M2_AVALANCHE_PRO () {0x35;}' unless defined(&CPU_PART_M2_AVALANCHE_PRO);
	    eval 'sub CPU_PART_M2_BLIZZARD_MAX () {0x38;}' unless defined(&CPU_PART_M2_BLIZZARD_MAX);
	    eval 'sub CPU_PART_M2_AVALANCHE_MAX () {0x39;}' unless defined(&CPU_PART_M2_AVALANCHE_MAX);
	    eval 'sub CPU_IMPL {
	        my($midr) = @_;
    		eval q(((($midr) >> 24) & 0xff));
	    }' unless defined(&CPU_IMPL);
	    eval 'sub CPU_PART {
	        my($midr) = @_;
    		eval q(((($midr) >> 4) & 0xfff));
	    }' unless defined(&CPU_PART);
	    eval 'sub CPU_VAR {
	        my($midr) = @_;
    		eval q(((($midr) >> 20) & 0xf));
	    }' unless defined(&CPU_VAR);
	    eval 'sub CPU_ARCH {
	        my($midr) = @_;
    		eval q(((($midr) >> 16) & 0xf));
	    }' unless defined(&CPU_ARCH);
	    eval 'sub CPU_REV {
	        my($midr) = @_;
    		eval q(((($midr) >> 0) & 0xf));
	    }' unless defined(&CPU_REV);
	    eval 'sub CPU_IMPL_TO_MIDR {
	        my($val) = @_;
    		eval q(((($val) & 0xff) << 24));
	    }' unless defined(&CPU_IMPL_TO_MIDR);
	    eval 'sub CPU_PART_TO_MIDR {
	        my($val) = @_;
    		eval q(((($val) & 0xfff) << 4));
	    }' unless defined(&CPU_PART_TO_MIDR);
	    eval 'sub CPU_VAR_TO_MIDR {
	        my($val) = @_;
    		eval q(((($val) & 0xf) << 20));
	    }' unless defined(&CPU_VAR_TO_MIDR);
	    eval 'sub CPU_ARCH_TO_MIDR {
	        my($val) = @_;
    		eval q(((($val) & 0xf) << 16));
	    }' unless defined(&CPU_ARCH_TO_MIDR);
	    eval 'sub CPU_REV_TO_MIDR {
	        my($val) = @_;
    		eval q(((($val) & 0xf) << 0));
	    }' unless defined(&CPU_REV_TO_MIDR);
	    eval 'sub CPU_IMPL_MASK () {(0xff << 24);}' unless defined(&CPU_IMPL_MASK);
	    eval 'sub CPU_PART_MASK () {(0xfff << 4);}' unless defined(&CPU_PART_MASK);
	    eval 'sub CPU_VAR_MASK () {(0xf << 20);}' unless defined(&CPU_VAR_MASK);
	    eval 'sub CPU_ARCH_MASK () {(0xf << 16);}' unless defined(&CPU_ARCH_MASK);
	    eval 'sub CPU_REV_MASK () {(0xf << 0);}' unless defined(&CPU_REV_MASK);
	    eval 'sub CPU_ID_RAW {
	        my($impl, $part, $var, $rev) = @_;
    		eval q(( &CPU_IMPL_TO_MIDR(($impl)) |  &CPU_PART_TO_MIDR(($part)) |  &CPU_VAR_TO_MIDR(($var)) |  &CPU_REV_TO_MIDR(($rev))));
	    }' unless defined(&CPU_ID_RAW);
	    eval 'sub CPU_MATCH {
	        my($mask, $impl, $part, $var, $rev) = @_;
    		eval q(((($mask) &  &PCPU_GET( &midr)) == (($mask) &  &CPU_ID_RAW(($impl), ($part), ($var), ($rev)))));
	    }' unless defined(&CPU_MATCH);
	    eval 'sub CPU_MATCH_RAW {
	        my($mask, $devid) = @_;
    		eval q(((($mask) &  &PCPU_GET( &midr)) == (($mask) & ($devid))));
	    }' unless defined(&CPU_MATCH_RAW);
	    if(defined(&THUNDERX_PASS_1_1_ERRATA)) {
		eval 'sub CPU_MATCH_ERRATA_CAVIUM_THUNDERX_1_1 () {( &CPU_MATCH( &CPU_IMPL_MASK |  &CPU_PART_MASK |  &CPU_REV_MASK,  &CPU_IMPL_CAVIUM,  &CPU_PART_THUNDERX, 0,  &CPU_REV_THUNDERX_1_0) ||  &CPU_MATCH( &CPU_IMPL_MASK |  &CPU_PART_MASK |  &CPU_REV_MASK,  &CPU_IMPL_CAVIUM,  &CPU_PART_THUNDERX, 0,  &CPU_REV_THUNDERX_1_1));}' unless defined(&CPU_MATCH_ERRATA_CAVIUM_THUNDERX_1_1);
	    } else {
		eval 'sub CPU_MATCH_ERRATA_CAVIUM_THUNDERX_1_1 () {0;}' unless defined(&CPU_MATCH_ERRATA_CAVIUM_THUNDERX_1_1);
	    }
	    if(defined(&SMP)) {
	    }
	    eval 'sub CPU_AFFINITY {
	        my($cpu) = @_;
    		eval q( $__cpu_affinity[($cpu)]);
	    }' unless defined(&CPU_AFFINITY);
	    eval 'sub CPU_CURRENT_SOCKET () {( &CPU_AFF2( &CPU_AFFINITY( &PCPU_GET( &cpuid))));}' unless defined(&CPU_CURRENT_SOCKET);
	    eval 'sub get_cyclecount {
	        my($void) = @_;
    		eval q({  &uint64_t  &ret;  &ret =  &READ_SPECIALREG( &cntvct_el0); ( &ret); });
	    }' unless defined(&get_cyclecount);
	    eval 'sub ADDRESS_TRANSLATE_FUNC {
	        my($stage) = @_;
    		eval q( &static  &inline  &uint64_t  &arm64_address_translate_ $stage ( &uint64_t  &addr) {  &uint64_t  &ret;  &__asm  &__volatile( \\"at \\"  &__STRING($stage) \\", %1 \\\\n\\" \\"isb \\\\n\\" \\"mrs %0, par_el1\\" : \\"=r\\"( &ret) : \\"r\\"( &addr));  &return ( &ret); });
	    }' unless defined(&ADDRESS_TRANSLATE_FUNC);
	}
    }
}
1;
