require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__arm__)) {
    require 'arm/cpufunc.ph';
} else {
    unless(defined(&_MACHINE_CPUFUNC_H_)) {
	eval 'sub _MACHINE_CPUFUNC_H_ () {1;}' unless defined(&_MACHINE_CPUFUNC_H_);
	eval 'sub breakpoint {
	    my($void) = @_;
    	    eval q({  &__asm(\\"brk #0\\"); });
	}' unless defined(&breakpoint);
	if(defined(&_KERNEL)) {
	    require 'machine/armreg.ph';
	    eval 'sub dbg_disable {
	        my($void) = @_;
    		eval q({  &uint32_t  &ret;  &__asm  &__volatile( \\"mrs %x0, daif   \\\\n\\" \\"msr daifset, #(\\"  &__XSTRING( &DAIF_D) \\") \\\\n\\" : \\"=&r\\" ( &ret)); ( &ret); });
	    }' unless defined(&dbg_disable);
	    eval 'sub dbg_enable {
	        my($void) = @_;
    		eval q({  &__asm  &__volatile(\\"msr daifclr, #(\\"  &__XSTRING( &DAIF_D) \\")\\"); });
	    }' unless defined(&dbg_enable);
	    eval 'sub intr_disable {
	        my($void) = @_;
    		eval q({  &uint32_t  &ret;  &__asm  &__volatile( \\"mrs %x0, daif   \\\\n\\" \\"msr daifset, #(\\"  &__XSTRING( &DAIF_INTR) \\") \\\\n\\" : \\"=&r\\" ( &ret)); ( &ret); });
	    }' unless defined(&intr_disable);
	    eval 'sub intr_restore {
	        my($s) = @_;
    		eval q({  &WRITE_SPECIALREG( &daif, $s); });
	    }' unless defined(&intr_restore);
	    eval 'sub intr_enable {
	        my($void) = @_;
    		eval q({  &__asm  &__volatile(\\"msr daifclr, #(\\"  &__XSTRING( &DAIF_INTR) \\")\\"); });
	    }' unless defined(&intr_enable);
	    eval 'sub serror_enable {
	        my($void) = @_;
    		eval q({  &__asm  &__volatile(\\"msr daifclr, #(\\"  &__XSTRING( &DAIF_A) \\")\\"); });
	    }' unless defined(&serror_enable);
	    eval 'sub get_midr {
	        my($void) = @_;
    		eval q({  &uint64_t  &midr;  &midr =  &READ_SPECIALREG( &midr_el1); ( &midr); });
	    }' unless defined(&get_midr);
	    eval 'sub get_mpidr {
	        my($void) = @_;
    		eval q({  &uint64_t  &mpidr;  &mpidr =  &READ_SPECIALREG( &mpidr_el1); ( &mpidr); });
	    }' unless defined(&get_mpidr);
	    eval 'sub clrex {
	        my($void) = @_;
    		eval q({  &__asm  &__volatile(\\"clrex\\" : : : \\"memory\\"); });
	    }' unless defined(&clrex);
	    eval 'sub set_ttbr0 {
	        my($ttbr0) = @_;
    		eval q({  &__asm  &__volatile( \\"msr ttbr0_el1, %0 \\\\n\\" \\"isb	       \\\\n\\" : : \\"r\\" ($ttbr0)); });
	    }' unless defined(&set_ttbr0);
	    eval 'sub invalidate_icache {
	        my($void) = @_;
    		eval q({  &__asm  &__volatile( \\"ic ialluis	\\\\n\\" \\"dsb ish	   \\\\n\\" \\"isb	       \\\\n\\"); });
	    }' unless defined(&invalidate_icache);
	    eval 'sub invalidate_local_icache {
	        my($void) = @_;
    		eval q({  &__asm  &__volatile( \\"ic iallu	  \\\\n\\" \\"dsb nsh	   \\\\n\\" \\"isb	       \\\\n\\"); });
	    }' unless defined(&invalidate_local_icache);
	    eval 'sub cpu_nullop () {
	        eval q( &arm64_nullop());
	    }' unless defined(&cpu_nullop);
	    eval 'sub cpufunc_nullop () {
	        eval q( &arm64_nullop());
	    }' unless defined(&cpufunc_nullop);
	    eval 'sub cpu_tlb_flushID () {
	        eval q( &arm64_tlb_flushID());
	    }' unless defined(&cpu_tlb_flushID);
	    eval 'sub cpu_dcache_wbinv_range {
	        my($a, $s) = @_;
    		eval q( &arm64_dcache_wbinv_range(($a), ($s)));
	    }' unless defined(&cpu_dcache_wbinv_range);
	    eval 'sub cpu_dcache_inv_range {
	        my($a, $s) = @_;
    		eval q( &arm64_dcache_inv_range(($a), ($s)));
	    }' unless defined(&cpu_dcache_inv_range);
	    eval 'sub cpu_dcache_wb_range {
	        my($a, $s) = @_;
    		eval q( &arm64_dcache_wb_range(($a), ($s)));
	    }' unless defined(&cpu_dcache_wb_range);
	    eval 'sub cpu_icache_sync_range {
	        my($a, $s) = @_;
    		eval q( &arm64_icache_sync_range(($a), ($s)));
	    }' unless defined(&cpu_icache_sync_range);
	    eval 'sub cpu_icache_sync_range_checked {
	        my($a, $s) = @_;
    		eval q( &arm64_icache_sync_range_checked(($a), ($s)));
	    }' unless defined(&cpu_icache_sync_range_checked);
	}
    }
}
1;
