require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__arm__)) {
    require 'arm/elf.ph';
} else {
    unless(defined(&_MACHINE_ELF_H_)) {
	eval 'sub _MACHINE_ELF_H_ () {1;}' unless defined(&_MACHINE_ELF_H_);
	require 'sys/elf32.ph';
	require 'sys/elf64.ph';
	unless(defined(&__ELF_WORD_SIZE)) {
	    eval 'sub __ELF_WORD_SIZE () {64;}' unless defined(&__ELF_WORD_SIZE);
	}
	require 'sys/elf_generic.ph';
	if(defined(&_MACHINE_ELF_WANT_32BIT)) {
	    eval 'sub ELF_ARCH () { &EM_ARM;}' unless defined(&ELF_ARCH);
	} else {
	    eval 'sub ELF_ARCH () { &EM_AARCH64;}' unless defined(&ELF_ARCH);
	}
	eval 'sub ELF_MACHINE_OK {
	    my($x) = @_;
    	    eval q((($x) == ( &ELF_ARCH)));
	}' unless defined(&ELF_MACHINE_OK);
	if((defined(&__ELF_WORD_SIZE) ? &__ELF_WORD_SIZE : undef) == 64) {
	    eval 'sub ELF_TARG_CLASS () { &ELFCLASS64;}' unless defined(&ELF_TARG_CLASS);
	    eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
	    eval 'sub ELF_TARG_MACH () { &EM_AARCH64;}' unless defined(&ELF_TARG_MACH);
	    eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
	} else {
	    eval 'sub ELF_TARG_CLASS () { &ELFCLASS32;}' unless defined(&ELF_TARG_CLASS);
	    eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
	    eval 'sub ELF_TARG_MACH () { &EM_ARM;}' unless defined(&ELF_TARG_MACH);
	    eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
	}
	if((defined(&__ELF_WORD_SIZE) ? &__ELF_WORD_SIZE : undef) == 32) {
	    eval 'sub ET_DYN_LOAD_ADDR () {0x1001000;}' unless defined(&ET_DYN_LOAD_ADDR);
	} else {
	    eval 'sub ET_DYN_LOAD_ADDR () {0x100000;}' unless defined(&ET_DYN_LOAD_ADDR);
	}
	eval 'sub HWCAP_FP () {0x1;}' unless defined(&HWCAP_FP);
	eval 'sub HWCAP_ASIMD () {0x2;}' unless defined(&HWCAP_ASIMD);
	eval 'sub HWCAP_EVTSTRM () {0x4;}' unless defined(&HWCAP_EVTSTRM);
	eval 'sub HWCAP_AES () {0x8;}' unless defined(&HWCAP_AES);
	eval 'sub HWCAP_PMULL () {0x10;}' unless defined(&HWCAP_PMULL);
	eval 'sub HWCAP_SHA1 () {0x20;}' unless defined(&HWCAP_SHA1);
	eval 'sub HWCAP_SHA2 () {0x40;}' unless defined(&HWCAP_SHA2);
	eval 'sub HWCAP_CRC32 () {0x80;}' unless defined(&HWCAP_CRC32);
	eval 'sub HWCAP_ATOMICS () {0x100;}' unless defined(&HWCAP_ATOMICS);
	eval 'sub HWCAP_FPHP () {0x200;}' unless defined(&HWCAP_FPHP);
	eval 'sub HWCAP_ASIMDHP () {0x400;}' unless defined(&HWCAP_ASIMDHP);
	eval 'sub HWCAP_CPUID () {0x800;}' unless defined(&HWCAP_CPUID);
	eval 'sub HWCAP_ASIMDRDM () {0x1000;}' unless defined(&HWCAP_ASIMDRDM);
	eval 'sub HWCAP_JSCVT () {0x2000;}' unless defined(&HWCAP_JSCVT);
	eval 'sub HWCAP_FCMA () {0x4000;}' unless defined(&HWCAP_FCMA);
	eval 'sub HWCAP_LRCPC () {0x8000;}' unless defined(&HWCAP_LRCPC);
	eval 'sub HWCAP_DCPOP () {0x10000;}' unless defined(&HWCAP_DCPOP);
	eval 'sub HWCAP_SHA3 () {0x20000;}' unless defined(&HWCAP_SHA3);
	eval 'sub HWCAP_SM3 () {0x40000;}' unless defined(&HWCAP_SM3);
	eval 'sub HWCAP_SM4 () {0x80000;}' unless defined(&HWCAP_SM4);
	eval 'sub HWCAP_ASIMDDP () {0x100000;}' unless defined(&HWCAP_ASIMDDP);
	eval 'sub HWCAP_SHA512 () {0x200000;}' unless defined(&HWCAP_SHA512);
	eval 'sub HWCAP_SVE () {0x400000;}' unless defined(&HWCAP_SVE);
	eval 'sub HWCAP_ASIMDFHM () {0x800000;}' unless defined(&HWCAP_ASIMDFHM);
	eval 'sub HWCAP_DIT () {0x1000000;}' unless defined(&HWCAP_DIT);
	eval 'sub HWCAP_USCAT () {0x2000000;}' unless defined(&HWCAP_USCAT);
	eval 'sub HWCAP_ILRCPC () {0x4000000;}' unless defined(&HWCAP_ILRCPC);
	eval 'sub HWCAP_FLAGM () {0x8000000;}' unless defined(&HWCAP_FLAGM);
	eval 'sub HWCAP_SSBS () {0x10000000;}' unless defined(&HWCAP_SSBS);
	eval 'sub HWCAP_SB () {0x20000000;}' unless defined(&HWCAP_SB);
	eval 'sub HWCAP_PACA () {0x40000000;}' unless defined(&HWCAP_PACA);
	eval 'sub HWCAP_PACG () {0x80000000;}' unless defined(&HWCAP_PACG);
	eval 'sub HWCAP2_DCPODP () {0x1;}' unless defined(&HWCAP2_DCPODP);
	eval 'sub HWCAP2_SVE2 () {0x2;}' unless defined(&HWCAP2_SVE2);
	eval 'sub HWCAP2_SVEAES () {0x4;}' unless defined(&HWCAP2_SVEAES);
	eval 'sub HWCAP2_SVEPMULL () {0x8;}' unless defined(&HWCAP2_SVEPMULL);
	eval 'sub HWCAP2_SVEBITPERM () {0x10;}' unless defined(&HWCAP2_SVEBITPERM);
	eval 'sub HWCAP2_SVESHA3 () {0x20;}' unless defined(&HWCAP2_SVESHA3);
	eval 'sub HWCAP2_SVESM4 () {0x40;}' unless defined(&HWCAP2_SVESM4);
	eval 'sub HWCAP2_FLAGM2 () {0x80;}' unless defined(&HWCAP2_FLAGM2);
	eval 'sub HWCAP2_FRINT () {0x100;}' unless defined(&HWCAP2_FRINT);
	eval 'sub HWCAP2_SVEI8MM () {0x200;}' unless defined(&HWCAP2_SVEI8MM);
	eval 'sub HWCAP2_SVEF32MM () {0x400;}' unless defined(&HWCAP2_SVEF32MM);
	eval 'sub HWCAP2_SVEF64MM () {0x800;}' unless defined(&HWCAP2_SVEF64MM);
	eval 'sub HWCAP2_SVEBF16 () {0x1000;}' unless defined(&HWCAP2_SVEBF16);
	eval 'sub HWCAP2_I8MM () {0x2000;}' unless defined(&HWCAP2_I8MM);
	eval 'sub HWCAP2_BF16 () {0x4000;}' unless defined(&HWCAP2_BF16);
	eval 'sub HWCAP2_DGH () {0x8000;}' unless defined(&HWCAP2_DGH);
	eval 'sub HWCAP2_RNG () {0x10000;}' unless defined(&HWCAP2_RNG);
	eval 'sub HWCAP2_BTI () {0x20000;}' unless defined(&HWCAP2_BTI);
	eval 'sub HWCAP2_MTE () {0x40000;}' unless defined(&HWCAP2_MTE);
	eval 'sub HWCAP2_ECV () {0x80000;}' unless defined(&HWCAP2_ECV);
	eval 'sub HWCAP2_AFP () {0x100000;}' unless defined(&HWCAP2_AFP);
	eval 'sub HWCAP2_RPRES () {0x200000;}' unless defined(&HWCAP2_RPRES);
	eval 'sub HWCAP2_MTE3 () {0x400000;}' unless defined(&HWCAP2_MTE3);
	eval 'sub HWCAP2_SME () {0x800000;}' unless defined(&HWCAP2_SME);
	eval 'sub HWCAP2_SME_I16I64 () {0x1000000;}' unless defined(&HWCAP2_SME_I16I64);
	eval 'sub HWCAP2_SME_F64F64 () {0x2000000;}' unless defined(&HWCAP2_SME_F64F64);
	eval 'sub HWCAP2_SME_I8I32 () {0x4000000;}' unless defined(&HWCAP2_SME_I8I32);
	eval 'sub HWCAP2_SME_F16F32 () {0x8000000;}' unless defined(&HWCAP2_SME_F16F32);
	eval 'sub HWCAP2_SME_B16F32 () {0x10000000;}' unless defined(&HWCAP2_SME_B16F32);
	eval 'sub HWCAP2_SME_F32F32 () {0x20000000;}' unless defined(&HWCAP2_SME_F32F32);
	eval 'sub HWCAP2_SME_FA64 () {0x40000000;}' unless defined(&HWCAP2_SME_FA64);
	eval 'sub HWCAP2_WFXT () {0x80000000;}' unless defined(&HWCAP2_WFXT);
	eval 'sub HWCAP2_EBF16 () {0x100000000;}' unless defined(&HWCAP2_EBF16);
	eval 'sub HWCAP2_SVE_EBF16 () {0x200000000;}' unless defined(&HWCAP2_SVE_EBF16);
	eval 'sub HWCAP2_CSSC () {0x400000000;}' unless defined(&HWCAP2_CSSC);
	eval 'sub HWCAP2_RPRFM () {0x800000000;}' unless defined(&HWCAP2_RPRFM);
	eval 'sub HWCAP2_SVE2P1 () {0x1000000000;}' unless defined(&HWCAP2_SVE2P1);
	eval 'sub HWCAP2_SME2 () {0x2000000000;}' unless defined(&HWCAP2_SME2);
	eval 'sub HWCAP2_SME2P1 () {0x4000000000;}' unless defined(&HWCAP2_SME2P1);
	eval 'sub HWCAP2_SME_I16I32 () {0x8000000000;}' unless defined(&HWCAP2_SME_I16I32);
	eval 'sub HWCAP2_SME_BI32I32 () {0x10000000000;}' unless defined(&HWCAP2_SME_BI32I32);
	eval 'sub HWCAP2_SME_B16B16 () {0x20000000000;}' unless defined(&HWCAP2_SME_B16B16);
	eval 'sub HWCAP2_SME_F16F16 () {0x40000000000;}' unless defined(&HWCAP2_SME_F16F16);
	eval 'sub HWCAP2_MOPS () {0x80000000000;}' unless defined(&HWCAP2_MOPS);
	eval 'sub HWCAP2_HBC () {0x100000000000;}' unless defined(&HWCAP2_HBC);
	if(defined(&COMPAT_FREEBSD32)) {
	    eval 'sub HWCAP32_HALF () {0x2;}' unless defined(&HWCAP32_HALF);
	    eval 'sub HWCAP32_THUMB () {0x4;}' unless defined(&HWCAP32_THUMB);
	    eval 'sub HWCAP32_FAST_MULT () {0x10;}' unless defined(&HWCAP32_FAST_MULT);
	    eval 'sub HWCAP32_VFP () {0x40;}' unless defined(&HWCAP32_VFP);
	    eval 'sub HWCAP32_EDSP () {0x80;}' unless defined(&HWCAP32_EDSP);
	    eval 'sub HWCAP32_NEON () {0x1000;}' unless defined(&HWCAP32_NEON);
	    eval 'sub HWCAP32_VFPv3 () {0x2000;}' unless defined(&HWCAP32_VFPv3);
	    eval 'sub HWCAP32_TLS () {0x8000;}' unless defined(&HWCAP32_TLS);
	    eval 'sub HWCAP32_VFPv4 () {0x10000;}' unless defined(&HWCAP32_VFPv4);
	    eval 'sub HWCAP32_IDIVA () {0x20000;}' unless defined(&HWCAP32_IDIVA);
	    eval 'sub HWCAP32_IDIVT () {0x40000;}' unless defined(&HWCAP32_IDIVT);
	    eval 'sub HWCAP32_VFPD32 () {0x80000;}' unless defined(&HWCAP32_VFPD32);
	    eval 'sub HWCAP32_LPAE () {0x100000;}' unless defined(&HWCAP32_LPAE);
	    eval 'sub HWCAP32_DEFAULT () {( &HWCAP32_HALF |  &HWCAP32_THUMB |  &HWCAP32_FAST_MULT |  &HWCAP32_EDSP |  &HWCAP32_TLS |  &HWCAP32_IDIVA |  &HWCAP32_IDIVT |  &HWCAP32_VFPD32 |  &HWCAP32_LPAE);}' unless defined(&HWCAP32_DEFAULT);
	    eval 'sub HWCAP32_2_AES () {0x1;}' unless defined(&HWCAP32_2_AES);
	    eval 'sub HWCAP32_2_PMULL () {0x2;}' unless defined(&HWCAP32_2_PMULL);
	    eval 'sub HWCAP32_2_SHA1 () {0x4;}' unless defined(&HWCAP32_2_SHA1);
	    eval 'sub HWCAP32_2_SHA2 () {0x8;}' unless defined(&HWCAP32_2_SHA2);
	    eval 'sub HWCAP32_2_CRC32 () {0x10;}' unless defined(&HWCAP32_2_CRC32);
	}
    }
}
1;
