require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__arm__)) {
    require 'arm/pcpu.ph';
} else {
    unless(defined(&_MACHINE_PCPU_H_)) {
	eval 'sub _MACHINE_PCPU_H_ () {1;}' unless defined(&_MACHINE_PCPU_H_);
	require 'machine/cpu.ph';
	require 'machine/cpufunc.ph';
	eval 'sub PCPU_MD_FIELDS () {\'u_int\'  &pc_acpi_id; \'u_int\'  &pc_midr;  &uint64_t  &pc_clock;  &pcpu_bp_harden  &pc_bp_harden;  &pcpu_ssbd  &pc_ssbd; \'struct pmap\' * &pc_curpmap; \'struct pmap\' * &pc_curvmpmap;  &uint64_t  &pc_mpidr; \'u_int\'  &pc_bcast_tlbi_workaround; \'char\'  $__pad[197];}' unless defined(&PCPU_MD_FIELDS);
	if(defined(&_KERNEL)) {
	    eval 'sub get_pcpu {
	        my($void) = @_;
    		eval q({ \'struct pcpu\' * &pcpu;  &__asm  &__volatile(\\"mov   %0, x18\\" : \\"=&r\\"( &pcpu)); ( &pcpu); });
	    }' unless defined(&get_pcpu);
	    eval 'sub get_curthread {
	        my($void) = @_;
    		eval q({ \'struct thread\' * &td;  &__asm  &__volatile(\\"ldr	%0, [x18]\\" : \\"=&r\\"( &td)); ( &td); });
	    }' unless defined(&get_curthread);
	    eval 'sub curthread () { &get_curthread();}' unless defined(&curthread);
	    eval 'sub PCPU_GET {
	        my($member) = @_;
    		eval q(( ($pcpup->{pc_})  $member));
	    }' unless defined(&PCPU_GET);
	    eval 'sub PCPU_ADD {
	        my($member, $value) = @_;
    		eval q(( ($pcpup->{pc_})  $member += ($value)));
	    }' unless defined(&PCPU_ADD);
	    eval 'sub PCPU_PTR {
	        my($member) = @_;
    		eval q(( ($pcpup->{pc_})  $member));
	    }' unless defined(&PCPU_PTR);
	    eval 'sub PCPU_SET {
	        my($member,$value) = @_;
    		eval q(( ($pcpup->{pc_})  $member = ($value)));
	    }' unless defined(&PCPU_SET);
	    eval 'sub PCPU_GET_MPIDR {
	        my($pc) = @_;
    		eval q((($pc)-> &pc_mpidr));
	    }' unless defined(&PCPU_GET_MPIDR);
	}
    }
}
1;
