require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__arm__)) {
    require 'arm/vfp.ph';
} else {
    unless(defined(&_MACHINE_VFP_H_)) {
	eval 'sub _MACHINE_VFP_H_ () {1;}' unless defined(&_MACHINE_VFP_H_);
	eval 'sub VFPCR_AHP () {(0x4000000);}' unless defined(&VFPCR_AHP);
	eval 'sub VFPCR_DN () {(0x2000000);}' unless defined(&VFPCR_DN);
	eval 'sub VFPCR_FZ () {(0x1000000);}' unless defined(&VFPCR_FZ);
	eval 'sub VFPCR_INIT () {0;}' unless defined(&VFPCR_INIT);
	eval 'sub VFPCR_RMODE_OFF () {22;}' unless defined(&VFPCR_RMODE_OFF);
	eval 'sub VFPCR_RMODE_MASK () {(0xc00000);}' unless defined(&VFPCR_RMODE_MASK);
	eval 'sub VFPCR_RMODE_RN () {(0x);}' unless defined(&VFPCR_RMODE_RN);
	eval 'sub VFPCR_RMODE_RPI () {(0x400000);}' unless defined(&VFPCR_RMODE_RPI);
	eval 'sub VFPCR_RMODE_RNI () {(0x800000);}' unless defined(&VFPCR_RMODE_RNI);
	eval 'sub VFPCR_RMODE_RM () {(0xc00000);}' unless defined(&VFPCR_RMODE_RM);
	eval 'sub VFPCR_STRIDE_OFF () {20;}' unless defined(&VFPCR_STRIDE_OFF);
	eval 'sub VFPCR_STRIDE_MASK () {(0x300000);}' unless defined(&VFPCR_STRIDE_MASK);
	eval 'sub VFPCR_LEN_OFF () {16;}' unless defined(&VFPCR_LEN_OFF);
	eval 'sub VFPCR_LEN_MASK () {(0x70000);}' unless defined(&VFPCR_LEN_MASK);
	eval 'sub VFPCR_IDE () {(0x8000);}' unless defined(&VFPCR_IDE);
	eval 'sub VFPCR_IXE () {(0x1000);}' unless defined(&VFPCR_IXE);
	eval 'sub VFPCR_UFE () {(0x800);}' unless defined(&VFPCR_UFE);
	eval 'sub VFPCR_OFE () {(0x400);}' unless defined(&VFPCR_OFE);
	eval 'sub VFPCR_DZE () {(0x200);}' unless defined(&VFPCR_DZE);
	eval 'sub VFPCR_IOE () {(0x100);}' unless defined(&VFPCR_IOE);
	unless(defined(&LOCORE)) {
	    if(defined(&_KERNEL)) {
		eval 'sub FPU_KERN_NORMAL () {0x;}' unless defined(&FPU_KERN_NORMAL);
		eval 'sub FPU_KERN_NOWAIT () {0x1;}' unless defined(&FPU_KERN_NOWAIT);
		eval 'sub FPU_KERN_KTHR () {0x2;}' unless defined(&FPU_KERN_KTHR);
		eval 'sub FPU_KERN_NOCTX () {0x4;}' unless defined(&FPU_KERN_NOCTX);
		eval 'sub VFP_FPSCR_FROM_SRCR {
		    my($vpsr, $vpcr) = @_;
    		    eval q((($vpsr) | (($vpcr) & 0x7c00000)));
		}' unless defined(&VFP_FPSCR_FROM_SRCR);
		eval 'sub VFP_FPSR_FROM_FPSCR {
		    my($vpscr) = @_;
    		    eval q((($vpscr) &~ 0x7c00000));
		}' unless defined(&VFP_FPSR_FROM_FPSCR);
		eval 'sub VFP_FPCR_FROM_FPSCR {
		    my($vpsrc) = @_;
    		    eval q((($vpsrc) & 0x7c00000));
		}' unless defined(&VFP_FPCR_FROM_FPSCR);
		if(defined(&COMPAT_FREEBSD32)) {
		}
	    }
	}
    }
}
1;
