require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__arm__)) {
    require 'arm/armreg.ph';
} else {
    unless(defined(&_MACHINE_ARMREG_H_)) {
	eval 'sub _MACHINE_ARMREG_H_ () {1;}' unless defined(&_MACHINE_ARMREG_H_);
	eval 'sub INSN_SIZE () {4;}' unless defined(&INSN_SIZE);
	eval 'sub MRS_MASK () {0xfff00000;}' unless defined(&MRS_MASK);
	eval 'sub MRS_VALUE () {0xd5300000;}' unless defined(&MRS_VALUE);
	eval 'sub MRS_SPECIAL {
	    my($insn) = @_;
    	    eval q((($insn) & 0xfffe0));
	}' unless defined(&MRS_SPECIAL);
	eval 'sub MRS_REGISTER {
	    my($insn) = @_;
    	    eval q((($insn) & 0x1f));
	}' unless defined(&MRS_REGISTER);
	eval 'sub MRS_Op0_SHIFT () {19;}' unless defined(&MRS_Op0_SHIFT);
	eval 'sub MRS_Op0_MASK () {0x80000;}' unless defined(&MRS_Op0_MASK);
	eval 'sub MRS_Op1_SHIFT () {16;}' unless defined(&MRS_Op1_SHIFT);
	eval 'sub MRS_Op1_MASK () {0x70000;}' unless defined(&MRS_Op1_MASK);
	eval 'sub MRS_CRn_SHIFT () {12;}' unless defined(&MRS_CRn_SHIFT);
	eval 'sub MRS_CRn_MASK () {0xf000;}' unless defined(&MRS_CRn_MASK);
	eval 'sub MRS_CRm_SHIFT () {8;}' unless defined(&MRS_CRm_SHIFT);
	eval 'sub MRS_CRm_MASK () {0xf00;}' unless defined(&MRS_CRm_MASK);
	eval 'sub MRS_Op2_SHIFT () {5;}' unless defined(&MRS_Op2_SHIFT);
	eval 'sub MRS_Op2_MASK () {0xe0;}' unless defined(&MRS_Op2_MASK);
	eval 'sub MRS_Rt_SHIFT () {0;}' unless defined(&MRS_Rt_SHIFT);
	eval 'sub MRS_Rt_MASK () {0x1f;}' unless defined(&MRS_Rt_MASK);
	eval 'sub __MRS_REG {
	    my($op0, $op1, $crn, $crm, $op2) = @_;
    	    eval q(((($op0) <<  &MRS_Op0_SHIFT) | (($op1) <<  &MRS_Op1_SHIFT) | (($crn) <<  &MRS_CRn_SHIFT) | (($crm) <<  &MRS_CRm_SHIFT) | (($op2) <<  &MRS_Op2_SHIFT)));
	}' unless defined(&__MRS_REG);
	eval 'sub MRS_REG {
	    my($reg) = @_;
    	    eval q( &__MRS_REG($reg &_op0, $reg &_op1, $reg &_CRn, $reg &_CRm, $reg &_op2));
	}' unless defined(&MRS_REG);
	eval 'sub __MRS_REG_ALT_NAME {
	    my($op0, $op1, $crn, $crm, $op2) = @_;
    	    eval q( &S$op0 &_$op1 &_C$crn &_C$crm &_$op2);
	}' unless defined(&__MRS_REG_ALT_NAME);
	eval 'sub _MRS_REG_ALT_NAME {
	    my($op0, $op1, $crn, $crm, $op2) = @_;
    	    eval q( &__MRS_REG_ALT_NAME($op0, $op1, $crn, $crm, $op2));
	}' unless defined(&_MRS_REG_ALT_NAME);
	eval 'sub MRS_REG_ALT_NAME {
	    my($reg) = @_;
    	    eval q( &_MRS_REG_ALT_NAME($reg &_op0, $reg &_op1, $reg &_CRn, $reg &_CRm, $reg &_op2));
	}' unless defined(&MRS_REG_ALT_NAME);
	eval 'sub READ_SPECIALREG {
	    my($reg) = @_;
    	    eval q(({  &uint64_t  &_val;  &__asm  &__volatile(\\"mrs	%0, \\"  &__STRING($reg) : \\"=&r\\" ( &_val));  &_val; }));
	}' unless defined(&READ_SPECIALREG);
	eval 'sub WRITE_SPECIALREG {
	    my($reg, $_val) = @_;
    	    eval q( &__asm  &__volatile(\\"msr	\\"  &__STRING($reg) \\", %0\\" : : \\"r\\"(( &uint64_t)$_val)));
	}' unless defined(&WRITE_SPECIALREG);
	eval 'sub UL {
	    my($x) = @_;
    	    eval q( &UINT64_C($x));
	}' unless defined(&UL);
	eval 'sub CCSIDR_NumSets_MASK () {0xfffe000;}' unless defined(&CCSIDR_NumSets_MASK);
	eval 'sub CCSIDR_NumSets64_MASK () {0xffffff00000000;}' unless defined(&CCSIDR_NumSets64_MASK);
	eval 'sub CCSIDR_NumSets_SHIFT () {13;}' unless defined(&CCSIDR_NumSets_SHIFT);
	eval 'sub CCSIDR_NumSets64_SHIFT () {32;}' unless defined(&CCSIDR_NumSets64_SHIFT);
	eval 'sub CCSIDR_Assoc_MASK () {0x1ff8;}' unless defined(&CCSIDR_Assoc_MASK);
	eval 'sub CCSIDR_Assoc64_MASK () {0xfffff8;}' unless defined(&CCSIDR_Assoc64_MASK);
	eval 'sub CCSIDR_Assoc_SHIFT () {3;}' unless defined(&CCSIDR_Assoc_SHIFT);
	eval 'sub CCSIDR_Assoc64_SHIFT () {3;}' unless defined(&CCSIDR_Assoc64_SHIFT);
	eval 'sub CCSIDR_LineSize_MASK () {0x7;}' unless defined(&CCSIDR_LineSize_MASK);
	eval 'sub CCSIDR_NSETS {
	    my($idr) = @_;
    	    eval q(((($idr) &  &CCSIDR_NumSets_MASK) >>  &CCSIDR_NumSets_SHIFT));
	}' unless defined(&CCSIDR_NSETS);
	eval 'sub CCSIDR_ASSOC {
	    my($idr) = @_;
    	    eval q(((($idr) &  &CCSIDR_Assoc_MASK) >>  &CCSIDR_Assoc_SHIFT));
	}' unless defined(&CCSIDR_ASSOC);
	eval 'sub CCSIDR_NSETS_64 {
	    my($idr) = @_;
    	    eval q(((($idr) &  &CCSIDR_NumSets64_MASK) >>  &CCSIDR_NumSets64_SHIFT));
	}' unless defined(&CCSIDR_NSETS_64);
	eval 'sub CCSIDR_ASSOC_64 {
	    my($idr) = @_;
    	    eval q(((($idr) &  &CCSIDR_Assoc64_MASK) >>  &CCSIDR_Assoc64_SHIFT));
	}' unless defined(&CCSIDR_ASSOC_64);
	eval 'sub CLIDR_CTYPE_MASK () {0x7;}' unless defined(&CLIDR_CTYPE_MASK);
	eval 'sub CLIDR_CTYPE_IO () {0x1;}' unless defined(&CLIDR_CTYPE_IO);
	eval 'sub CLIDR_CTYPE_DO () {0x2;}' unless defined(&CLIDR_CTYPE_DO);
	eval 'sub CLIDR_CTYPE_ID () {0x3;}' unless defined(&CLIDR_CTYPE_ID);
	eval 'sub CLIDR_CTYPE_UNIFIED () {0x4;}' unless defined(&CLIDR_CTYPE_UNIFIED);
	eval 'sub CNTP_CTL_EL0 () { &MRS_REG( &CNTP_CTL_EL0);}' unless defined(&CNTP_CTL_EL0);
	eval 'sub CNTP_CTL_EL0_op0 () {3;}' unless defined(&CNTP_CTL_EL0_op0);
	eval 'sub CNTP_CTL_EL0_op1 () {3;}' unless defined(&CNTP_CTL_EL0_op1);
	eval 'sub CNTP_CTL_EL0_CRn () {14;}' unless defined(&CNTP_CTL_EL0_CRn);
	eval 'sub CNTP_CTL_EL0_CRm () {2;}' unless defined(&CNTP_CTL_EL0_CRm);
	eval 'sub CNTP_CTL_EL0_op2 () {1;}' unless defined(&CNTP_CTL_EL0_op2);
	eval 'sub CNTP_CTL_ENABLE () {(1<< 0);}' unless defined(&CNTP_CTL_ENABLE);
	eval 'sub CNTP_CTL_IMASK () {(1<< 1);}' unless defined(&CNTP_CTL_IMASK);
	eval 'sub CNTP_CTL_ISTATUS () {(1<< 2);}' unless defined(&CNTP_CTL_ISTATUS);
	eval 'sub CNTP_CVAL_EL0 () { &MRS_REG( &CNTP_CVAL_EL0);}' unless defined(&CNTP_CVAL_EL0);
	eval 'sub CNTP_CVAL_EL0_op0 () {3;}' unless defined(&CNTP_CVAL_EL0_op0);
	eval 'sub CNTP_CVAL_EL0_op1 () {3;}' unless defined(&CNTP_CVAL_EL0_op1);
	eval 'sub CNTP_CVAL_EL0_CRn () {14;}' unless defined(&CNTP_CVAL_EL0_CRn);
	eval 'sub CNTP_CVAL_EL0_CRm () {2;}' unless defined(&CNTP_CVAL_EL0_CRm);
	eval 'sub CNTP_CVAL_EL0_op2 () {2;}' unless defined(&CNTP_CVAL_EL0_op2);
	eval 'sub CNTP_TVAL_EL0 () { &MRS_REG( &CNTP_TVAL_EL0);}' unless defined(&CNTP_TVAL_EL0);
	eval 'sub CNTP_TVAL_EL0_op0 () {3;}' unless defined(&CNTP_TVAL_EL0_op0);
	eval 'sub CNTP_TVAL_EL0_op1 () {3;}' unless defined(&CNTP_TVAL_EL0_op1);
	eval 'sub CNTP_TVAL_EL0_CRn () {14;}' unless defined(&CNTP_TVAL_EL0_CRn);
	eval 'sub CNTP_TVAL_EL0_CRm () {2;}' unless defined(&CNTP_TVAL_EL0_CRm);
	eval 'sub CNTP_TVAL_EL0_op2 () {0;}' unless defined(&CNTP_TVAL_EL0_op2);
	eval 'sub CNTPCT_EL0 () { &MRS_REG( &CNTPCT_EL0);}' unless defined(&CNTPCT_EL0);
	eval 'sub CNTPCT_EL0_op0 () {3;}' unless defined(&CNTPCT_EL0_op0);
	eval 'sub CNTPCT_EL0_op1 () {3;}' unless defined(&CNTPCT_EL0_op1);
	eval 'sub CNTPCT_EL0_CRn () {14;}' unless defined(&CNTPCT_EL0_CRn);
	eval 'sub CNTPCT_EL0_CRm () {0;}' unless defined(&CNTPCT_EL0_CRm);
	eval 'sub CNTPCT_EL0_op2 () {1;}' unless defined(&CNTPCT_EL0_op2);
	eval 'sub CPACR_ZEN_MASK () {(0x3 << 16);}' unless defined(&CPACR_ZEN_MASK);
	eval 'sub CPACR_ZEN_TRAP_ALL1 () {(0x << 16);}' unless defined(&CPACR_ZEN_TRAP_ALL1);
	eval 'sub CPACR_ZEN_TRAP_EL0 () {(0x1 << 16);}' unless defined(&CPACR_ZEN_TRAP_EL0);
	eval 'sub CPACR_ZEN_TRAP_ALL2 () {(0x2 << 16);}' unless defined(&CPACR_ZEN_TRAP_ALL2);
	eval 'sub CPACR_ZEN_TRAP_NONE () {(0x3 << 16);}' unless defined(&CPACR_ZEN_TRAP_NONE);
	eval 'sub CPACR_FPEN_MASK () {(0x3 << 20);}' unless defined(&CPACR_FPEN_MASK);
	eval 'sub CPACR_FPEN_TRAP_ALL1 () {(0x << 20);}' unless defined(&CPACR_FPEN_TRAP_ALL1);
	eval 'sub CPACR_FPEN_TRAP_EL0 () {(0x1 << 20);}' unless defined(&CPACR_FPEN_TRAP_EL0);
	eval 'sub CPACR_FPEN_TRAP_ALL2 () {(0x2 << 20);}' unless defined(&CPACR_FPEN_TRAP_ALL2);
	eval 'sub CPACR_FPEN_TRAP_NONE () {(0x3 << 20);}' unless defined(&CPACR_FPEN_TRAP_NONE);
	eval 'sub CPACR_TTA () {(0x1 << 28);}' unless defined(&CPACR_TTA);
	eval 'sub CSSELR_Level {
	    my($i) = @_;
    	    eval q(($i << 1));
	}' unless defined(&CSSELR_Level);
	eval 'sub CSSELR_InD () {0x1;}' unless defined(&CSSELR_InD);
	eval 'sub CTR_RES1 () {(1<< 31);}' unless defined(&CTR_RES1);
	eval 'sub CTR_TminLine_SHIFT () {32;}' unless defined(&CTR_TminLine_SHIFT);
	eval 'sub CTR_TminLine_MASK () {( &UL(0x3f) <<  &CTR_TminLine_SHIFT);}' unless defined(&CTR_TminLine_MASK);
	eval 'sub CTR_TminLine_VAL {
	    my($reg) = @_;
    	    eval q((($reg) &  &CTR_TminLine_MASK));
	}' unless defined(&CTR_TminLine_VAL);
	eval 'sub CTR_DIC_SHIFT () {29;}' unless defined(&CTR_DIC_SHIFT);
	eval 'sub CTR_DIC_MASK () {(0x1 <<  &CTR_DIC_SHIFT);}' unless defined(&CTR_DIC_MASK);
	eval 'sub CTR_DIC_VAL {
	    my($reg) = @_;
    	    eval q((($reg) &  &CTR_DIC_MASK));
	}' unless defined(&CTR_DIC_VAL);
	eval 'sub CTR_IDC_SHIFT () {28;}' unless defined(&CTR_IDC_SHIFT);
	eval 'sub CTR_IDC_MASK () {(0x1 <<  &CTR_IDC_SHIFT);}' unless defined(&CTR_IDC_MASK);
	eval 'sub CTR_IDC_VAL {
	    my($reg) = @_;
    	    eval q((($reg) &  &CTR_IDC_MASK));
	}' unless defined(&CTR_IDC_VAL);
	eval 'sub CTR_CWG_SHIFT () {24;}' unless defined(&CTR_CWG_SHIFT);
	eval 'sub CTR_CWG_MASK () {(0xf <<  &CTR_CWG_SHIFT);}' unless defined(&CTR_CWG_MASK);
	eval 'sub CTR_CWG_VAL {
	    my($reg) = @_;
    	    eval q((($reg) &  &CTR_CWG_MASK));
	}' unless defined(&CTR_CWG_VAL);
	eval 'sub CTR_CWG_SIZE {
	    my($reg) = @_;
    	    eval q((4<< ( &CTR_CWG_VAL($reg) >>  &CTR_CWG_SHIFT)));
	}' unless defined(&CTR_CWG_SIZE);
	eval 'sub CTR_ERG_SHIFT () {20;}' unless defined(&CTR_ERG_SHIFT);
	eval 'sub CTR_ERG_MASK () {(0xf <<  &CTR_ERG_SHIFT);}' unless defined(&CTR_ERG_MASK);
	eval 'sub CTR_ERG_VAL {
	    my($reg) = @_;
    	    eval q((($reg) &  &CTR_ERG_MASK));
	}' unless defined(&CTR_ERG_VAL);
	eval 'sub CTR_ERG_SIZE {
	    my($reg) = @_;
    	    eval q((4<< ( &CTR_ERG_VAL($reg) >>  &CTR_ERG_SHIFT)));
	}' unless defined(&CTR_ERG_SIZE);
	eval 'sub CTR_DLINE_SHIFT () {16;}' unless defined(&CTR_DLINE_SHIFT);
	eval 'sub CTR_DLINE_MASK () {(0xf <<  &CTR_DLINE_SHIFT);}' unless defined(&CTR_DLINE_MASK);
	eval 'sub CTR_DLINE_VAL {
	    my($reg) = @_;
    	    eval q((($reg) &  &CTR_DLINE_MASK));
	}' unless defined(&CTR_DLINE_VAL);
	eval 'sub CTR_DLINE_SIZE {
	    my($reg) = @_;
    	    eval q((4<< ( &CTR_DLINE_VAL($reg) >>  &CTR_DLINE_SHIFT)));
	}' unless defined(&CTR_DLINE_SIZE);
	eval 'sub CTR_L1IP_SHIFT () {14;}' unless defined(&CTR_L1IP_SHIFT);
	eval 'sub CTR_L1IP_MASK () {(0x3 <<  &CTR_L1IP_SHIFT);}' unless defined(&CTR_L1IP_MASK);
	eval 'sub CTR_L1IP_VAL {
	    my($reg) = @_;
    	    eval q((($reg) &  &CTR_L1IP_MASK));
	}' unless defined(&CTR_L1IP_VAL);
	eval 'sub CTR_L1IP_VPIPT () {(0<<  &CTR_L1IP_SHIFT);}' unless defined(&CTR_L1IP_VPIPT);
	eval 'sub CTR_L1IP_AIVIVT () {(1<<  &CTR_L1IP_SHIFT);}' unless defined(&CTR_L1IP_AIVIVT);
	eval 'sub CTR_L1IP_VIPT () {(2<<  &CTR_L1IP_SHIFT);}' unless defined(&CTR_L1IP_VIPT);
	eval 'sub CTR_L1IP_PIPT () {(3<<  &CTR_L1IP_SHIFT);}' unless defined(&CTR_L1IP_PIPT);
	eval 'sub CTR_ILINE_SHIFT () {0;}' unless defined(&CTR_ILINE_SHIFT);
	eval 'sub CTR_ILINE_MASK () {(0xf <<  &CTR_ILINE_SHIFT);}' unless defined(&CTR_ILINE_MASK);
	eval 'sub CTR_ILINE_VAL {
	    my($reg) = @_;
    	    eval q((($reg) &  &CTR_ILINE_MASK));
	}' unless defined(&CTR_ILINE_VAL);
	eval 'sub CTR_ILINE_SIZE {
	    my($reg) = @_;
    	    eval q((4<< ( &CTR_ILINE_VAL($reg) >>  &CTR_ILINE_SHIFT)));
	}' unless defined(&CTR_ILINE_SIZE);
	eval 'sub DAIF_D () {(1<< 3);}' unless defined(&DAIF_D);
	eval 'sub DAIF_A () {(1<< 2);}' unless defined(&DAIF_A);
	eval 'sub DAIF_I () {(1<< 1);}' unless defined(&DAIF_I);
	eval 'sub DAIF_F () {(1<< 0);}' unless defined(&DAIF_F);
	eval 'sub DAIF_ALL () {( &DAIF_D |  &DAIF_A |  &DAIF_I |  &DAIF_F);}' unless defined(&DAIF_ALL);
	eval 'sub DAIF_INTR () {( &DAIF_I);}' unless defined(&DAIF_INTR);
	eval 'sub DBGBCR_EL1_op0 () {2;}' unless defined(&DBGBCR_EL1_op0);
	eval 'sub DBGBCR_EL1_op1 () {0;}' unless defined(&DBGBCR_EL1_op1);
	eval 'sub DBGBCR_EL1_CRn () {0;}' unless defined(&DBGBCR_EL1_CRn);
	eval 'sub DBGBCR_EL1_op2 () {5;}' unless defined(&DBGBCR_EL1_op2);
	eval 'sub DBGBCR_EN () {0x1;}' unless defined(&DBGBCR_EN);
	eval 'sub DBGBCR_PMC_SHIFT () {1;}' unless defined(&DBGBCR_PMC_SHIFT);
	eval 'sub DBGBCR_PMC () {(0x3 <<  &DBGBCR_PMC_SHIFT);}' unless defined(&DBGBCR_PMC);
	eval 'sub DBGBCR_PMC_EL1 () {(0x1 <<  &DBGBCR_PMC_SHIFT);}' unless defined(&DBGBCR_PMC_EL1);
	eval 'sub DBGBCR_PMC_EL0 () {(0x2 <<  &DBGBCR_PMC_SHIFT);}' unless defined(&DBGBCR_PMC_EL0);
	eval 'sub DBGBCR_BAS_SHIFT () {5;}' unless defined(&DBGBCR_BAS_SHIFT);
	eval 'sub DBGBCR_BAS () {(0xf <<  &DBGBCR_BAS_SHIFT);}' unless defined(&DBGBCR_BAS);
	eval 'sub DBGBCR_HMC_SHIFT () {13;}' unless defined(&DBGBCR_HMC_SHIFT);
	eval 'sub DBGBCR_HMC () {(0x1 <<  &DBGBCR_HMC_SHIFT);}' unless defined(&DBGBCR_HMC);
	eval 'sub DBGBCR_SSC_SHIFT () {14;}' unless defined(&DBGBCR_SSC_SHIFT);
	eval 'sub DBGBCR_SSC () {(0x3 <<  &DBGBCR_SSC_SHIFT);}' unless defined(&DBGBCR_SSC);
	eval 'sub DBGBCR_LBN_SHIFT () {16;}' unless defined(&DBGBCR_LBN_SHIFT);
	eval 'sub DBGBCR_LBN () {(0xf <<  &DBGBCR_LBN_SHIFT);}' unless defined(&DBGBCR_LBN);
	eval 'sub DBGBCR_BT_SHIFT () {20;}' unless defined(&DBGBCR_BT_SHIFT);
	eval 'sub DBGBCR_BT () {(0xf <<  &DBGBCR_BT_SHIFT);}' unless defined(&DBGBCR_BT);
	eval 'sub DBGBVR_EL1_op0 () {2;}' unless defined(&DBGBVR_EL1_op0);
	eval 'sub DBGBVR_EL1_op1 () {0;}' unless defined(&DBGBVR_EL1_op1);
	eval 'sub DBGBVR_EL1_CRn () {0;}' unless defined(&DBGBVR_EL1_CRn);
	eval 'sub DBGBVR_EL1_op2 () {4;}' unless defined(&DBGBVR_EL1_op2);
	eval 'sub DBGWCR_EL1_op0 () {2;}' unless defined(&DBGWCR_EL1_op0);
	eval 'sub DBGWCR_EL1_op1 () {0;}' unless defined(&DBGWCR_EL1_op1);
	eval 'sub DBGWCR_EL1_CRn () {0;}' unless defined(&DBGWCR_EL1_CRn);
	eval 'sub DBGWCR_EL1_op2 () {7;}' unless defined(&DBGWCR_EL1_op2);
	eval 'sub DBGWCR_EN () {0x1;}' unless defined(&DBGWCR_EN);
	eval 'sub DBGWCR_PAC_SHIFT () {1;}' unless defined(&DBGWCR_PAC_SHIFT);
	eval 'sub DBGWCR_PAC () {(0x3 <<  &DBGWCR_PAC_SHIFT);}' unless defined(&DBGWCR_PAC);
	eval 'sub DBGWCR_PAC_EL1 () {(0x1 <<  &DBGWCR_PAC_SHIFT);}' unless defined(&DBGWCR_PAC_EL1);
	eval 'sub DBGWCR_PAC_EL0 () {(0x2 <<  &DBGWCR_PAC_SHIFT);}' unless defined(&DBGWCR_PAC_EL0);
	eval 'sub DBGWCR_LSC_SHIFT () {3;}' unless defined(&DBGWCR_LSC_SHIFT);
	eval 'sub DBGWCR_LSC () {(0x3 <<  &DBGWCR_LSC_SHIFT);}' unless defined(&DBGWCR_LSC);
	eval 'sub DBGWCR_BAS_SHIFT () {5;}' unless defined(&DBGWCR_BAS_SHIFT);
	eval 'sub DBGWCR_BAS () {(0xff <<  &DBGWCR_BAS_SHIFT);}' unless defined(&DBGWCR_BAS);
	eval 'sub DBGWCR_HMC_SHIFT () {13;}' unless defined(&DBGWCR_HMC_SHIFT);
	eval 'sub DBGWCR_HMC () {(0x1 <<  &DBGWCR_HMC_SHIFT);}' unless defined(&DBGWCR_HMC);
	eval 'sub DBGWCR_SSC_SHIFT () {14;}' unless defined(&DBGWCR_SSC_SHIFT);
	eval 'sub DBGWCR_SSC () {(0x3 <<  &DBGWCR_SSC_SHIFT);}' unless defined(&DBGWCR_SSC);
	eval 'sub DBGWCR_LBN_SHIFT () {16;}' unless defined(&DBGWCR_LBN_SHIFT);
	eval 'sub DBGWCR_LBN () {(0xf <<  &DBGWCR_LBN_SHIFT);}' unless defined(&DBGWCR_LBN);
	eval 'sub DBGWCR_WT_SHIFT () {20;}' unless defined(&DBGWCR_WT_SHIFT);
	eval 'sub DBGWCR_WT () {(0x1 <<  &DBGWCR_WT_SHIFT);}' unless defined(&DBGWCR_WT);
	eval 'sub DBGWCR_MASK_SHIFT () {24;}' unless defined(&DBGWCR_MASK_SHIFT);
	eval 'sub DBGWCR_MASK () {(0x1f <<  &DBGWCR_MASK_SHIFT);}' unless defined(&DBGWCR_MASK);
	eval 'sub DBGWVR_EL1_op0 () {2;}' unless defined(&DBGWVR_EL1_op0);
	eval 'sub DBGWVR_EL1_op1 () {0;}' unless defined(&DBGWVR_EL1_op1);
	eval 'sub DBGWVR_EL1_CRn () {0;}' unless defined(&DBGWVR_EL1_CRn);
	eval 'sub DBGWVR_EL1_op2 () {6;}' unless defined(&DBGWVR_EL1_op2);
	eval 'sub DCZID_DZP () {(1<< 4);}' unless defined(&DCZID_DZP);
	eval 'sub DCZID_BS_SHIFT () {0;}' unless defined(&DCZID_BS_SHIFT);
	eval 'sub DCZID_BS_MASK () {(0xf <<  &DCZID_BS_SHIFT);}' unless defined(&DCZID_BS_MASK);
	eval 'sub DCZID_BS_SIZE {
	    my($reg) = @_;
    	    eval q(((($reg) &  &DCZID_BS_MASK) >>  &DCZID_BS_SHIFT));
	}' unless defined(&DCZID_BS_SIZE);
	eval 'sub DBGAUTHSTATUS_EL1 () { &MRS_REG( &DBGAUTHSTATUS_EL1);}' unless defined(&DBGAUTHSTATUS_EL1);
	eval 'sub DBGAUTHSTATUS_EL1_op0 () {2;}' unless defined(&DBGAUTHSTATUS_EL1_op0);
	eval 'sub DBGAUTHSTATUS_EL1_op1 () {0;}' unless defined(&DBGAUTHSTATUS_EL1_op1);
	eval 'sub DBGAUTHSTATUS_EL1_CRn () {7;}' unless defined(&DBGAUTHSTATUS_EL1_CRn);
	eval 'sub DBGAUTHSTATUS_EL1_CRm () {14;}' unless defined(&DBGAUTHSTATUS_EL1_CRm);
	eval 'sub DBGAUTHSTATUS_EL1_op2 () {6;}' unless defined(&DBGAUTHSTATUS_EL1_op2);
	eval 'sub DBGCLAIMCLR_EL1 () { &MRS_REG( &DBGCLAIMCLR_EL1);}' unless defined(&DBGCLAIMCLR_EL1);
	eval 'sub DBGCLAIMCLR_EL1_op0 () {2;}' unless defined(&DBGCLAIMCLR_EL1_op0);
	eval 'sub DBGCLAIMCLR_EL1_op1 () {0;}' unless defined(&DBGCLAIMCLR_EL1_op1);
	eval 'sub DBGCLAIMCLR_EL1_CRn () {7;}' unless defined(&DBGCLAIMCLR_EL1_CRn);
	eval 'sub DBGCLAIMCLR_EL1_CRm () {9;}' unless defined(&DBGCLAIMCLR_EL1_CRm);
	eval 'sub DBGCLAIMCLR_EL1_op2 () {6;}' unless defined(&DBGCLAIMCLR_EL1_op2);
	eval 'sub DBGCLAIMSET_EL1 () { &MRS_REG( &DBGCLAIMSET_EL1);}' unless defined(&DBGCLAIMSET_EL1);
	eval 'sub DBGCLAIMSET_EL1_op0 () {2;}' unless defined(&DBGCLAIMSET_EL1_op0);
	eval 'sub DBGCLAIMSET_EL1_op1 () {0;}' unless defined(&DBGCLAIMSET_EL1_op1);
	eval 'sub DBGCLAIMSET_EL1_CRn () {7;}' unless defined(&DBGCLAIMSET_EL1_CRn);
	eval 'sub DBGCLAIMSET_EL1_CRm () {8;}' unless defined(&DBGCLAIMSET_EL1_CRm);
	eval 'sub DBGCLAIMSET_EL1_op2 () {6;}' unless defined(&DBGCLAIMSET_EL1_op2);
	eval 'sub DBGPRCR_EL1 () { &MRS_REG( &DBGPRCR_EL1);}' unless defined(&DBGPRCR_EL1);
	eval 'sub DBGPRCR_EL1_op0 () {2;}' unless defined(&DBGPRCR_EL1_op0);
	eval 'sub DBGPRCR_EL1_op1 () {0;}' unless defined(&DBGPRCR_EL1_op1);
	eval 'sub DBGPRCR_EL1_CRn () {1;}' unless defined(&DBGPRCR_EL1_CRn);
	eval 'sub DBGPRCR_EL1_CRm () {4;}' unless defined(&DBGPRCR_EL1_CRm);
	eval 'sub DBGPRCR_EL1_op2 () {4;}' unless defined(&DBGPRCR_EL1_op2);
	eval 'sub ESR_ELx_ISS_MASK () {0x1ffffff;}' unless defined(&ESR_ELx_ISS_MASK);
	eval 'sub ISS_FP_TFV_SHIFT () {23;}' unless defined(&ISS_FP_TFV_SHIFT);
	eval 'sub ISS_FP_TFV () {(0x1 <<  &ISS_FP_TFV_SHIFT);}' unless defined(&ISS_FP_TFV);
	eval 'sub ISS_FP_IOF () {0x1;}' unless defined(&ISS_FP_IOF);
	eval 'sub ISS_FP_DZF () {0x2;}' unless defined(&ISS_FP_DZF);
	eval 'sub ISS_FP_OFF () {0x4;}' unless defined(&ISS_FP_OFF);
	eval 'sub ISS_FP_UFF () {0x8;}' unless defined(&ISS_FP_UFF);
	eval 'sub ISS_FP_IXF () {0x10;}' unless defined(&ISS_FP_IXF);
	eval 'sub ISS_FP_IDF () {0x80;}' unless defined(&ISS_FP_IDF);
	eval 'sub ISS_INSN_FnV () {(0x1 << 10);}' unless defined(&ISS_INSN_FnV);
	eval 'sub ISS_INSN_EA () {(0x1 << 9);}' unless defined(&ISS_INSN_EA);
	eval 'sub ISS_INSN_S1PTW () {(0x1 << 7);}' unless defined(&ISS_INSN_S1PTW);
	eval 'sub ISS_INSN_IFSC_MASK () {(0x1f << 0);}' unless defined(&ISS_INSN_IFSC_MASK);
	eval 'sub ISS_WFx_TI_SHIFT () {0;}' unless defined(&ISS_WFx_TI_SHIFT);
	eval 'sub ISS_WFx_TI_MASK () {(0x3 <<  &ISS_WFx_TI_SHIFT);}' unless defined(&ISS_WFx_TI_MASK);
	eval 'sub ISS_WFx_TI_WFI () {(0x <<  &ISS_WFx_TI_SHIFT);}' unless defined(&ISS_WFx_TI_WFI);
	eval 'sub ISS_WFx_TI_WFE () {(0x1 <<  &ISS_WFx_TI_SHIFT);}' unless defined(&ISS_WFx_TI_WFE);
	eval 'sub ISS_WFx_TI_WFIT () {(0x2 <<  &ISS_WFx_TI_SHIFT);}' unless defined(&ISS_WFx_TI_WFIT);
	eval 'sub ISS_WFx_TI_WFET () {(0x3 <<  &ISS_WFx_TI_SHIFT);}' unless defined(&ISS_WFx_TI_WFET);
	eval 'sub ISS_WFx_RV_SHIFT () {2;}' unless defined(&ISS_WFx_RV_SHIFT);
	eval 'sub ISS_WFx_RV_MASK () {(0x1 <<  &ISS_WFx_RV_SHIFT);}' unless defined(&ISS_WFx_RV_MASK);
	eval 'sub ISS_WFx_RV_INVALID () {(0x <<  &ISS_WFx_RV_SHIFT);}' unless defined(&ISS_WFx_RV_INVALID);
	eval 'sub ISS_WFx_RV_VALID () {(0x1 <<  &ISS_WFx_RV_SHIFT);}' unless defined(&ISS_WFx_RV_VALID);
	eval 'sub ISS_WFx_RN_SHIFT () {5;}' unless defined(&ISS_WFx_RN_SHIFT);
	eval 'sub ISS_WFx_RN_MASK () {(0x1f <<  &ISS_WFx_RN_SHIFT);}' unless defined(&ISS_WFx_RN_MASK);
	eval 'sub ISS_WFx_RN {
	    my($x) = @_;
    	    eval q(((($x) &  &ISS_WFx_RN_MASK) >>  &ISS_WFx_RN_SHIFT));
	}' unless defined(&ISS_WFx_RN);
	eval 'sub ISS_WFx_COND_SHIFT () {20;}' unless defined(&ISS_WFx_COND_SHIFT);
	eval 'sub ISS_WFx_COND_MASK () {(0xf <<  &ISS_WFx_COND_SHIFT);}' unless defined(&ISS_WFx_COND_MASK);
	eval 'sub ISS_WFx_CV_SHIFT () {24;}' unless defined(&ISS_WFx_CV_SHIFT);
	eval 'sub ISS_WFx_CV_MASK () {(0x1 <<  &ISS_WFx_CV_SHIFT);}' unless defined(&ISS_WFx_CV_MASK);
	eval 'sub ISS_WFx_CV_INVALID () {(0x <<  &ISS_WFx_CV_SHIFT);}' unless defined(&ISS_WFx_CV_INVALID);
	eval 'sub ISS_WFx_CV_VALID () {(0x1 <<  &ISS_WFx_CV_SHIFT);}' unless defined(&ISS_WFx_CV_VALID);
	eval 'sub ISS_MSR_DIR_SHIFT () {0;}' unless defined(&ISS_MSR_DIR_SHIFT);
	eval 'sub ISS_MSR_DIR () {(0x1 <<  &ISS_MSR_DIR_SHIFT);}' unless defined(&ISS_MSR_DIR);
	eval 'sub ISS_MSR_Rt_SHIFT () {5;}' unless defined(&ISS_MSR_Rt_SHIFT);
	eval 'sub ISS_MSR_Rt_MASK () {(0x1f <<  &ISS_MSR_Rt_SHIFT);}' unless defined(&ISS_MSR_Rt_MASK);
	eval 'sub ISS_MSR_Rt {
	    my($x) = @_;
    	    eval q(((($x) &  &ISS_MSR_Rt_MASK) >>  &ISS_MSR_Rt_SHIFT));
	}' unless defined(&ISS_MSR_Rt);
	eval 'sub ISS_MSR_CRm_SHIFT () {1;}' unless defined(&ISS_MSR_CRm_SHIFT);
	eval 'sub ISS_MSR_CRm_MASK () {(0xf <<  &ISS_MSR_CRm_SHIFT);}' unless defined(&ISS_MSR_CRm_MASK);
	eval 'sub ISS_MSR_CRm {
	    my($x) = @_;
    	    eval q(((($x) &  &ISS_MSR_CRm_MASK) >>  &ISS_MSR_CRm_SHIFT));
	}' unless defined(&ISS_MSR_CRm);
	eval 'sub ISS_MSR_CRn_SHIFT () {10;}' unless defined(&ISS_MSR_CRn_SHIFT);
	eval 'sub ISS_MSR_CRn_MASK () {(0xf <<  &ISS_MSR_CRn_SHIFT);}' unless defined(&ISS_MSR_CRn_MASK);
	eval 'sub ISS_MSR_CRn {
	    my($x) = @_;
    	    eval q(((($x) &  &ISS_MSR_CRn_MASK) >>  &ISS_MSR_CRn_SHIFT));
	}' unless defined(&ISS_MSR_CRn);
	eval 'sub ISS_MSR_OP1_SHIFT () {14;}' unless defined(&ISS_MSR_OP1_SHIFT);
	eval 'sub ISS_MSR_OP1_MASK () {(0x7 <<  &ISS_MSR_OP1_SHIFT);}' unless defined(&ISS_MSR_OP1_MASK);
	eval 'sub ISS_MSR_OP1 {
	    my($x) = @_;
    	    eval q(((($x) &  &ISS_MSR_OP1_MASK) >>  &ISS_MSR_OP1_SHIFT));
	}' unless defined(&ISS_MSR_OP1);
	eval 'sub ISS_MSR_OP2_SHIFT () {17;}' unless defined(&ISS_MSR_OP2_SHIFT);
	eval 'sub ISS_MSR_OP2_MASK () {(0x7 <<  &ISS_MSR_OP2_SHIFT);}' unless defined(&ISS_MSR_OP2_MASK);
	eval 'sub ISS_MSR_OP2 {
	    my($x) = @_;
    	    eval q(((($x) &  &ISS_MSR_OP2_MASK) >>  &ISS_MSR_OP2_SHIFT));
	}' unless defined(&ISS_MSR_OP2);
	eval 'sub ISS_MSR_OP0_SHIFT () {20;}' unless defined(&ISS_MSR_OP0_SHIFT);
	eval 'sub ISS_MSR_OP0_MASK () {(0x3 <<  &ISS_MSR_OP0_SHIFT);}' unless defined(&ISS_MSR_OP0_MASK);
	eval 'sub ISS_MSR_OP0 {
	    my($x) = @_;
    	    eval q(((($x) &  &ISS_MSR_OP0_MASK) >>  &ISS_MSR_OP0_SHIFT));
	}' unless defined(&ISS_MSR_OP0);
	eval 'sub ISS_MSR_REG_MASK () {( &ISS_MSR_OP0_MASK |  &ISS_MSR_OP2_MASK |  &ISS_MSR_OP1_MASK |  &ISS_MSR_CRn_MASK |  &ISS_MSR_CRm_MASK);}' unless defined(&ISS_MSR_REG_MASK);
	eval 'sub ISS_DATA_ISV_SHIFT () {24;}' unless defined(&ISS_DATA_ISV_SHIFT);
	eval 'sub ISS_DATA_ISV () {(0x1 <<  &ISS_DATA_ISV_SHIFT);}' unless defined(&ISS_DATA_ISV);
	eval 'sub ISS_DATA_SAS_SHIFT () {22;}' unless defined(&ISS_DATA_SAS_SHIFT);
	eval 'sub ISS_DATA_SAS_MASK () {(0x3 <<  &ISS_DATA_SAS_SHIFT);}' unless defined(&ISS_DATA_SAS_MASK);
	eval 'sub ISS_DATA_SSE_SHIFT () {21;}' unless defined(&ISS_DATA_SSE_SHIFT);
	eval 'sub ISS_DATA_SSE () {(0x1 <<  &ISS_DATA_SSE_SHIFT);}' unless defined(&ISS_DATA_SSE);
	eval 'sub ISS_DATA_SRT_SHIFT () {16;}' unless defined(&ISS_DATA_SRT_SHIFT);
	eval 'sub ISS_DATA_SRT_MASK () {(0x1f <<  &ISS_DATA_SRT_SHIFT);}' unless defined(&ISS_DATA_SRT_MASK);
	eval 'sub ISS_DATA_SF () {(0x1 << 15);}' unless defined(&ISS_DATA_SF);
	eval 'sub ISS_DATA_AR () {(0x1 << 14);}' unless defined(&ISS_DATA_AR);
	eval 'sub ISS_DATA_FnV () {(0x1 << 10);}' unless defined(&ISS_DATA_FnV);
	eval 'sub ISS_DATA_EA () {(0x1 << 9);}' unless defined(&ISS_DATA_EA);
	eval 'sub ISS_DATA_CM () {(0x1 << 8);}' unless defined(&ISS_DATA_CM);
	eval 'sub ISS_DATA_S1PTW () {(0x1 << 7);}' unless defined(&ISS_DATA_S1PTW);
	eval 'sub ISS_DATA_WnR_SHIFT () {6;}' unless defined(&ISS_DATA_WnR_SHIFT);
	eval 'sub ISS_DATA_WnR () {(0x1 <<  &ISS_DATA_WnR_SHIFT);}' unless defined(&ISS_DATA_WnR);
	eval 'sub ISS_DATA_DFSC_MASK () {(0x3f << 0);}' unless defined(&ISS_DATA_DFSC_MASK);
	eval 'sub ISS_DATA_DFSC_ASF_L0 () {(0x << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L0);
	eval 'sub ISS_DATA_DFSC_ASF_L1 () {(0x1 << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L1);
	eval 'sub ISS_DATA_DFSC_ASF_L2 () {(0x2 << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L2);
	eval 'sub ISS_DATA_DFSC_ASF_L3 () {(0x3 << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L3);
	eval 'sub ISS_DATA_DFSC_TF_L0 () {(0x4 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L0);
	eval 'sub ISS_DATA_DFSC_TF_L1 () {(0x5 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L1);
	eval 'sub ISS_DATA_DFSC_TF_L2 () {(0x6 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L2);
	eval 'sub ISS_DATA_DFSC_TF_L3 () {(0x7 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L3);
	eval 'sub ISS_DATA_DFSC_AFF_L1 () {(0x9 << 0);}' unless defined(&ISS_DATA_DFSC_AFF_L1);
	eval 'sub ISS_DATA_DFSC_AFF_L2 () {(0xa << 0);}' unless defined(&ISS_DATA_DFSC_AFF_L2);
	eval 'sub ISS_DATA_DFSC_AFF_L3 () {(0xb << 0);}' unless defined(&ISS_DATA_DFSC_AFF_L3);
	eval 'sub ISS_DATA_DFSC_PF_L1 () {(0xd << 0);}' unless defined(&ISS_DATA_DFSC_PF_L1);
	eval 'sub ISS_DATA_DFSC_PF_L2 () {(0xe << 0);}' unless defined(&ISS_DATA_DFSC_PF_L2);
	eval 'sub ISS_DATA_DFSC_PF_L3 () {(0xf << 0);}' unless defined(&ISS_DATA_DFSC_PF_L3);
	eval 'sub ISS_DATA_DFSC_EXT () {(0x10 << 0);}' unless defined(&ISS_DATA_DFSC_EXT);
	eval 'sub ISS_DATA_DFSC_EXT_L0 () {(0x14 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L0);
	eval 'sub ISS_DATA_DFSC_EXT_L1 () {(0x15 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L1);
	eval 'sub ISS_DATA_DFSC_EXT_L2 () {(0x16 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L2);
	eval 'sub ISS_DATA_DFSC_EXT_L3 () {(0x17 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L3);
	eval 'sub ISS_DATA_DFSC_ECC () {(0x18 << 0);}' unless defined(&ISS_DATA_DFSC_ECC);
	eval 'sub ISS_DATA_DFSC_ECC_L0 () {(0x1c << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L0);
	eval 'sub ISS_DATA_DFSC_ECC_L1 () {(0x1d << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L1);
	eval 'sub ISS_DATA_DFSC_ECC_L2 () {(0x1e << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L2);
	eval 'sub ISS_DATA_DFSC_ECC_L3 () {(0x1f << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L3);
	eval 'sub ISS_DATA_DFSC_ALIGN () {(0x21 << 0);}' unless defined(&ISS_DATA_DFSC_ALIGN);
	eval 'sub ISS_DATA_DFSC_TLB_CONFLICT () {(0x30 << 0);}' unless defined(&ISS_DATA_DFSC_TLB_CONFLICT);
	eval 'sub ESR_ELx_IL () {(0x1 << 25);}' unless defined(&ESR_ELx_IL);
	eval 'sub ESR_ELx_EC_SHIFT () {26;}' unless defined(&ESR_ELx_EC_SHIFT);
	eval 'sub ESR_ELx_EC_MASK () {(0x3f << 26);}' unless defined(&ESR_ELx_EC_MASK);
	eval 'sub ESR_ELx_EXCEPTION {
	    my($esr) = @_;
    	    eval q(((($esr) &  &ESR_ELx_EC_MASK) >>  &ESR_ELx_EC_SHIFT));
	}' unless defined(&ESR_ELx_EXCEPTION);
	eval 'sub EXCP_UNKNOWN () {0x;}' unless defined(&EXCP_UNKNOWN);
	eval 'sub EXCP_TRAP_WFI_WFE () {0x1;}' unless defined(&EXCP_TRAP_WFI_WFE);
	eval 'sub EXCP_FP_SIMD () {0x7;}' unless defined(&EXCP_FP_SIMD);
	eval 'sub EXCP_BTI () {0xd;}' unless defined(&EXCP_BTI);
	eval 'sub EXCP_ILL_STATE () {0xe;}' unless defined(&EXCP_ILL_STATE);
	eval 'sub EXCP_SVC32 () {0x11;}' unless defined(&EXCP_SVC32);
	eval 'sub EXCP_SVC64 () {0x15;}' unless defined(&EXCP_SVC64);
	eval 'sub EXCP_HVC () {0x16;}' unless defined(&EXCP_HVC);
	eval 'sub EXCP_MSR () {0x18;}' unless defined(&EXCP_MSR);
	eval 'sub EXCP_SVE () {0x19;}' unless defined(&EXCP_SVE);
	eval 'sub EXCP_FPAC () {0x1c;}' unless defined(&EXCP_FPAC);
	eval 'sub EXCP_INSN_ABORT_L () {0x20;}' unless defined(&EXCP_INSN_ABORT_L);
	eval 'sub EXCP_INSN_ABORT () {0x21;}' unless defined(&EXCP_INSN_ABORT);
	eval 'sub EXCP_PC_ALIGN () {0x22;}' unless defined(&EXCP_PC_ALIGN);
	eval 'sub EXCP_DATA_ABORT_L () {0x24;}' unless defined(&EXCP_DATA_ABORT_L);
	eval 'sub EXCP_DATA_ABORT () {0x25;}' unless defined(&EXCP_DATA_ABORT);
	eval 'sub EXCP_SP_ALIGN () {0x26;}' unless defined(&EXCP_SP_ALIGN);
	eval 'sub EXCP_TRAP_FP () {0x2c;}' unless defined(&EXCP_TRAP_FP);
	eval 'sub EXCP_SERROR () {0x2f;}' unless defined(&EXCP_SERROR);
	eval 'sub EXCP_BRKPT_EL0 () {0x30;}' unless defined(&EXCP_BRKPT_EL0);
	eval 'sub EXCP_SOFTSTP_EL0 () {0x32;}' unless defined(&EXCP_SOFTSTP_EL0);
	eval 'sub EXCP_SOFTSTP_EL1 () {0x33;}' unless defined(&EXCP_SOFTSTP_EL1);
	eval 'sub EXCP_WATCHPT_EL0 () {0x34;}' unless defined(&EXCP_WATCHPT_EL0);
	eval 'sub EXCP_WATCHPT_EL1 () {0x35;}' unless defined(&EXCP_WATCHPT_EL1);
	eval 'sub EXCP_BRKPT_32 () {0x38;}' unless defined(&EXCP_BRKPT_32);
	eval 'sub EXCP_BRK () {0x3c;}' unless defined(&EXCP_BRK);
	eval 'sub ICC_CTLR_EL1_EOIMODE () {(1 << 1);}' unless defined(&ICC_CTLR_EL1_EOIMODE);
	eval 'sub ICC_IAR1_EL1_SPUR () {(0x3ff);}' unless defined(&ICC_IAR1_EL1_SPUR);
	eval 'sub ICC_IGRPEN0_EL1_EN () {(1 << 0);}' unless defined(&ICC_IGRPEN0_EL1_EN);
	eval 'sub ICC_PMR_EL1_PRIO_MASK () {(0xff);}' unless defined(&ICC_PMR_EL1_PRIO_MASK);
	eval 'sub ICC_SGI1R_EL1 () { &MRS_REG( &ICC_SGI1R_EL1);}' unless defined(&ICC_SGI1R_EL1);
	eval 'sub ICC_SGI1R_EL1_op0 () {3;}' unless defined(&ICC_SGI1R_EL1_op0);
	eval 'sub ICC_SGI1R_EL1_op1 () {0;}' unless defined(&ICC_SGI1R_EL1_op1);
	eval 'sub ICC_SGI1R_EL1_CRn () {12;}' unless defined(&ICC_SGI1R_EL1_CRn);
	eval 'sub ICC_SGI1R_EL1_CRm () {11;}' unless defined(&ICC_SGI1R_EL1_CRm);
	eval 'sub ICC_SGI1R_EL1_op2 () {5;}' unless defined(&ICC_SGI1R_EL1_op2);
	eval 'sub ICC_SGI1R_EL1_TL_SHIFT () {0;}' unless defined(&ICC_SGI1R_EL1_TL_SHIFT);
	eval 'sub ICC_SGI1R_EL1_TL_MASK () {(0xffff <<  &ICC_SGI1R_EL1_TL_SHIFT);}' unless defined(&ICC_SGI1R_EL1_TL_MASK);
	eval 'sub ICC_SGI1R_EL1_TL_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ICC_SGI1R_EL1_TL_MASK));
	}' unless defined(&ICC_SGI1R_EL1_TL_VAL);
	eval 'sub ICC_SGI1R_EL1_AFF1_SHIFT () {16;}' unless defined(&ICC_SGI1R_EL1_AFF1_SHIFT);
	eval 'sub ICC_SGI1R_EL1_AFF1_MASK () {(0xff <<  &ICC_SGI1R_EL1_AFF1_SHIFT);}' unless defined(&ICC_SGI1R_EL1_AFF1_MASK);
	eval 'sub ICC_SGI1R_EL1_AFF1_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ICC_SGI1R_EL1_AFF1_MASK));
	}' unless defined(&ICC_SGI1R_EL1_AFF1_VAL);
	eval 'sub ICC_SGI1R_EL1_SGIID_SHIFT () {24;}' unless defined(&ICC_SGI1R_EL1_SGIID_SHIFT);
	eval 'sub ICC_SGI1R_EL1_SGIID_MASK () {(0xf <<  &ICC_SGI1R_EL1_SGIID_SHIFT);}' unless defined(&ICC_SGI1R_EL1_SGIID_MASK);
	eval 'sub ICC_SGI1R_EL1_SGIID_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ICC_SGI1R_EL1_SGIID_MASK));
	}' unless defined(&ICC_SGI1R_EL1_SGIID_VAL);
	eval 'sub ICC_SGI1R_EL1_AFF2_SHIFT () {32;}' unless defined(&ICC_SGI1R_EL1_AFF2_SHIFT);
	eval 'sub ICC_SGI1R_EL1_AFF2_MASK () {(0xff <<  &ICC_SGI1R_EL1_AFF2_SHIFT);}' unless defined(&ICC_SGI1R_EL1_AFF2_MASK);
	eval 'sub ICC_SGI1R_EL1_AFF2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ICC_SGI1R_EL1_AFF2_MASK));
	}' unless defined(&ICC_SGI1R_EL1_AFF2_VAL);
	eval 'sub ICC_SGI1R_EL1_RS_SHIFT () {44;}' unless defined(&ICC_SGI1R_EL1_RS_SHIFT);
	eval 'sub ICC_SGI1R_EL1_RS_MASK () {(0xf <<  &ICC_SGI1R_EL1_RS_SHIFT);}' unless defined(&ICC_SGI1R_EL1_RS_MASK);
	eval 'sub ICC_SGI1R_EL1_RS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ICC_SGI1R_EL1_RS_MASK));
	}' unless defined(&ICC_SGI1R_EL1_RS_VAL);
	eval 'sub ICC_SGI1R_EL1_AFF3_SHIFT () {48;}' unless defined(&ICC_SGI1R_EL1_AFF3_SHIFT);
	eval 'sub ICC_SGI1R_EL1_AFF3_MASK () {(0xff <<  &ICC_SGI1R_EL1_AFF3_SHIFT);}' unless defined(&ICC_SGI1R_EL1_AFF3_MASK);
	eval 'sub ICC_SGI1R_EL1_AFF3_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ICC_SGI1R_EL1_AFF3_MASK));
	}' unless defined(&ICC_SGI1R_EL1_AFF3_VAL);
	eval 'sub ICC_SGI1R_EL1_IRM () {(0x1 << 40);}' unless defined(&ICC_SGI1R_EL1_IRM);
	eval 'sub ICC_SRE_EL1_SRE () {(1 << 0);}' unless defined(&ICC_SRE_EL1_SRE);
	eval 'sub ID_AA64AFR0_EL1 () { &MRS_REG( &ID_AA64AFR0_EL1);}' unless defined(&ID_AA64AFR0_EL1);
	eval 'sub ID_AA64AFR0_EL1_op0 () {3;}' unless defined(&ID_AA64AFR0_EL1_op0);
	eval 'sub ID_AA64AFR0_EL1_op1 () {0;}' unless defined(&ID_AA64AFR0_EL1_op1);
	eval 'sub ID_AA64AFR0_EL1_CRn () {0;}' unless defined(&ID_AA64AFR0_EL1_CRn);
	eval 'sub ID_AA64AFR0_EL1_CRm () {5;}' unless defined(&ID_AA64AFR0_EL1_CRm);
	eval 'sub ID_AA64AFR0_EL1_op2 () {4;}' unless defined(&ID_AA64AFR0_EL1_op2);
	eval 'sub ID_AA64AFR1_EL1 () { &MRS_REG( &ID_AA64AFR1_EL1);}' unless defined(&ID_AA64AFR1_EL1);
	eval 'sub ID_AA64AFR1_EL1_op0 () {3;}' unless defined(&ID_AA64AFR1_EL1_op0);
	eval 'sub ID_AA64AFR1_EL1_op1 () {0;}' unless defined(&ID_AA64AFR1_EL1_op1);
	eval 'sub ID_AA64AFR1_EL1_CRn () {0;}' unless defined(&ID_AA64AFR1_EL1_CRn);
	eval 'sub ID_AA64AFR1_EL1_CRm () {5;}' unless defined(&ID_AA64AFR1_EL1_CRm);
	eval 'sub ID_AA64AFR1_EL1_op2 () {5;}' unless defined(&ID_AA64AFR1_EL1_op2);
	eval 'sub ID_AA64DFR0_EL1 () { &MRS_REG( &ID_AA64DFR0_EL1);}' unless defined(&ID_AA64DFR0_EL1);
	eval 'sub ID_AA64DFR0_EL1_op0 () {3;}' unless defined(&ID_AA64DFR0_EL1_op0);
	eval 'sub ID_AA64DFR0_EL1_op1 () {0;}' unless defined(&ID_AA64DFR0_EL1_op1);
	eval 'sub ID_AA64DFR0_EL1_CRn () {0;}' unless defined(&ID_AA64DFR0_EL1_CRn);
	eval 'sub ID_AA64DFR0_EL1_CRm () {5;}' unless defined(&ID_AA64DFR0_EL1_CRm);
	eval 'sub ID_AA64DFR0_EL1_op2 () {0;}' unless defined(&ID_AA64DFR0_EL1_op2);
	eval 'sub ID_AA64DFR0_DebugVer_SHIFT () {0;}' unless defined(&ID_AA64DFR0_DebugVer_SHIFT);
	eval 'sub ID_AA64DFR0_DebugVer_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_MASK);
	eval 'sub ID_AA64DFR0_DebugVer_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_DebugVer_MASK));
	}' unless defined(&ID_AA64DFR0_DebugVer_VAL);
	eval 'sub ID_AA64DFR0_DebugVer_8 () {( &UL(0x6) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_8);
	eval 'sub ID_AA64DFR0_DebugVer_8_VHE () {( &UL(0x7) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_8_VHE);
	eval 'sub ID_AA64DFR0_DebugVer_8_2 () {( &UL(0x8) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_8_2);
	eval 'sub ID_AA64DFR0_DebugVer_8_4 () {( &UL(0x9) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_8_4);
	eval 'sub ID_AA64DFR0_DebugVer_8_8 () {( &UL(0xa) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_8_8);
	eval 'sub ID_AA64DFR0_TraceVer_SHIFT () {4;}' unless defined(&ID_AA64DFR0_TraceVer_SHIFT);
	eval 'sub ID_AA64DFR0_TraceVer_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_TraceVer_SHIFT);}' unless defined(&ID_AA64DFR0_TraceVer_MASK);
	eval 'sub ID_AA64DFR0_TraceVer_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_TraceVer_MASK));
	}' unless defined(&ID_AA64DFR0_TraceVer_VAL);
	eval 'sub ID_AA64DFR0_TraceVer_NONE () {( &UL(0x) <<  &ID_AA64DFR0_TraceVer_SHIFT);}' unless defined(&ID_AA64DFR0_TraceVer_NONE);
	eval 'sub ID_AA64DFR0_TraceVer_IMPL () {( &UL(0x1) <<  &ID_AA64DFR0_TraceVer_SHIFT);}' unless defined(&ID_AA64DFR0_TraceVer_IMPL);
	eval 'sub ID_AA64DFR0_PMUVer_SHIFT () {8;}' unless defined(&ID_AA64DFR0_PMUVer_SHIFT);
	eval 'sub ID_AA64DFR0_PMUVer_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_MASK);
	eval 'sub ID_AA64DFR0_PMUVer_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_PMUVer_MASK));
	}' unless defined(&ID_AA64DFR0_PMUVer_VAL);
	eval 'sub ID_AA64DFR0_PMUVer_NONE () {( &UL(0x) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_NONE);
	eval 'sub ID_AA64DFR0_PMUVer_3 () {( &UL(0x1) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_3);
	eval 'sub ID_AA64DFR0_PMUVer_3_1 () {( &UL(0x4) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_3_1);
	eval 'sub ID_AA64DFR0_PMUVer_3_4 () {( &UL(0x5) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_3_4);
	eval 'sub ID_AA64DFR0_PMUVer_3_5 () {( &UL(0x6) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_3_5);
	eval 'sub ID_AA64DFR0_PMUVer_3_7 () {( &UL(0x7) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_3_7);
	eval 'sub ID_AA64DFR0_PMUVer_3_8 () {( &UL(0x8) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_3_8);
	eval 'sub ID_AA64DFR0_PMUVer_IMPL () {( &UL(0xf) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_IMPL);
	eval 'sub ID_AA64DFR0_BRPs_SHIFT () {12;}' unless defined(&ID_AA64DFR0_BRPs_SHIFT);
	eval 'sub ID_AA64DFR0_BRPs_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_BRPs_SHIFT);}' unless defined(&ID_AA64DFR0_BRPs_MASK);
	eval 'sub ID_AA64DFR0_BRPs_VAL {
	    my($x) = @_;
    	    eval q((((($x) >>  &ID_AA64DFR0_BRPs_SHIFT) & 0xf) + 1));
	}' unless defined(&ID_AA64DFR0_BRPs_VAL);
	eval 'sub ID_AA64DFR0_PMSS_SHIFT () {16;}' unless defined(&ID_AA64DFR0_PMSS_SHIFT);
	eval 'sub ID_AA64DFR0_PMSS_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_PMSS_SHIFT);}' unless defined(&ID_AA64DFR0_PMSS_MASK);
	eval 'sub ID_AA64DFR0_PMSS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_PMSS_MASK));
	}' unless defined(&ID_AA64DFR0_PMSS_VAL);
	eval 'sub ID_AA64DFR0_PMSS_NONE () {( &UL(0x) <<  &ID_AA64DFR0_PMSS_SHIFT);}' unless defined(&ID_AA64DFR0_PMSS_NONE);
	eval 'sub ID_AA64DFR0_PMSS_IMPL () {( &UL(0x1) <<  &ID_AA64DFR0_PMSS_SHIFT);}' unless defined(&ID_AA64DFR0_PMSS_IMPL);
	eval 'sub ID_AA64DFR0_WRPs_SHIFT () {20;}' unless defined(&ID_AA64DFR0_WRPs_SHIFT);
	eval 'sub ID_AA64DFR0_WRPs_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_WRPs_SHIFT);}' unless defined(&ID_AA64DFR0_WRPs_MASK);
	eval 'sub ID_AA64DFR0_WRPs_VAL {
	    my($x) = @_;
    	    eval q((((($x) >>  &ID_AA64DFR0_WRPs_SHIFT) & 0xf) + 1));
	}' unless defined(&ID_AA64DFR0_WRPs_VAL);
	eval 'sub ID_AA64DFR0_CTX_CMPs_SHIFT () {28;}' unless defined(&ID_AA64DFR0_CTX_CMPs_SHIFT);
	eval 'sub ID_AA64DFR0_CTX_CMPs_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_CTX_CMPs_SHIFT);}' unless defined(&ID_AA64DFR0_CTX_CMPs_MASK);
	eval 'sub ID_AA64DFR0_CTX_CMPs_VAL {
	    my($x) = @_;
    	    eval q((((($x) >>  &ID_AA64DFR0_CTX_CMPs_SHIFT) & 0xf) + 1));
	}' unless defined(&ID_AA64DFR0_CTX_CMPs_VAL);
	eval 'sub ID_AA64DFR0_PMSVer_SHIFT () {32;}' unless defined(&ID_AA64DFR0_PMSVer_SHIFT);
	eval 'sub ID_AA64DFR0_PMSVer_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_PMSVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMSVer_MASK);
	eval 'sub ID_AA64DFR0_PMSVer_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_PMSVer_MASK));
	}' unless defined(&ID_AA64DFR0_PMSVer_VAL);
	eval 'sub ID_AA64DFR0_PMSVer_NONE () {( &UL(0x) <<  &ID_AA64DFR0_PMSVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMSVer_NONE);
	eval 'sub ID_AA64DFR0_PMSVer_SPE () {( &UL(0x1) <<  &ID_AA64DFR0_PMSVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMSVer_SPE);
	eval 'sub ID_AA64DFR0_PMSVer_SPE_1_1 () {( &UL(0x2) <<  &ID_AA64DFR0_PMSVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMSVer_SPE_1_1);
	eval 'sub ID_AA64DFR0_PMSVer_SPE_1_2 () {( &UL(0x3) <<  &ID_AA64DFR0_PMSVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMSVer_SPE_1_2);
	eval 'sub ID_AA64DFR0_PMSVer_SPE_1_3 () {( &UL(0x4) <<  &ID_AA64DFR0_PMSVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMSVer_SPE_1_3);
	eval 'sub ID_AA64DFR0_DoubleLock_SHIFT () {36;}' unless defined(&ID_AA64DFR0_DoubleLock_SHIFT);
	eval 'sub ID_AA64DFR0_DoubleLock_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_DoubleLock_SHIFT);}' unless defined(&ID_AA64DFR0_DoubleLock_MASK);
	eval 'sub ID_AA64DFR0_DoubleLock_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_DoubleLock_MASK));
	}' unless defined(&ID_AA64DFR0_DoubleLock_VAL);
	eval 'sub ID_AA64DFR0_DoubleLock_IMPL () {( &UL(0x) <<  &ID_AA64DFR0_DoubleLock_SHIFT);}' unless defined(&ID_AA64DFR0_DoubleLock_IMPL);
	eval 'sub ID_AA64DFR0_DoubleLock_NONE () {( &UL(0xf) <<  &ID_AA64DFR0_DoubleLock_SHIFT);}' unless defined(&ID_AA64DFR0_DoubleLock_NONE);
	eval 'sub ID_AA64DFR0_TraceFilt_SHIFT () {40;}' unless defined(&ID_AA64DFR0_TraceFilt_SHIFT);
	eval 'sub ID_AA64DFR0_TraceFilt_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_TraceFilt_SHIFT);}' unless defined(&ID_AA64DFR0_TraceFilt_MASK);
	eval 'sub ID_AA64DFR0_TraceFilt_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_TraceFilt_MASK));
	}' unless defined(&ID_AA64DFR0_TraceFilt_VAL);
	eval 'sub ID_AA64DFR0_TraceFilt_NONE () {( &UL(0x) <<  &ID_AA64DFR0_TraceFilt_SHIFT);}' unless defined(&ID_AA64DFR0_TraceFilt_NONE);
	eval 'sub ID_AA64DFR0_TraceFilt_8_4 () {( &UL(0x1) <<  &ID_AA64DFR0_TraceFilt_SHIFT);}' unless defined(&ID_AA64DFR0_TraceFilt_8_4);
	eval 'sub ID_AA64DFR0_TraceBuffer_SHIFT () {44;}' unless defined(&ID_AA64DFR0_TraceBuffer_SHIFT);
	eval 'sub ID_AA64DFR0_TraceBuffer_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_TraceBuffer_SHIFT);}' unless defined(&ID_AA64DFR0_TraceBuffer_MASK);
	eval 'sub ID_AA64DFR0_TraceBuffer_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_TraceBuffer_MASK));
	}' unless defined(&ID_AA64DFR0_TraceBuffer_VAL);
	eval 'sub ID_AA64DFR0_TraceBuffer_NONE () {( &UL(0x) <<  &ID_AA64DFR0_TraceBuffer_SHIFT);}' unless defined(&ID_AA64DFR0_TraceBuffer_NONE);
	eval 'sub ID_AA64DFR0_TraceBuffer_IMPL () {( &UL(0x1) <<  &ID_AA64DFR0_TraceBuffer_SHIFT);}' unless defined(&ID_AA64DFR0_TraceBuffer_IMPL);
	eval 'sub ID_AA64DFR0_MTPMU_SHIFT () {48;}' unless defined(&ID_AA64DFR0_MTPMU_SHIFT);
	eval 'sub ID_AA64DFR0_MTPMU_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_MTPMU_SHIFT);}' unless defined(&ID_AA64DFR0_MTPMU_MASK);
	eval 'sub ID_AA64DFR0_MTPMU_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_MTPMU_MASK));
	}' unless defined(&ID_AA64DFR0_MTPMU_VAL);
	eval 'sub ID_AA64DFR0_MTPMU_NONE () {( &UL(0x) <<  &ID_AA64DFR0_MTPMU_SHIFT);}' unless defined(&ID_AA64DFR0_MTPMU_NONE);
	eval 'sub ID_AA64DFR0_MTPMU_IMPL () {( &UL(0x1) <<  &ID_AA64DFR0_MTPMU_SHIFT);}' unless defined(&ID_AA64DFR0_MTPMU_IMPL);
	eval 'sub ID_AA64DFR0_MTPMU_NONE_MT_RES0 () {( &UL(0xf) <<  &ID_AA64DFR0_MTPMU_SHIFT);}' unless defined(&ID_AA64DFR0_MTPMU_NONE_MT_RES0);
	eval 'sub ID_AA64DFR0_BRBE_SHIFT () {52;}' unless defined(&ID_AA64DFR0_BRBE_SHIFT);
	eval 'sub ID_AA64DFR0_BRBE_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_BRBE_SHIFT);}' unless defined(&ID_AA64DFR0_BRBE_MASK);
	eval 'sub ID_AA64DFR0_BRBE_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_BRBE_MASK));
	}' unless defined(&ID_AA64DFR0_BRBE_VAL);
	eval 'sub ID_AA64DFR0_BRBE_NONE () {( &UL(0x) <<  &ID_AA64DFR0_BRBE_SHIFT);}' unless defined(&ID_AA64DFR0_BRBE_NONE);
	eval 'sub ID_AA64DFR0_BRBE_IMPL () {( &UL(0x1) <<  &ID_AA64DFR0_BRBE_SHIFT);}' unless defined(&ID_AA64DFR0_BRBE_IMPL);
	eval 'sub ID_AA64DFR0_BRBE_EL3 () {( &UL(0x2) <<  &ID_AA64DFR0_BRBE_SHIFT);}' unless defined(&ID_AA64DFR0_BRBE_EL3);
	eval 'sub ID_AA64DFR0_HPMN0_SHIFT () {60;}' unless defined(&ID_AA64DFR0_HPMN0_SHIFT);
	eval 'sub ID_AA64DFR0_HPMN0_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_HPMN0_SHIFT);}' unless defined(&ID_AA64DFR0_HPMN0_MASK);
	eval 'sub ID_AA64DFR0_HPMN0_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64DFR0_HPMN0_MASK));
	}' unless defined(&ID_AA64DFR0_HPMN0_VAL);
	eval 'sub ID_AA64DFR0_HPMN0_CONSTR () {( &UL(0x) <<  &ID_AA64DFR0_HPMN0_SHIFT);}' unless defined(&ID_AA64DFR0_HPMN0_CONSTR);
	eval 'sub ID_AA64DFR0_HPMN0_DEFINED () {( &UL(0x1) <<  &ID_AA64DFR0_HPMN0_SHIFT);}' unless defined(&ID_AA64DFR0_HPMN0_DEFINED);
	eval 'sub ID_AA64DFR1_EL1 () { &MRS_REG( &ID_AA64DFR1_EL1);}' unless defined(&ID_AA64DFR1_EL1);
	eval 'sub ID_AA64DFR1_EL1_op0 () {3;}' unless defined(&ID_AA64DFR1_EL1_op0);
	eval 'sub ID_AA64DFR1_EL1_op1 () {0;}' unless defined(&ID_AA64DFR1_EL1_op1);
	eval 'sub ID_AA64DFR1_EL1_CRn () {0;}' unless defined(&ID_AA64DFR1_EL1_CRn);
	eval 'sub ID_AA64DFR1_EL1_CRm () {5;}' unless defined(&ID_AA64DFR1_EL1_CRm);
	eval 'sub ID_AA64DFR1_EL1_op2 () {1;}' unless defined(&ID_AA64DFR1_EL1_op2);
	eval 'sub ID_AA64ISAR0_EL1 () { &MRS_REG( &ID_AA64ISAR0_EL1);}' unless defined(&ID_AA64ISAR0_EL1);
	eval 'sub ID_AA64ISAR0_EL1_op0 () {3;}' unless defined(&ID_AA64ISAR0_EL1_op0);
	eval 'sub ID_AA64ISAR0_EL1_op1 () {0;}' unless defined(&ID_AA64ISAR0_EL1_op1);
	eval 'sub ID_AA64ISAR0_EL1_CRn () {0;}' unless defined(&ID_AA64ISAR0_EL1_CRn);
	eval 'sub ID_AA64ISAR0_EL1_CRm () {6;}' unless defined(&ID_AA64ISAR0_EL1_CRm);
	eval 'sub ID_AA64ISAR0_EL1_op2 () {0;}' unless defined(&ID_AA64ISAR0_EL1_op2);
	eval 'sub ID_AA64ISAR0_AES_SHIFT () {4;}' unless defined(&ID_AA64ISAR0_AES_SHIFT);
	eval 'sub ID_AA64ISAR0_AES_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_MASK);
	eval 'sub ID_AA64ISAR0_AES_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_AES_MASK));
	}' unless defined(&ID_AA64ISAR0_AES_VAL);
	eval 'sub ID_AA64ISAR0_AES_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_NONE);
	eval 'sub ID_AA64ISAR0_AES_BASE () {( &UL(0x1) <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_BASE);
	eval 'sub ID_AA64ISAR0_AES_PMULL () {( &UL(0x2) <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_PMULL);
	eval 'sub ID_AA64ISAR0_SHA1_SHIFT () {8;}' unless defined(&ID_AA64ISAR0_SHA1_SHIFT);
	eval 'sub ID_AA64ISAR0_SHA1_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SHA1_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA1_MASK);
	eval 'sub ID_AA64ISAR0_SHA1_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_SHA1_MASK));
	}' unless defined(&ID_AA64ISAR0_SHA1_VAL);
	eval 'sub ID_AA64ISAR0_SHA1_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SHA1_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA1_NONE);
	eval 'sub ID_AA64ISAR0_SHA1_BASE () {( &UL(0x1) <<  &ID_AA64ISAR0_SHA1_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA1_BASE);
	eval 'sub ID_AA64ISAR0_SHA2_SHIFT () {12;}' unless defined(&ID_AA64ISAR0_SHA2_SHIFT);
	eval 'sub ID_AA64ISAR0_SHA2_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_MASK);
	eval 'sub ID_AA64ISAR0_SHA2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_SHA2_MASK));
	}' unless defined(&ID_AA64ISAR0_SHA2_VAL);
	eval 'sub ID_AA64ISAR0_SHA2_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_NONE);
	eval 'sub ID_AA64ISAR0_SHA2_BASE () {( &UL(0x1) <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_BASE);
	eval 'sub ID_AA64ISAR0_SHA2_512 () {( &UL(0x2) <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_512);
	eval 'sub ID_AA64ISAR0_CRC32_SHIFT () {16;}' unless defined(&ID_AA64ISAR0_CRC32_SHIFT);
	eval 'sub ID_AA64ISAR0_CRC32_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_CRC32_SHIFT);}' unless defined(&ID_AA64ISAR0_CRC32_MASK);
	eval 'sub ID_AA64ISAR0_CRC32_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_CRC32_MASK));
	}' unless defined(&ID_AA64ISAR0_CRC32_VAL);
	eval 'sub ID_AA64ISAR0_CRC32_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_CRC32_SHIFT);}' unless defined(&ID_AA64ISAR0_CRC32_NONE);
	eval 'sub ID_AA64ISAR0_CRC32_BASE () {( &UL(0x1) <<  &ID_AA64ISAR0_CRC32_SHIFT);}' unless defined(&ID_AA64ISAR0_CRC32_BASE);
	eval 'sub ID_AA64ISAR0_Atomic_SHIFT () {20;}' unless defined(&ID_AA64ISAR0_Atomic_SHIFT);
	eval 'sub ID_AA64ISAR0_Atomic_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_Atomic_SHIFT);}' unless defined(&ID_AA64ISAR0_Atomic_MASK);
	eval 'sub ID_AA64ISAR0_Atomic_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_Atomic_MASK));
	}' unless defined(&ID_AA64ISAR0_Atomic_VAL);
	eval 'sub ID_AA64ISAR0_Atomic_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_Atomic_SHIFT);}' unless defined(&ID_AA64ISAR0_Atomic_NONE);
	eval 'sub ID_AA64ISAR0_Atomic_IMPL () {( &UL(0x2) <<  &ID_AA64ISAR0_Atomic_SHIFT);}' unless defined(&ID_AA64ISAR0_Atomic_IMPL);
	eval 'sub ID_AA64ISAR0_TME_SHIFT () {24;}' unless defined(&ID_AA64ISAR0_TME_SHIFT);
	eval 'sub ID_AA64ISAR0_TME_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_TME_SHIFT);}' unless defined(&ID_AA64ISAR0_TME_MASK);
	eval 'sub ID_AA64ISAR0_TME_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_TME_SHIFT);}' unless defined(&ID_AA64ISAR0_TME_NONE);
	eval 'sub ID_AA64ISAR0_TME_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_TME_SHIFT);}' unless defined(&ID_AA64ISAR0_TME_IMPL);
	eval 'sub ID_AA64ISAR0_RDM_SHIFT () {28;}' unless defined(&ID_AA64ISAR0_RDM_SHIFT);
	eval 'sub ID_AA64ISAR0_RDM_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_RDM_SHIFT);}' unless defined(&ID_AA64ISAR0_RDM_MASK);
	eval 'sub ID_AA64ISAR0_RDM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_RDM_MASK));
	}' unless defined(&ID_AA64ISAR0_RDM_VAL);
	eval 'sub ID_AA64ISAR0_RDM_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_RDM_SHIFT);}' unless defined(&ID_AA64ISAR0_RDM_NONE);
	eval 'sub ID_AA64ISAR0_RDM_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_RDM_SHIFT);}' unless defined(&ID_AA64ISAR0_RDM_IMPL);
	eval 'sub ID_AA64ISAR0_SHA3_SHIFT () {32;}' unless defined(&ID_AA64ISAR0_SHA3_SHIFT);
	eval 'sub ID_AA64ISAR0_SHA3_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SHA3_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA3_MASK);
	eval 'sub ID_AA64ISAR0_SHA3_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_SHA3_MASK));
	}' unless defined(&ID_AA64ISAR0_SHA3_VAL);
	eval 'sub ID_AA64ISAR0_SHA3_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SHA3_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA3_NONE);
	eval 'sub ID_AA64ISAR0_SHA3_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_SHA3_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA3_IMPL);
	eval 'sub ID_AA64ISAR0_SM3_SHIFT () {36;}' unless defined(&ID_AA64ISAR0_SM3_SHIFT);
	eval 'sub ID_AA64ISAR0_SM3_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SM3_SHIFT);}' unless defined(&ID_AA64ISAR0_SM3_MASK);
	eval 'sub ID_AA64ISAR0_SM3_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_SM3_MASK));
	}' unless defined(&ID_AA64ISAR0_SM3_VAL);
	eval 'sub ID_AA64ISAR0_SM3_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SM3_SHIFT);}' unless defined(&ID_AA64ISAR0_SM3_NONE);
	eval 'sub ID_AA64ISAR0_SM3_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_SM3_SHIFT);}' unless defined(&ID_AA64ISAR0_SM3_IMPL);
	eval 'sub ID_AA64ISAR0_SM4_SHIFT () {40;}' unless defined(&ID_AA64ISAR0_SM4_SHIFT);
	eval 'sub ID_AA64ISAR0_SM4_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SM4_SHIFT);}' unless defined(&ID_AA64ISAR0_SM4_MASK);
	eval 'sub ID_AA64ISAR0_SM4_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_SM4_MASK));
	}' unless defined(&ID_AA64ISAR0_SM4_VAL);
	eval 'sub ID_AA64ISAR0_SM4_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SM4_SHIFT);}' unless defined(&ID_AA64ISAR0_SM4_NONE);
	eval 'sub ID_AA64ISAR0_SM4_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_SM4_SHIFT);}' unless defined(&ID_AA64ISAR0_SM4_IMPL);
	eval 'sub ID_AA64ISAR0_DP_SHIFT () {44;}' unless defined(&ID_AA64ISAR0_DP_SHIFT);
	eval 'sub ID_AA64ISAR0_DP_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_DP_SHIFT);}' unless defined(&ID_AA64ISAR0_DP_MASK);
	eval 'sub ID_AA64ISAR0_DP_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_DP_MASK));
	}' unless defined(&ID_AA64ISAR0_DP_VAL);
	eval 'sub ID_AA64ISAR0_DP_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_DP_SHIFT);}' unless defined(&ID_AA64ISAR0_DP_NONE);
	eval 'sub ID_AA64ISAR0_DP_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_DP_SHIFT);}' unless defined(&ID_AA64ISAR0_DP_IMPL);
	eval 'sub ID_AA64ISAR0_FHM_SHIFT () {48;}' unless defined(&ID_AA64ISAR0_FHM_SHIFT);
	eval 'sub ID_AA64ISAR0_FHM_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_FHM_SHIFT);}' unless defined(&ID_AA64ISAR0_FHM_MASK);
	eval 'sub ID_AA64ISAR0_FHM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_FHM_MASK));
	}' unless defined(&ID_AA64ISAR0_FHM_VAL);
	eval 'sub ID_AA64ISAR0_FHM_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_FHM_SHIFT);}' unless defined(&ID_AA64ISAR0_FHM_NONE);
	eval 'sub ID_AA64ISAR0_FHM_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_FHM_SHIFT);}' unless defined(&ID_AA64ISAR0_FHM_IMPL);
	eval 'sub ID_AA64ISAR0_TS_SHIFT () {52;}' unless defined(&ID_AA64ISAR0_TS_SHIFT);
	eval 'sub ID_AA64ISAR0_TS_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_TS_SHIFT);}' unless defined(&ID_AA64ISAR0_TS_MASK);
	eval 'sub ID_AA64ISAR0_TS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_TS_MASK));
	}' unless defined(&ID_AA64ISAR0_TS_VAL);
	eval 'sub ID_AA64ISAR0_TS_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_TS_SHIFT);}' unless defined(&ID_AA64ISAR0_TS_NONE);
	eval 'sub ID_AA64ISAR0_TS_CondM_8_4 () {( &UL(0x1) <<  &ID_AA64ISAR0_TS_SHIFT);}' unless defined(&ID_AA64ISAR0_TS_CondM_8_4);
	eval 'sub ID_AA64ISAR0_TS_CondM_8_5 () {( &UL(0x2) <<  &ID_AA64ISAR0_TS_SHIFT);}' unless defined(&ID_AA64ISAR0_TS_CondM_8_5);
	eval 'sub ID_AA64ISAR0_TLB_SHIFT () {56;}' unless defined(&ID_AA64ISAR0_TLB_SHIFT);
	eval 'sub ID_AA64ISAR0_TLB_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_TLB_SHIFT);}' unless defined(&ID_AA64ISAR0_TLB_MASK);
	eval 'sub ID_AA64ISAR0_TLB_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_TLB_MASK));
	}' unless defined(&ID_AA64ISAR0_TLB_VAL);
	eval 'sub ID_AA64ISAR0_TLB_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_TLB_SHIFT);}' unless defined(&ID_AA64ISAR0_TLB_NONE);
	eval 'sub ID_AA64ISAR0_TLB_TLBIOS () {( &UL(0x1) <<  &ID_AA64ISAR0_TLB_SHIFT);}' unless defined(&ID_AA64ISAR0_TLB_TLBIOS);
	eval 'sub ID_AA64ISAR0_TLB_TLBIOSR () {( &UL(0x2) <<  &ID_AA64ISAR0_TLB_SHIFT);}' unless defined(&ID_AA64ISAR0_TLB_TLBIOSR);
	eval 'sub ID_AA64ISAR0_RNDR_SHIFT () {60;}' unless defined(&ID_AA64ISAR0_RNDR_SHIFT);
	eval 'sub ID_AA64ISAR0_RNDR_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_RNDR_SHIFT);}' unless defined(&ID_AA64ISAR0_RNDR_MASK);
	eval 'sub ID_AA64ISAR0_RNDR_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR0_RNDR_MASK));
	}' unless defined(&ID_AA64ISAR0_RNDR_VAL);
	eval 'sub ID_AA64ISAR0_RNDR_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_RNDR_SHIFT);}' unless defined(&ID_AA64ISAR0_RNDR_NONE);
	eval 'sub ID_AA64ISAR0_RNDR_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_RNDR_SHIFT);}' unless defined(&ID_AA64ISAR0_RNDR_IMPL);
	eval 'sub ID_AA64ISAR1_EL1 () { &MRS_REG( &ID_AA64ISAR1_EL1);}' unless defined(&ID_AA64ISAR1_EL1);
	eval 'sub ID_AA64ISAR1_EL1_op0 () {3;}' unless defined(&ID_AA64ISAR1_EL1_op0);
	eval 'sub ID_AA64ISAR1_EL1_op1 () {0;}' unless defined(&ID_AA64ISAR1_EL1_op1);
	eval 'sub ID_AA64ISAR1_EL1_CRn () {0;}' unless defined(&ID_AA64ISAR1_EL1_CRn);
	eval 'sub ID_AA64ISAR1_EL1_CRm () {6;}' unless defined(&ID_AA64ISAR1_EL1_CRm);
	eval 'sub ID_AA64ISAR1_EL1_op2 () {1;}' unless defined(&ID_AA64ISAR1_EL1_op2);
	eval 'sub ID_AA64ISAR1_DPB_SHIFT () {0;}' unless defined(&ID_AA64ISAR1_DPB_SHIFT);
	eval 'sub ID_AA64ISAR1_DPB_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_DPB_SHIFT);}' unless defined(&ID_AA64ISAR1_DPB_MASK);
	eval 'sub ID_AA64ISAR1_DPB_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_DPB_MASK));
	}' unless defined(&ID_AA64ISAR1_DPB_VAL);
	eval 'sub ID_AA64ISAR1_DPB_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_DPB_SHIFT);}' unless defined(&ID_AA64ISAR1_DPB_NONE);
	eval 'sub ID_AA64ISAR1_DPB_DCCVAP () {( &UL(0x1) <<  &ID_AA64ISAR1_DPB_SHIFT);}' unless defined(&ID_AA64ISAR1_DPB_DCCVAP);
	eval 'sub ID_AA64ISAR1_DPB_DCCVADP () {( &UL(0x2) <<  &ID_AA64ISAR1_DPB_SHIFT);}' unless defined(&ID_AA64ISAR1_DPB_DCCVADP);
	eval 'sub ID_AA64ISAR1_APA_SHIFT () {4;}' unless defined(&ID_AA64ISAR1_APA_SHIFT);
	eval 'sub ID_AA64ISAR1_APA_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_MASK);
	eval 'sub ID_AA64ISAR1_APA_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_APA_MASK));
	}' unless defined(&ID_AA64ISAR1_APA_VAL);
	eval 'sub ID_AA64ISAR1_APA_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_NONE);
	eval 'sub ID_AA64ISAR1_APA_PAC () {( &UL(0x1) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_PAC);
	eval 'sub ID_AA64ISAR1_APA_EPAC () {( &UL(0x2) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_EPAC);
	eval 'sub ID_AA64ISAR1_APA_EPAC2 () {( &UL(0x3) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_EPAC2);
	eval 'sub ID_AA64ISAR1_APA_FPAC () {( &UL(0x4) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_FPAC);
	eval 'sub ID_AA64ISAR1_APA_FPAC_COMBINED () {( &UL(0x5) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_FPAC_COMBINED);
	eval 'sub ID_AA64ISAR1_API_SHIFT () {8;}' unless defined(&ID_AA64ISAR1_API_SHIFT);
	eval 'sub ID_AA64ISAR1_API_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_MASK);
	eval 'sub ID_AA64ISAR1_API_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_API_MASK));
	}' unless defined(&ID_AA64ISAR1_API_VAL);
	eval 'sub ID_AA64ISAR1_API_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_NONE);
	eval 'sub ID_AA64ISAR1_API_PAC () {( &UL(0x1) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_PAC);
	eval 'sub ID_AA64ISAR1_API_EPAC () {( &UL(0x2) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_EPAC);
	eval 'sub ID_AA64ISAR1_API_EPAC2 () {( &UL(0x3) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_EPAC2);
	eval 'sub ID_AA64ISAR1_API_FPAC () {( &UL(0x4) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_FPAC);
	eval 'sub ID_AA64ISAR1_API_FPAC_COMBINED () {( &UL(0x5) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_FPAC_COMBINED);
	eval 'sub ID_AA64ISAR1_JSCVT_SHIFT () {12;}' unless defined(&ID_AA64ISAR1_JSCVT_SHIFT);
	eval 'sub ID_AA64ISAR1_JSCVT_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_JSCVT_SHIFT);}' unless defined(&ID_AA64ISAR1_JSCVT_MASK);
	eval 'sub ID_AA64ISAR1_JSCVT_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_JSCVT_MASK));
	}' unless defined(&ID_AA64ISAR1_JSCVT_VAL);
	eval 'sub ID_AA64ISAR1_JSCVT_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_JSCVT_SHIFT);}' unless defined(&ID_AA64ISAR1_JSCVT_NONE);
	eval 'sub ID_AA64ISAR1_JSCVT_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_JSCVT_SHIFT);}' unless defined(&ID_AA64ISAR1_JSCVT_IMPL);
	eval 'sub ID_AA64ISAR1_FCMA_SHIFT () {16;}' unless defined(&ID_AA64ISAR1_FCMA_SHIFT);
	eval 'sub ID_AA64ISAR1_FCMA_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_FCMA_SHIFT);}' unless defined(&ID_AA64ISAR1_FCMA_MASK);
	eval 'sub ID_AA64ISAR1_FCMA_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_FCMA_MASK));
	}' unless defined(&ID_AA64ISAR1_FCMA_VAL);
	eval 'sub ID_AA64ISAR1_FCMA_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_FCMA_SHIFT);}' unless defined(&ID_AA64ISAR1_FCMA_NONE);
	eval 'sub ID_AA64ISAR1_FCMA_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_FCMA_SHIFT);}' unless defined(&ID_AA64ISAR1_FCMA_IMPL);
	eval 'sub ID_AA64ISAR1_LRCPC_SHIFT () {20;}' unless defined(&ID_AA64ISAR1_LRCPC_SHIFT);
	eval 'sub ID_AA64ISAR1_LRCPC_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_LRCPC_SHIFT);}' unless defined(&ID_AA64ISAR1_LRCPC_MASK);
	eval 'sub ID_AA64ISAR1_LRCPC_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_LRCPC_MASK));
	}' unless defined(&ID_AA64ISAR1_LRCPC_VAL);
	eval 'sub ID_AA64ISAR1_LRCPC_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_LRCPC_SHIFT);}' unless defined(&ID_AA64ISAR1_LRCPC_NONE);
	eval 'sub ID_AA64ISAR1_LRCPC_RCPC_8_3 () {( &UL(0x1) <<  &ID_AA64ISAR1_LRCPC_SHIFT);}' unless defined(&ID_AA64ISAR1_LRCPC_RCPC_8_3);
	eval 'sub ID_AA64ISAR1_LRCPC_RCPC_8_4 () {( &UL(0x2) <<  &ID_AA64ISAR1_LRCPC_SHIFT);}' unless defined(&ID_AA64ISAR1_LRCPC_RCPC_8_4);
	eval 'sub ID_AA64ISAR1_GPA_SHIFT () {24;}' unless defined(&ID_AA64ISAR1_GPA_SHIFT);
	eval 'sub ID_AA64ISAR1_GPA_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_GPA_SHIFT);}' unless defined(&ID_AA64ISAR1_GPA_MASK);
	eval 'sub ID_AA64ISAR1_GPA_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_GPA_MASK));
	}' unless defined(&ID_AA64ISAR1_GPA_VAL);
	eval 'sub ID_AA64ISAR1_GPA_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_GPA_SHIFT);}' unless defined(&ID_AA64ISAR1_GPA_NONE);
	eval 'sub ID_AA64ISAR1_GPA_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_GPA_SHIFT);}' unless defined(&ID_AA64ISAR1_GPA_IMPL);
	eval 'sub ID_AA64ISAR1_GPI_SHIFT () {28;}' unless defined(&ID_AA64ISAR1_GPI_SHIFT);
	eval 'sub ID_AA64ISAR1_GPI_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_GPI_SHIFT);}' unless defined(&ID_AA64ISAR1_GPI_MASK);
	eval 'sub ID_AA64ISAR1_GPI_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_GPI_MASK));
	}' unless defined(&ID_AA64ISAR1_GPI_VAL);
	eval 'sub ID_AA64ISAR1_GPI_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_GPI_SHIFT);}' unless defined(&ID_AA64ISAR1_GPI_NONE);
	eval 'sub ID_AA64ISAR1_GPI_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_GPI_SHIFT);}' unless defined(&ID_AA64ISAR1_GPI_IMPL);
	eval 'sub ID_AA64ISAR1_FRINTTS_SHIFT () {32;}' unless defined(&ID_AA64ISAR1_FRINTTS_SHIFT);
	eval 'sub ID_AA64ISAR1_FRINTTS_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_FRINTTS_SHIFT);}' unless defined(&ID_AA64ISAR1_FRINTTS_MASK);
	eval 'sub ID_AA64ISAR1_FRINTTS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_FRINTTS_MASK));
	}' unless defined(&ID_AA64ISAR1_FRINTTS_VAL);
	eval 'sub ID_AA64ISAR1_FRINTTS_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_FRINTTS_SHIFT);}' unless defined(&ID_AA64ISAR1_FRINTTS_NONE);
	eval 'sub ID_AA64ISAR1_FRINTTS_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_FRINTTS_SHIFT);}' unless defined(&ID_AA64ISAR1_FRINTTS_IMPL);
	eval 'sub ID_AA64ISAR1_SB_SHIFT () {36;}' unless defined(&ID_AA64ISAR1_SB_SHIFT);
	eval 'sub ID_AA64ISAR1_SB_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_SB_SHIFT);}' unless defined(&ID_AA64ISAR1_SB_MASK);
	eval 'sub ID_AA64ISAR1_SB_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_SB_MASK));
	}' unless defined(&ID_AA64ISAR1_SB_VAL);
	eval 'sub ID_AA64ISAR1_SB_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_SB_SHIFT);}' unless defined(&ID_AA64ISAR1_SB_NONE);
	eval 'sub ID_AA64ISAR1_SB_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_SB_SHIFT);}' unless defined(&ID_AA64ISAR1_SB_IMPL);
	eval 'sub ID_AA64ISAR1_SPECRES_SHIFT () {40;}' unless defined(&ID_AA64ISAR1_SPECRES_SHIFT);
	eval 'sub ID_AA64ISAR1_SPECRES_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_SPECRES_SHIFT);}' unless defined(&ID_AA64ISAR1_SPECRES_MASK);
	eval 'sub ID_AA64ISAR1_SPECRES_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_SPECRES_MASK));
	}' unless defined(&ID_AA64ISAR1_SPECRES_VAL);
	eval 'sub ID_AA64ISAR1_SPECRES_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_SPECRES_SHIFT);}' unless defined(&ID_AA64ISAR1_SPECRES_NONE);
	eval 'sub ID_AA64ISAR1_SPECRES_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_SPECRES_SHIFT);}' unless defined(&ID_AA64ISAR1_SPECRES_IMPL);
	eval 'sub ID_AA64ISAR1_BF16_SHIFT () {44;}' unless defined(&ID_AA64ISAR1_BF16_SHIFT);
	eval 'sub ID_AA64ISAR1_BF16_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_BF16_SHIFT);}' unless defined(&ID_AA64ISAR1_BF16_MASK);
	eval 'sub ID_AA64ISAR1_BF16_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_BF16_MASK));
	}' unless defined(&ID_AA64ISAR1_BF16_VAL);
	eval 'sub ID_AA64ISAR1_BF16_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_BF16_SHIFT);}' unless defined(&ID_AA64ISAR1_BF16_NONE);
	eval 'sub ID_AA64ISAR1_BF16_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_BF16_SHIFT);}' unless defined(&ID_AA64ISAR1_BF16_IMPL);
	eval 'sub ID_AA64ISAR1_BF16_EBF () {( &UL(0x2) <<  &ID_AA64ISAR1_BF16_SHIFT);}' unless defined(&ID_AA64ISAR1_BF16_EBF);
	eval 'sub ID_AA64ISAR1_DGH_SHIFT () {48;}' unless defined(&ID_AA64ISAR1_DGH_SHIFT);
	eval 'sub ID_AA64ISAR1_DGH_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_DGH_SHIFT);}' unless defined(&ID_AA64ISAR1_DGH_MASK);
	eval 'sub ID_AA64ISAR1_DGH_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_DGH_MASK));
	}' unless defined(&ID_AA64ISAR1_DGH_VAL);
	eval 'sub ID_AA64ISAR1_DGH_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_DGH_SHIFT);}' unless defined(&ID_AA64ISAR1_DGH_NONE);
	eval 'sub ID_AA64ISAR1_DGH_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_DGH_SHIFT);}' unless defined(&ID_AA64ISAR1_DGH_IMPL);
	eval 'sub ID_AA64ISAR1_I8MM_SHIFT () {52;}' unless defined(&ID_AA64ISAR1_I8MM_SHIFT);
	eval 'sub ID_AA64ISAR1_I8MM_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_I8MM_SHIFT);}' unless defined(&ID_AA64ISAR1_I8MM_MASK);
	eval 'sub ID_AA64ISAR1_I8MM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_I8MM_MASK));
	}' unless defined(&ID_AA64ISAR1_I8MM_VAL);
	eval 'sub ID_AA64ISAR1_I8MM_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_I8MM_SHIFT);}' unless defined(&ID_AA64ISAR1_I8MM_NONE);
	eval 'sub ID_AA64ISAR1_I8MM_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_I8MM_SHIFT);}' unless defined(&ID_AA64ISAR1_I8MM_IMPL);
	eval 'sub ID_AA64ISAR1_XS_SHIFT () {56;}' unless defined(&ID_AA64ISAR1_XS_SHIFT);
	eval 'sub ID_AA64ISAR1_XS_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_XS_SHIFT);}' unless defined(&ID_AA64ISAR1_XS_MASK);
	eval 'sub ID_AA64ISAR1_XS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_XS_MASK));
	}' unless defined(&ID_AA64ISAR1_XS_VAL);
	eval 'sub ID_AA64ISAR1_XS_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_XS_SHIFT);}' unless defined(&ID_AA64ISAR1_XS_NONE);
	eval 'sub ID_AA64ISAR1_XS_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_XS_SHIFT);}' unless defined(&ID_AA64ISAR1_XS_IMPL);
	eval 'sub ID_AA64ISAR1_LS64_SHIFT () {60;}' unless defined(&ID_AA64ISAR1_LS64_SHIFT);
	eval 'sub ID_AA64ISAR1_LS64_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_LS64_SHIFT);}' unless defined(&ID_AA64ISAR1_LS64_MASK);
	eval 'sub ID_AA64ISAR1_LS64_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR1_LS64_MASK));
	}' unless defined(&ID_AA64ISAR1_LS64_VAL);
	eval 'sub ID_AA64ISAR1_LS64_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_LS64_SHIFT);}' unless defined(&ID_AA64ISAR1_LS64_NONE);
	eval 'sub ID_AA64ISAR1_LS64_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_LS64_SHIFT);}' unless defined(&ID_AA64ISAR1_LS64_IMPL);
	eval 'sub ID_AA64ISAR1_LS64_V () {( &UL(0x2) <<  &ID_AA64ISAR1_LS64_SHIFT);}' unless defined(&ID_AA64ISAR1_LS64_V);
	eval 'sub ID_AA64ISAR1_LS64_ACCDATA () {( &UL(0x3) <<  &ID_AA64ISAR1_LS64_SHIFT);}' unless defined(&ID_AA64ISAR1_LS64_ACCDATA);
	eval 'sub ID_AA64ISAR2_EL1 () { &MRS_REG( &ID_AA64ISAR2_EL1);}' unless defined(&ID_AA64ISAR2_EL1);
	eval 'sub ID_AA64ISAR2_EL1_op0 () {3;}' unless defined(&ID_AA64ISAR2_EL1_op0);
	eval 'sub ID_AA64ISAR2_EL1_op1 () {0;}' unless defined(&ID_AA64ISAR2_EL1_op1);
	eval 'sub ID_AA64ISAR2_EL1_CRn () {0;}' unless defined(&ID_AA64ISAR2_EL1_CRn);
	eval 'sub ID_AA64ISAR2_EL1_CRm () {6;}' unless defined(&ID_AA64ISAR2_EL1_CRm);
	eval 'sub ID_AA64ISAR2_EL1_op2 () {2;}' unless defined(&ID_AA64ISAR2_EL1_op2);
	eval 'sub ID_AA64ISAR2_WFxT_SHIFT () {0;}' unless defined(&ID_AA64ISAR2_WFxT_SHIFT);
	eval 'sub ID_AA64ISAR2_WFxT_MASK () {( &UL(0xf) <<  &ID_AA64ISAR2_WFxT_SHIFT);}' unless defined(&ID_AA64ISAR2_WFxT_MASK);
	eval 'sub ID_AA64ISAR2_WFxT_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR2_WFxT_MASK));
	}' unless defined(&ID_AA64ISAR2_WFxT_VAL);
	eval 'sub ID_AA64ISAR2_WFxT_NONE () {( &UL(0x) <<  &ID_AA64ISAR2_WFxT_SHIFT);}' unless defined(&ID_AA64ISAR2_WFxT_NONE);
	eval 'sub ID_AA64ISAR2_WFxT_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR2_WFxT_SHIFT);}' unless defined(&ID_AA64ISAR2_WFxT_IMPL);
	eval 'sub ID_AA64ISAR2_RPRES_SHIFT () {4;}' unless defined(&ID_AA64ISAR2_RPRES_SHIFT);
	eval 'sub ID_AA64ISAR2_RPRES_MASK () {( &UL(0xf) <<  &ID_AA64ISAR2_RPRES_SHIFT);}' unless defined(&ID_AA64ISAR2_RPRES_MASK);
	eval 'sub ID_AA64ISAR2_RPRES_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR2_RPRES_MASK));
	}' unless defined(&ID_AA64ISAR2_RPRES_VAL);
	eval 'sub ID_AA64ISAR2_RPRES_NONE () {( &UL(0x) <<  &ID_AA64ISAR2_RPRES_SHIFT);}' unless defined(&ID_AA64ISAR2_RPRES_NONE);
	eval 'sub ID_AA64ISAR2_RPRES_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR2_RPRES_SHIFT);}' unless defined(&ID_AA64ISAR2_RPRES_IMPL);
	eval 'sub ID_AA64ISAR2_GPA3_SHIFT () {8;}' unless defined(&ID_AA64ISAR2_GPA3_SHIFT);
	eval 'sub ID_AA64ISAR2_GPA3_MASK () {( &UL(0xf) <<  &ID_AA64ISAR2_GPA3_SHIFT);}' unless defined(&ID_AA64ISAR2_GPA3_MASK);
	eval 'sub ID_AA64ISAR2_GPA3_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR2_GPA3_MASK));
	}' unless defined(&ID_AA64ISAR2_GPA3_VAL);
	eval 'sub ID_AA64ISAR2_GPA3_NONE () {( &UL(0x) <<  &ID_AA64ISAR2_GPA3_SHIFT);}' unless defined(&ID_AA64ISAR2_GPA3_NONE);
	eval 'sub ID_AA64ISAR2_GPA3_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR2_GPA3_SHIFT);}' unless defined(&ID_AA64ISAR2_GPA3_IMPL);
	eval 'sub ID_AA64ISAR2_APA3_SHIFT () {12;}' unless defined(&ID_AA64ISAR2_APA3_SHIFT);
	eval 'sub ID_AA64ISAR2_APA3_MASK () {( &UL(0xf) <<  &ID_AA64ISAR2_APA3_SHIFT);}' unless defined(&ID_AA64ISAR2_APA3_MASK);
	eval 'sub ID_AA64ISAR2_APA3_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR2_APA3_MASK));
	}' unless defined(&ID_AA64ISAR2_APA3_VAL);
	eval 'sub ID_AA64ISAR2_APA3_NONE () {( &UL(0x) <<  &ID_AA64ISAR2_APA3_SHIFT);}' unless defined(&ID_AA64ISAR2_APA3_NONE);
	eval 'sub ID_AA64ISAR2_APA3_PAC () {( &UL(0x1) <<  &ID_AA64ISAR2_APA3_SHIFT);}' unless defined(&ID_AA64ISAR2_APA3_PAC);
	eval 'sub ID_AA64ISAR2_APA3_EPAC () {( &UL(0x2) <<  &ID_AA64ISAR2_APA3_SHIFT);}' unless defined(&ID_AA64ISAR2_APA3_EPAC);
	eval 'sub ID_AA64ISAR2_APA3_EPAC2 () {( &UL(0x3) <<  &ID_AA64ISAR2_APA3_SHIFT);}' unless defined(&ID_AA64ISAR2_APA3_EPAC2);
	eval 'sub ID_AA64ISAR2_APA3_FPAC () {( &UL(0x4) <<  &ID_AA64ISAR2_APA3_SHIFT);}' unless defined(&ID_AA64ISAR2_APA3_FPAC);
	eval 'sub ID_AA64ISAR2_APA3_FPAC_COMBINED () {( &UL(0x5) <<  &ID_AA64ISAR2_APA3_SHIFT);}' unless defined(&ID_AA64ISAR2_APA3_FPAC_COMBINED);
	eval 'sub ID_AA64ISAR2_MOPS_SHIFT () {16;}' unless defined(&ID_AA64ISAR2_MOPS_SHIFT);
	eval 'sub ID_AA64ISAR2_MOPS_MASK () {( &UL(0xf) <<  &ID_AA64ISAR2_MOPS_SHIFT);}' unless defined(&ID_AA64ISAR2_MOPS_MASK);
	eval 'sub ID_AA64ISAR2_MOPS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR2_MOPS_MASK));
	}' unless defined(&ID_AA64ISAR2_MOPS_VAL);
	eval 'sub ID_AA64ISAR2_MOPS_NONE () {( &UL(0x) <<  &ID_AA64ISAR2_MOPS_SHIFT);}' unless defined(&ID_AA64ISAR2_MOPS_NONE);
	eval 'sub ID_AA64ISAR2_MOPS_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR2_MOPS_SHIFT);}' unless defined(&ID_AA64ISAR2_MOPS_IMPL);
	eval 'sub ID_AA64ISAR2_BC_SHIFT () {20;}' unless defined(&ID_AA64ISAR2_BC_SHIFT);
	eval 'sub ID_AA64ISAR2_BC_MASK () {( &UL(0xf) <<  &ID_AA64ISAR2_BC_SHIFT);}' unless defined(&ID_AA64ISAR2_BC_MASK);
	eval 'sub ID_AA64ISAR2_BC_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR2_BC_MASK));
	}' unless defined(&ID_AA64ISAR2_BC_VAL);
	eval 'sub ID_AA64ISAR2_BC_NONE () {( &UL(0x) <<  &ID_AA64ISAR2_BC_SHIFT);}' unless defined(&ID_AA64ISAR2_BC_NONE);
	eval 'sub ID_AA64ISAR2_BC_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR2_BC_SHIFT);}' unless defined(&ID_AA64ISAR2_BC_IMPL);
	eval 'sub ID_AA64ISAR2_PAC_frac_SHIFT () {28;}' unless defined(&ID_AA64ISAR2_PAC_frac_SHIFT);
	eval 'sub ID_AA64ISAR2_PAC_frac_MASK () {( &UL(0xf) <<  &ID_AA64ISAR2_PAC_frac_SHIFT);}' unless defined(&ID_AA64ISAR2_PAC_frac_MASK);
	eval 'sub ID_AA64ISAR2_PAC_frac_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ISAR2_PAC_frac_MASK));
	}' unless defined(&ID_AA64ISAR2_PAC_frac_VAL);
	eval 'sub ID_AA64ISAR2_PAC_frac_NONE () {( &UL(0x) <<  &ID_AA64ISAR2_PAC_frac_SHIFT);}' unless defined(&ID_AA64ISAR2_PAC_frac_NONE);
	eval 'sub ID_AA64ISAR2_PAC_frac_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR2_PAC_frac_SHIFT);}' unless defined(&ID_AA64ISAR2_PAC_frac_IMPL);
	eval 'sub ID_AA64MMFR0_EL1 () { &MRS_REG( &ID_AA64MMFR0_EL1);}' unless defined(&ID_AA64MMFR0_EL1);
	eval 'sub ID_AA64MMFR0_EL1_op0 () {3;}' unless defined(&ID_AA64MMFR0_EL1_op0);
	eval 'sub ID_AA64MMFR0_EL1_op1 () {0;}' unless defined(&ID_AA64MMFR0_EL1_op1);
	eval 'sub ID_AA64MMFR0_EL1_CRn () {0;}' unless defined(&ID_AA64MMFR0_EL1_CRn);
	eval 'sub ID_AA64MMFR0_EL1_CRm () {7;}' unless defined(&ID_AA64MMFR0_EL1_CRm);
	eval 'sub ID_AA64MMFR0_EL1_op2 () {0;}' unless defined(&ID_AA64MMFR0_EL1_op2);
	eval 'sub ID_AA64MMFR0_PARange_SHIFT () {0;}' unless defined(&ID_AA64MMFR0_PARange_SHIFT);
	eval 'sub ID_AA64MMFR0_PARange_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_MASK);
	eval 'sub ID_AA64MMFR0_PARange_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_PARange_MASK));
	}' unless defined(&ID_AA64MMFR0_PARange_VAL);
	eval 'sub ID_AA64MMFR0_PARange_4G () {( &UL(0x) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_4G);
	eval 'sub ID_AA64MMFR0_PARange_64G () {( &UL(0x1) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_64G);
	eval 'sub ID_AA64MMFR0_PARange_1T () {( &UL(0x2) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_1T);
	eval 'sub ID_AA64MMFR0_PARange_4T () {( &UL(0x3) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_4T);
	eval 'sub ID_AA64MMFR0_PARange_16T () {( &UL(0x4) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_16T);
	eval 'sub ID_AA64MMFR0_PARange_256T () {( &UL(0x5) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_256T);
	eval 'sub ID_AA64MMFR0_PARange_4P () {( &UL(0x6) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_4P);
	eval 'sub ID_AA64MMFR0_ASIDBits_SHIFT () {4;}' unless defined(&ID_AA64MMFR0_ASIDBits_SHIFT);
	eval 'sub ID_AA64MMFR0_ASIDBits_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_ASIDBits_SHIFT);}' unless defined(&ID_AA64MMFR0_ASIDBits_MASK);
	eval 'sub ID_AA64MMFR0_ASIDBits_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_ASIDBits_MASK));
	}' unless defined(&ID_AA64MMFR0_ASIDBits_VAL);
	eval 'sub ID_AA64MMFR0_ASIDBits_8 () {( &UL(0x) <<  &ID_AA64MMFR0_ASIDBits_SHIFT);}' unless defined(&ID_AA64MMFR0_ASIDBits_8);
	eval 'sub ID_AA64MMFR0_ASIDBits_16 () {( &UL(0x2) <<  &ID_AA64MMFR0_ASIDBits_SHIFT);}' unless defined(&ID_AA64MMFR0_ASIDBits_16);
	eval 'sub ID_AA64MMFR0_BigEnd_SHIFT () {8;}' unless defined(&ID_AA64MMFR0_BigEnd_SHIFT);
	eval 'sub ID_AA64MMFR0_BigEnd_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_BigEnd_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEnd_MASK);
	eval 'sub ID_AA64MMFR0_BigEnd_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_BigEnd_MASK));
	}' unless defined(&ID_AA64MMFR0_BigEnd_VAL);
	eval 'sub ID_AA64MMFR0_BigEnd_FIXED () {( &UL(0x) <<  &ID_AA64MMFR0_BigEnd_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEnd_FIXED);
	eval 'sub ID_AA64MMFR0_BigEnd_MIXED () {( &UL(0x1) <<  &ID_AA64MMFR0_BigEnd_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEnd_MIXED);
	eval 'sub ID_AA64MMFR0_SNSMem_SHIFT () {12;}' unless defined(&ID_AA64MMFR0_SNSMem_SHIFT);
	eval 'sub ID_AA64MMFR0_SNSMem_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_SNSMem_SHIFT);}' unless defined(&ID_AA64MMFR0_SNSMem_MASK);
	eval 'sub ID_AA64MMFR0_SNSMem_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_SNSMem_MASK));
	}' unless defined(&ID_AA64MMFR0_SNSMem_VAL);
	eval 'sub ID_AA64MMFR0_SNSMem_NONE () {( &UL(0x) <<  &ID_AA64MMFR0_SNSMem_SHIFT);}' unless defined(&ID_AA64MMFR0_SNSMem_NONE);
	eval 'sub ID_AA64MMFR0_SNSMem_DISTINCT () {( &UL(0x1) <<  &ID_AA64MMFR0_SNSMem_SHIFT);}' unless defined(&ID_AA64MMFR0_SNSMem_DISTINCT);
	eval 'sub ID_AA64MMFR0_BigEndEL0_SHIFT () {16;}' unless defined(&ID_AA64MMFR0_BigEndEL0_SHIFT);
	eval 'sub ID_AA64MMFR0_BigEndEL0_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_BigEndEL0_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEndEL0_MASK);
	eval 'sub ID_AA64MMFR0_BigEndEL0_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_BigEndEL0_MASK));
	}' unless defined(&ID_AA64MMFR0_BigEndEL0_VAL);
	eval 'sub ID_AA64MMFR0_BigEndEL0_FIXED () {( &UL(0x) <<  &ID_AA64MMFR0_BigEndEL0_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEndEL0_FIXED);
	eval 'sub ID_AA64MMFR0_BigEndEL0_MIXED () {( &UL(0x1) <<  &ID_AA64MMFR0_BigEndEL0_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEndEL0_MIXED);
	eval 'sub ID_AA64MMFR0_TGran16_SHIFT () {20;}' unless defined(&ID_AA64MMFR0_TGran16_SHIFT);
	eval 'sub ID_AA64MMFR0_TGran16_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_MASK);
	eval 'sub ID_AA64MMFR0_TGran16_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_TGran16_MASK));
	}' unless defined(&ID_AA64MMFR0_TGran16_VAL);
	eval 'sub ID_AA64MMFR0_TGran16_NONE () {( &UL(0x) <<  &ID_AA64MMFR0_TGran16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_NONE);
	eval 'sub ID_AA64MMFR0_TGran16_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR0_TGran16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_IMPL);
	eval 'sub ID_AA64MMFR0_TGran16_LPA2 () {( &UL(0x2) <<  &ID_AA64MMFR0_TGran16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_LPA2);
	eval 'sub ID_AA64MMFR0_TGran64_SHIFT () {24;}' unless defined(&ID_AA64MMFR0_TGran64_SHIFT);
	eval 'sub ID_AA64MMFR0_TGran64_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran64_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_MASK);
	eval 'sub ID_AA64MMFR0_TGran64_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_TGran64_MASK));
	}' unless defined(&ID_AA64MMFR0_TGran64_VAL);
	eval 'sub ID_AA64MMFR0_TGran64_IMPL () {( &UL(0x) <<  &ID_AA64MMFR0_TGran64_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_IMPL);
	eval 'sub ID_AA64MMFR0_TGran64_NONE () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran64_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_NONE);
	eval 'sub ID_AA64MMFR0_TGran4_SHIFT () {28;}' unless defined(&ID_AA64MMFR0_TGran4_SHIFT);
	eval 'sub ID_AA64MMFR0_TGran4_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_MASK);
	eval 'sub ID_AA64MMFR0_TGran4_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_TGran4_MASK));
	}' unless defined(&ID_AA64MMFR0_TGran4_VAL);
	eval 'sub ID_AA64MMFR0_TGran4_IMPL () {( &UL(0x) <<  &ID_AA64MMFR0_TGran4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_IMPL);
	eval 'sub ID_AA64MMFR0_TGran4_LPA2 () {( &UL(0x1) <<  &ID_AA64MMFR0_TGran4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_LPA2);
	eval 'sub ID_AA64MMFR0_TGran4_NONE () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_NONE);
	eval 'sub ID_AA64MMFR0_TGran16_2_SHIFT () {32;}' unless defined(&ID_AA64MMFR0_TGran16_2_SHIFT);
	eval 'sub ID_AA64MMFR0_TGran16_2_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran16_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_2_MASK);
	eval 'sub ID_AA64MMFR0_TGran16_2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_TGran16_2_MASK));
	}' unless defined(&ID_AA64MMFR0_TGran16_2_VAL);
	eval 'sub ID_AA64MMFR0_TGran16_2_TGran16 () {( &UL(0x) <<  &ID_AA64MMFR0_TGran16_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_2_TGran16);
	eval 'sub ID_AA64MMFR0_TGran16_2_NONE () {( &UL(0x1) <<  &ID_AA64MMFR0_TGran16_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_2_NONE);
	eval 'sub ID_AA64MMFR0_TGran16_2_IMPL () {( &UL(0x2) <<  &ID_AA64MMFR0_TGran16_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_2_IMPL);
	eval 'sub ID_AA64MMFR0_TGran16_2_LPA2 () {( &UL(0x3) <<  &ID_AA64MMFR0_TGran16_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_2_LPA2);
	eval 'sub ID_AA64MMFR0_TGran64_2_SHIFT () {36;}' unless defined(&ID_AA64MMFR0_TGran64_2_SHIFT);
	eval 'sub ID_AA64MMFR0_TGran64_2_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran64_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_2_MASK);
	eval 'sub ID_AA64MMFR0_TGran64_2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_TGran64_2_MASK));
	}' unless defined(&ID_AA64MMFR0_TGran64_2_VAL);
	eval 'sub ID_AA64MMFR0_TGran64_2_TGran64 () {( &UL(0x) <<  &ID_AA64MMFR0_TGran64_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_2_TGran64);
	eval 'sub ID_AA64MMFR0_TGran64_2_NONE () {( &UL(0x1) <<  &ID_AA64MMFR0_TGran64_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_2_NONE);
	eval 'sub ID_AA64MMFR0_TGran64_2_IMPL () {( &UL(0x2) <<  &ID_AA64MMFR0_TGran64_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_2_IMPL);
	eval 'sub ID_AA64MMFR0_TGran4_2_SHIFT () {40;}' unless defined(&ID_AA64MMFR0_TGran4_2_SHIFT);
	eval 'sub ID_AA64MMFR0_TGran4_2_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran4_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_2_MASK);
	eval 'sub ID_AA64MMFR0_TGran4_2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_TGran4_2_MASK));
	}' unless defined(&ID_AA64MMFR0_TGran4_2_VAL);
	eval 'sub ID_AA64MMFR0_TGran4_2_TGran4 () {( &UL(0x) <<  &ID_AA64MMFR0_TGran4_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_2_TGran4);
	eval 'sub ID_AA64MMFR0_TGran4_2_NONE () {( &UL(0x1) <<  &ID_AA64MMFR0_TGran4_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_2_NONE);
	eval 'sub ID_AA64MMFR0_TGran4_2_IMPL () {( &UL(0x2) <<  &ID_AA64MMFR0_TGran4_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_2_IMPL);
	eval 'sub ID_AA64MMFR0_TGran4_2_LPA2 () {( &UL(0x3) <<  &ID_AA64MMFR0_TGran4_2_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_2_LPA2);
	eval 'sub ID_AA64MMFR0_ExS_SHIFT () {44;}' unless defined(&ID_AA64MMFR0_ExS_SHIFT);
	eval 'sub ID_AA64MMFR0_ExS_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_ExS_SHIFT);}' unless defined(&ID_AA64MMFR0_ExS_MASK);
	eval 'sub ID_AA64MMFR0_ExS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_ExS_MASK));
	}' unless defined(&ID_AA64MMFR0_ExS_VAL);
	eval 'sub ID_AA64MMFR0_ExS_ALL () {( &UL(0x) <<  &ID_AA64MMFR0_ExS_SHIFT);}' unless defined(&ID_AA64MMFR0_ExS_ALL);
	eval 'sub ID_AA64MMFR0_ExS_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR0_ExS_SHIFT);}' unless defined(&ID_AA64MMFR0_ExS_IMPL);
	eval 'sub ID_AA64MMFR0_FGT_SHIFT () {56;}' unless defined(&ID_AA64MMFR0_FGT_SHIFT);
	eval 'sub ID_AA64MMFR0_FGT_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_FGT_SHIFT);}' unless defined(&ID_AA64MMFR0_FGT_MASK);
	eval 'sub ID_AA64MMFR0_FGT_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_FGT_MASK));
	}' unless defined(&ID_AA64MMFR0_FGT_VAL);
	eval 'sub ID_AA64MMFR0_FGT_NONE () {( &UL(0x) <<  &ID_AA64MMFR0_FGT_SHIFT);}' unless defined(&ID_AA64MMFR0_FGT_NONE);
	eval 'sub ID_AA64MMFR0_FGT_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR0_FGT_SHIFT);}' unless defined(&ID_AA64MMFR0_FGT_IMPL);
	eval 'sub ID_AA64MMFR0_ECV_SHIFT () {60;}' unless defined(&ID_AA64MMFR0_ECV_SHIFT);
	eval 'sub ID_AA64MMFR0_ECV_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_ECV_SHIFT);}' unless defined(&ID_AA64MMFR0_ECV_MASK);
	eval 'sub ID_AA64MMFR0_ECV_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR0_ECV_MASK));
	}' unless defined(&ID_AA64MMFR0_ECV_VAL);
	eval 'sub ID_AA64MMFR0_ECV_NONE () {( &UL(0x) <<  &ID_AA64MMFR0_ECV_SHIFT);}' unless defined(&ID_AA64MMFR0_ECV_NONE);
	eval 'sub ID_AA64MMFR0_ECV_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR0_ECV_SHIFT);}' unless defined(&ID_AA64MMFR0_ECV_IMPL);
	eval 'sub ID_AA64MMFR0_ECV_CNTHCTL () {( &UL(0x2) <<  &ID_AA64MMFR0_ECV_SHIFT);}' unless defined(&ID_AA64MMFR0_ECV_CNTHCTL);
	eval 'sub ID_AA64MMFR1_EL1 () { &MRS_REG( &ID_AA64MMFR1_EL1);}' unless defined(&ID_AA64MMFR1_EL1);
	eval 'sub ID_AA64MMFR1_EL1_op0 () {3;}' unless defined(&ID_AA64MMFR1_EL1_op0);
	eval 'sub ID_AA64MMFR1_EL1_op1 () {0;}' unless defined(&ID_AA64MMFR1_EL1_op1);
	eval 'sub ID_AA64MMFR1_EL1_CRn () {0;}' unless defined(&ID_AA64MMFR1_EL1_CRn);
	eval 'sub ID_AA64MMFR1_EL1_CRm () {7;}' unless defined(&ID_AA64MMFR1_EL1_CRm);
	eval 'sub ID_AA64MMFR1_EL1_op2 () {1;}' unless defined(&ID_AA64MMFR1_EL1_op2);
	eval 'sub ID_AA64MMFR1_HAFDBS_SHIFT () {0;}' unless defined(&ID_AA64MMFR1_HAFDBS_SHIFT);
	eval 'sub ID_AA64MMFR1_HAFDBS_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_MASK);
	eval 'sub ID_AA64MMFR1_HAFDBS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_HAFDBS_MASK));
	}' unless defined(&ID_AA64MMFR1_HAFDBS_VAL);
	eval 'sub ID_AA64MMFR1_HAFDBS_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_NONE);
	eval 'sub ID_AA64MMFR1_HAFDBS_AF () {( &UL(0x1) <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_AF);
	eval 'sub ID_AA64MMFR1_HAFDBS_AF_DBS () {( &UL(0x2) <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_AF_DBS);
	eval 'sub ID_AA64MMFR1_VMIDBits_SHIFT () {4;}' unless defined(&ID_AA64MMFR1_VMIDBits_SHIFT);
	eval 'sub ID_AA64MMFR1_VMIDBits_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_VMIDBits_SHIFT);}' unless defined(&ID_AA64MMFR1_VMIDBits_MASK);
	eval 'sub ID_AA64MMFR1_VMIDBits_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_VMIDBits_MASK));
	}' unless defined(&ID_AA64MMFR1_VMIDBits_VAL);
	eval 'sub ID_AA64MMFR1_VMIDBits_8 () {( &UL(0x) <<  &ID_AA64MMFR1_VMIDBits_SHIFT);}' unless defined(&ID_AA64MMFR1_VMIDBits_8);
	eval 'sub ID_AA64MMFR1_VMIDBits_16 () {( &UL(0x2) <<  &ID_AA64MMFR1_VMIDBits_SHIFT);}' unless defined(&ID_AA64MMFR1_VMIDBits_16);
	eval 'sub ID_AA64MMFR1_VH_SHIFT () {8;}' unless defined(&ID_AA64MMFR1_VH_SHIFT);
	eval 'sub ID_AA64MMFR1_VH_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_VH_SHIFT);}' unless defined(&ID_AA64MMFR1_VH_MASK);
	eval 'sub ID_AA64MMFR1_VH_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_VH_MASK));
	}' unless defined(&ID_AA64MMFR1_VH_VAL);
	eval 'sub ID_AA64MMFR1_VH_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_VH_SHIFT);}' unless defined(&ID_AA64MMFR1_VH_NONE);
	eval 'sub ID_AA64MMFR1_VH_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_VH_SHIFT);}' unless defined(&ID_AA64MMFR1_VH_IMPL);
	eval 'sub ID_AA64MMFR1_HPDS_SHIFT () {12;}' unless defined(&ID_AA64MMFR1_HPDS_SHIFT);
	eval 'sub ID_AA64MMFR1_HPDS_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_MASK);
	eval 'sub ID_AA64MMFR1_HPDS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_HPDS_MASK));
	}' unless defined(&ID_AA64MMFR1_HPDS_VAL);
	eval 'sub ID_AA64MMFR1_HPDS_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_NONE);
	eval 'sub ID_AA64MMFR1_HPDS_HPD () {( &UL(0x1) <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_HPD);
	eval 'sub ID_AA64MMFR1_HPDS_TTPBHA () {( &UL(0x2) <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_TTPBHA);
	eval 'sub ID_AA64MMFR1_LO_SHIFT () {16;}' unless defined(&ID_AA64MMFR1_LO_SHIFT);
	eval 'sub ID_AA64MMFR1_LO_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_LO_SHIFT);}' unless defined(&ID_AA64MMFR1_LO_MASK);
	eval 'sub ID_AA64MMFR1_LO_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_LO_MASK));
	}' unless defined(&ID_AA64MMFR1_LO_VAL);
	eval 'sub ID_AA64MMFR1_LO_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_LO_SHIFT);}' unless defined(&ID_AA64MMFR1_LO_NONE);
	eval 'sub ID_AA64MMFR1_LO_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_LO_SHIFT);}' unless defined(&ID_AA64MMFR1_LO_IMPL);
	eval 'sub ID_AA64MMFR1_PAN_SHIFT () {20;}' unless defined(&ID_AA64MMFR1_PAN_SHIFT);
	eval 'sub ID_AA64MMFR1_PAN_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_MASK);
	eval 'sub ID_AA64MMFR1_PAN_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_PAN_MASK));
	}' unless defined(&ID_AA64MMFR1_PAN_VAL);
	eval 'sub ID_AA64MMFR1_PAN_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_NONE);
	eval 'sub ID_AA64MMFR1_PAN_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_IMPL);
	eval 'sub ID_AA64MMFR1_PAN_ATS1E1 () {( &UL(0x2) <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_ATS1E1);
	eval 'sub ID_AA64MMFR1_PAN_EPAN () {( &UL(0x2) <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_EPAN);
	eval 'sub ID_AA64MMFR1_SpecSEI_SHIFT () {24;}' unless defined(&ID_AA64MMFR1_SpecSEI_SHIFT);
	eval 'sub ID_AA64MMFR1_SpecSEI_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_SpecSEI_SHIFT);}' unless defined(&ID_AA64MMFR1_SpecSEI_MASK);
	eval 'sub ID_AA64MMFR1_SpecSEI_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_SpecSEI_MASK));
	}' unless defined(&ID_AA64MMFR1_SpecSEI_VAL);
	eval 'sub ID_AA64MMFR1_SpecSEI_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_SpecSEI_SHIFT);}' unless defined(&ID_AA64MMFR1_SpecSEI_NONE);
	eval 'sub ID_AA64MMFR1_SpecSEI_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_SpecSEI_SHIFT);}' unless defined(&ID_AA64MMFR1_SpecSEI_IMPL);
	eval 'sub ID_AA64MMFR1_XNX_SHIFT () {28;}' unless defined(&ID_AA64MMFR1_XNX_SHIFT);
	eval 'sub ID_AA64MMFR1_XNX_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_XNX_SHIFT);}' unless defined(&ID_AA64MMFR1_XNX_MASK);
	eval 'sub ID_AA64MMFR1_XNX_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_XNX_MASK));
	}' unless defined(&ID_AA64MMFR1_XNX_VAL);
	eval 'sub ID_AA64MMFR1_XNX_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_XNX_SHIFT);}' unless defined(&ID_AA64MMFR1_XNX_NONE);
	eval 'sub ID_AA64MMFR1_XNX_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_XNX_SHIFT);}' unless defined(&ID_AA64MMFR1_XNX_IMPL);
	eval 'sub ID_AA64MMFR1_TWED_SHIFT () {32;}' unless defined(&ID_AA64MMFR1_TWED_SHIFT);
	eval 'sub ID_AA64MMFR1_TWED_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_TWED_SHIFT);}' unless defined(&ID_AA64MMFR1_TWED_MASK);
	eval 'sub ID_AA64MMFR1_TWED_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_TWED_MASK));
	}' unless defined(&ID_AA64MMFR1_TWED_VAL);
	eval 'sub ID_AA64MMFR1_TWED_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_TWED_SHIFT);}' unless defined(&ID_AA64MMFR1_TWED_NONE);
	eval 'sub ID_AA64MMFR1_TWED_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_TWED_SHIFT);}' unless defined(&ID_AA64MMFR1_TWED_IMPL);
	eval 'sub ID_AA64MMFR1_ETS_SHIFT () {36;}' unless defined(&ID_AA64MMFR1_ETS_SHIFT);
	eval 'sub ID_AA64MMFR1_ETS_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_ETS_SHIFT);}' unless defined(&ID_AA64MMFR1_ETS_MASK);
	eval 'sub ID_AA64MMFR1_ETS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_ETS_MASK));
	}' unless defined(&ID_AA64MMFR1_ETS_VAL);
	eval 'sub ID_AA64MMFR1_ETS_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_ETS_SHIFT);}' unless defined(&ID_AA64MMFR1_ETS_NONE);
	eval 'sub ID_AA64MMFR1_ETS_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_ETS_SHIFT);}' unless defined(&ID_AA64MMFR1_ETS_IMPL);
	eval 'sub ID_AA64MMFR1_HCX_SHIFT () {40;}' unless defined(&ID_AA64MMFR1_HCX_SHIFT);
	eval 'sub ID_AA64MMFR1_HCX_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_HCX_SHIFT);}' unless defined(&ID_AA64MMFR1_HCX_MASK);
	eval 'sub ID_AA64MMFR1_HCX_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_HCX_MASK));
	}' unless defined(&ID_AA64MMFR1_HCX_VAL);
	eval 'sub ID_AA64MMFR1_HCX_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_HCX_SHIFT);}' unless defined(&ID_AA64MMFR1_HCX_NONE);
	eval 'sub ID_AA64MMFR1_HCX_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_HCX_SHIFT);}' unless defined(&ID_AA64MMFR1_HCX_IMPL);
	eval 'sub ID_AA64MMFR1_AFP_SHIFT () {44;}' unless defined(&ID_AA64MMFR1_AFP_SHIFT);
	eval 'sub ID_AA64MMFR1_AFP_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_AFP_SHIFT);}' unless defined(&ID_AA64MMFR1_AFP_MASK);
	eval 'sub ID_AA64MMFR1_AFP_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_AFP_MASK));
	}' unless defined(&ID_AA64MMFR1_AFP_VAL);
	eval 'sub ID_AA64MMFR1_AFP_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_AFP_SHIFT);}' unless defined(&ID_AA64MMFR1_AFP_NONE);
	eval 'sub ID_AA64MMFR1_AFP_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_AFP_SHIFT);}' unless defined(&ID_AA64MMFR1_AFP_IMPL);
	eval 'sub ID_AA64MMFR1_nTLBPA_SHIFT () {48;}' unless defined(&ID_AA64MMFR1_nTLBPA_SHIFT);
	eval 'sub ID_AA64MMFR1_nTLBPA_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_nTLBPA_SHIFT);}' unless defined(&ID_AA64MMFR1_nTLBPA_MASK);
	eval 'sub ID_AA64MMFR1_nTLBPA_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_nTLBPA_MASK));
	}' unless defined(&ID_AA64MMFR1_nTLBPA_VAL);
	eval 'sub ID_AA64MMFR1_nTLBPA_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_nTLBPA_SHIFT);}' unless defined(&ID_AA64MMFR1_nTLBPA_NONE);
	eval 'sub ID_AA64MMFR1_nTLBPA_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_nTLBPA_SHIFT);}' unless defined(&ID_AA64MMFR1_nTLBPA_IMPL);
	eval 'sub ID_AA64MMFR1_TIDCP1_SHIFT () {52;}' unless defined(&ID_AA64MMFR1_TIDCP1_SHIFT);
	eval 'sub ID_AA64MMFR1_TIDCP1_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_TIDCP1_SHIFT);}' unless defined(&ID_AA64MMFR1_TIDCP1_MASK);
	eval 'sub ID_AA64MMFR1_TIDCP1_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_TIDCP1_MASK));
	}' unless defined(&ID_AA64MMFR1_TIDCP1_VAL);
	eval 'sub ID_AA64MMFR1_TIDCP1_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_TIDCP1_SHIFT);}' unless defined(&ID_AA64MMFR1_TIDCP1_NONE);
	eval 'sub ID_AA64MMFR1_TIDCP1_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_TIDCP1_SHIFT);}' unless defined(&ID_AA64MMFR1_TIDCP1_IMPL);
	eval 'sub ID_AA64MMFR1_CMOVW_SHIFT () {56;}' unless defined(&ID_AA64MMFR1_CMOVW_SHIFT);
	eval 'sub ID_AA64MMFR1_CMOVW_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_CMOVW_SHIFT);}' unless defined(&ID_AA64MMFR1_CMOVW_MASK);
	eval 'sub ID_AA64MMFR1_CMOVW_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR1_CMOVW_MASK));
	}' unless defined(&ID_AA64MMFR1_CMOVW_VAL);
	eval 'sub ID_AA64MMFR1_CMOVW_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_CMOVW_SHIFT);}' unless defined(&ID_AA64MMFR1_CMOVW_NONE);
	eval 'sub ID_AA64MMFR1_CMOVW_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_CMOVW_SHIFT);}' unless defined(&ID_AA64MMFR1_CMOVW_IMPL);
	eval 'sub ID_AA64MMFR2_EL1 () { &MRS_REG( &ID_AA64MMFR2_EL1);}' unless defined(&ID_AA64MMFR2_EL1);
	eval 'sub ID_AA64MMFR2_EL1_op0 () {3;}' unless defined(&ID_AA64MMFR2_EL1_op0);
	eval 'sub ID_AA64MMFR2_EL1_op1 () {0;}' unless defined(&ID_AA64MMFR2_EL1_op1);
	eval 'sub ID_AA64MMFR2_EL1_CRn () {0;}' unless defined(&ID_AA64MMFR2_EL1_CRn);
	eval 'sub ID_AA64MMFR2_EL1_CRm () {7;}' unless defined(&ID_AA64MMFR2_EL1_CRm);
	eval 'sub ID_AA64MMFR2_EL1_op2 () {2;}' unless defined(&ID_AA64MMFR2_EL1_op2);
	eval 'sub ID_AA64MMFR2_CnP_SHIFT () {0;}' unless defined(&ID_AA64MMFR2_CnP_SHIFT);
	eval 'sub ID_AA64MMFR2_CnP_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_CnP_SHIFT);}' unless defined(&ID_AA64MMFR2_CnP_MASK);
	eval 'sub ID_AA64MMFR2_CnP_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_CnP_MASK));
	}' unless defined(&ID_AA64MMFR2_CnP_VAL);
	eval 'sub ID_AA64MMFR2_CnP_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_CnP_SHIFT);}' unless defined(&ID_AA64MMFR2_CnP_NONE);
	eval 'sub ID_AA64MMFR2_CnP_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_CnP_SHIFT);}' unless defined(&ID_AA64MMFR2_CnP_IMPL);
	eval 'sub ID_AA64MMFR2_UAO_SHIFT () {4;}' unless defined(&ID_AA64MMFR2_UAO_SHIFT);
	eval 'sub ID_AA64MMFR2_UAO_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_UAO_SHIFT);}' unless defined(&ID_AA64MMFR2_UAO_MASK);
	eval 'sub ID_AA64MMFR2_UAO_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_UAO_MASK));
	}' unless defined(&ID_AA64MMFR2_UAO_VAL);
	eval 'sub ID_AA64MMFR2_UAO_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_UAO_SHIFT);}' unless defined(&ID_AA64MMFR2_UAO_NONE);
	eval 'sub ID_AA64MMFR2_UAO_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_UAO_SHIFT);}' unless defined(&ID_AA64MMFR2_UAO_IMPL);
	eval 'sub ID_AA64MMFR2_LSM_SHIFT () {8;}' unless defined(&ID_AA64MMFR2_LSM_SHIFT);
	eval 'sub ID_AA64MMFR2_LSM_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_LSM_SHIFT);}' unless defined(&ID_AA64MMFR2_LSM_MASK);
	eval 'sub ID_AA64MMFR2_LSM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_LSM_MASK));
	}' unless defined(&ID_AA64MMFR2_LSM_VAL);
	eval 'sub ID_AA64MMFR2_LSM_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_LSM_SHIFT);}' unless defined(&ID_AA64MMFR2_LSM_NONE);
	eval 'sub ID_AA64MMFR2_LSM_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_LSM_SHIFT);}' unless defined(&ID_AA64MMFR2_LSM_IMPL);
	eval 'sub ID_AA64MMFR2_IESB_SHIFT () {12;}' unless defined(&ID_AA64MMFR2_IESB_SHIFT);
	eval 'sub ID_AA64MMFR2_IESB_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_IESB_SHIFT);}' unless defined(&ID_AA64MMFR2_IESB_MASK);
	eval 'sub ID_AA64MMFR2_IESB_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_IESB_MASK));
	}' unless defined(&ID_AA64MMFR2_IESB_VAL);
	eval 'sub ID_AA64MMFR2_IESB_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_IESB_SHIFT);}' unless defined(&ID_AA64MMFR2_IESB_NONE);
	eval 'sub ID_AA64MMFR2_IESB_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_IESB_SHIFT);}' unless defined(&ID_AA64MMFR2_IESB_IMPL);
	eval 'sub ID_AA64MMFR2_VARange_SHIFT () {16;}' unless defined(&ID_AA64MMFR2_VARange_SHIFT);
	eval 'sub ID_AA64MMFR2_VARange_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_VARange_SHIFT);}' unless defined(&ID_AA64MMFR2_VARange_MASK);
	eval 'sub ID_AA64MMFR2_VARange_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_VARange_MASK));
	}' unless defined(&ID_AA64MMFR2_VARange_VAL);
	eval 'sub ID_AA64MMFR2_VARange_48 () {( &UL(0x) <<  &ID_AA64MMFR2_VARange_SHIFT);}' unless defined(&ID_AA64MMFR2_VARange_48);
	eval 'sub ID_AA64MMFR2_VARange_52 () {( &UL(0x1) <<  &ID_AA64MMFR2_VARange_SHIFT);}' unless defined(&ID_AA64MMFR2_VARange_52);
	eval 'sub ID_AA64MMFR2_CCIDX_SHIFT () {20;}' unless defined(&ID_AA64MMFR2_CCIDX_SHIFT);
	eval 'sub ID_AA64MMFR2_CCIDX_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_CCIDX_SHIFT);}' unless defined(&ID_AA64MMFR2_CCIDX_MASK);
	eval 'sub ID_AA64MMFR2_CCIDX_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_CCIDX_MASK));
	}' unless defined(&ID_AA64MMFR2_CCIDX_VAL);
	eval 'sub ID_AA64MMFR2_CCIDX_32 () {( &UL(0x) <<  &ID_AA64MMFR2_CCIDX_SHIFT);}' unless defined(&ID_AA64MMFR2_CCIDX_32);
	eval 'sub ID_AA64MMFR2_CCIDX_64 () {( &UL(0x1) <<  &ID_AA64MMFR2_CCIDX_SHIFT);}' unless defined(&ID_AA64MMFR2_CCIDX_64);
	eval 'sub ID_AA64MMFR2_NV_SHIFT () {24;}' unless defined(&ID_AA64MMFR2_NV_SHIFT);
	eval 'sub ID_AA64MMFR2_NV_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_NV_SHIFT);}' unless defined(&ID_AA64MMFR2_NV_MASK);
	eval 'sub ID_AA64MMFR2_NV_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_NV_MASK));
	}' unless defined(&ID_AA64MMFR2_NV_VAL);
	eval 'sub ID_AA64MMFR2_NV_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_NV_SHIFT);}' unless defined(&ID_AA64MMFR2_NV_NONE);
	eval 'sub ID_AA64MMFR2_NV_8_3 () {( &UL(0x1) <<  &ID_AA64MMFR2_NV_SHIFT);}' unless defined(&ID_AA64MMFR2_NV_8_3);
	eval 'sub ID_AA64MMFR2_NV_8_4 () {( &UL(0x2) <<  &ID_AA64MMFR2_NV_SHIFT);}' unless defined(&ID_AA64MMFR2_NV_8_4);
	eval 'sub ID_AA64MMFR2_ST_SHIFT () {28;}' unless defined(&ID_AA64MMFR2_ST_SHIFT);
	eval 'sub ID_AA64MMFR2_ST_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_ST_SHIFT);}' unless defined(&ID_AA64MMFR2_ST_MASK);
	eval 'sub ID_AA64MMFR2_ST_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_ST_MASK));
	}' unless defined(&ID_AA64MMFR2_ST_VAL);
	eval 'sub ID_AA64MMFR2_ST_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_ST_SHIFT);}' unless defined(&ID_AA64MMFR2_ST_NONE);
	eval 'sub ID_AA64MMFR2_ST_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_ST_SHIFT);}' unless defined(&ID_AA64MMFR2_ST_IMPL);
	eval 'sub ID_AA64MMFR2_AT_SHIFT () {32;}' unless defined(&ID_AA64MMFR2_AT_SHIFT);
	eval 'sub ID_AA64MMFR2_AT_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_AT_SHIFT);}' unless defined(&ID_AA64MMFR2_AT_MASK);
	eval 'sub ID_AA64MMFR2_AT_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_AT_MASK));
	}' unless defined(&ID_AA64MMFR2_AT_VAL);
	eval 'sub ID_AA64MMFR2_AT_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_AT_SHIFT);}' unless defined(&ID_AA64MMFR2_AT_NONE);
	eval 'sub ID_AA64MMFR2_AT_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_AT_SHIFT);}' unless defined(&ID_AA64MMFR2_AT_IMPL);
	eval 'sub ID_AA64MMFR2_IDS_SHIFT () {36;}' unless defined(&ID_AA64MMFR2_IDS_SHIFT);
	eval 'sub ID_AA64MMFR2_IDS_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_IDS_SHIFT);}' unless defined(&ID_AA64MMFR2_IDS_MASK);
	eval 'sub ID_AA64MMFR2_IDS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_IDS_MASK));
	}' unless defined(&ID_AA64MMFR2_IDS_VAL);
	eval 'sub ID_AA64MMFR2_IDS_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_IDS_SHIFT);}' unless defined(&ID_AA64MMFR2_IDS_NONE);
	eval 'sub ID_AA64MMFR2_IDS_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_IDS_SHIFT);}' unless defined(&ID_AA64MMFR2_IDS_IMPL);
	eval 'sub ID_AA64MMFR2_FWB_SHIFT () {40;}' unless defined(&ID_AA64MMFR2_FWB_SHIFT);
	eval 'sub ID_AA64MMFR2_FWB_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_FWB_SHIFT);}' unless defined(&ID_AA64MMFR2_FWB_MASK);
	eval 'sub ID_AA64MMFR2_FWB_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_FWB_MASK));
	}' unless defined(&ID_AA64MMFR2_FWB_VAL);
	eval 'sub ID_AA64MMFR2_FWB_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_FWB_SHIFT);}' unless defined(&ID_AA64MMFR2_FWB_NONE);
	eval 'sub ID_AA64MMFR2_FWB_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_FWB_SHIFT);}' unless defined(&ID_AA64MMFR2_FWB_IMPL);
	eval 'sub ID_AA64MMFR2_TTL_SHIFT () {48;}' unless defined(&ID_AA64MMFR2_TTL_SHIFT);
	eval 'sub ID_AA64MMFR2_TTL_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_TTL_SHIFT);}' unless defined(&ID_AA64MMFR2_TTL_MASK);
	eval 'sub ID_AA64MMFR2_TTL_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_TTL_MASK));
	}' unless defined(&ID_AA64MMFR2_TTL_VAL);
	eval 'sub ID_AA64MMFR2_TTL_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_TTL_SHIFT);}' unless defined(&ID_AA64MMFR2_TTL_NONE);
	eval 'sub ID_AA64MMFR2_TTL_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_TTL_SHIFT);}' unless defined(&ID_AA64MMFR2_TTL_IMPL);
	eval 'sub ID_AA64MMFR2_BBM_SHIFT () {52;}' unless defined(&ID_AA64MMFR2_BBM_SHIFT);
	eval 'sub ID_AA64MMFR2_BBM_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_BBM_SHIFT);}' unless defined(&ID_AA64MMFR2_BBM_MASK);
	eval 'sub ID_AA64MMFR2_BBM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_BBM_MASK));
	}' unless defined(&ID_AA64MMFR2_BBM_VAL);
	eval 'sub ID_AA64MMFR2_BBM_LEVEL0 () {( &UL(0x) <<  &ID_AA64MMFR2_BBM_SHIFT);}' unless defined(&ID_AA64MMFR2_BBM_LEVEL0);
	eval 'sub ID_AA64MMFR2_BBM_LEVEL1 () {( &UL(0x1) <<  &ID_AA64MMFR2_BBM_SHIFT);}' unless defined(&ID_AA64MMFR2_BBM_LEVEL1);
	eval 'sub ID_AA64MMFR2_BBM_LEVEL2 () {( &UL(0x2) <<  &ID_AA64MMFR2_BBM_SHIFT);}' unless defined(&ID_AA64MMFR2_BBM_LEVEL2);
	eval 'sub ID_AA64MMFR2_EVT_SHIFT () {56;}' unless defined(&ID_AA64MMFR2_EVT_SHIFT);
	eval 'sub ID_AA64MMFR2_EVT_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_EVT_SHIFT);}' unless defined(&ID_AA64MMFR2_EVT_MASK);
	eval 'sub ID_AA64MMFR2_EVT_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_EVT_MASK));
	}' unless defined(&ID_AA64MMFR2_EVT_VAL);
	eval 'sub ID_AA64MMFR2_EVT_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_EVT_SHIFT);}' unless defined(&ID_AA64MMFR2_EVT_NONE);
	eval 'sub ID_AA64MMFR2_EVT_8_2 () {( &UL(0x1) <<  &ID_AA64MMFR2_EVT_SHIFT);}' unless defined(&ID_AA64MMFR2_EVT_8_2);
	eval 'sub ID_AA64MMFR2_EVT_8_5 () {( &UL(0x2) <<  &ID_AA64MMFR2_EVT_SHIFT);}' unless defined(&ID_AA64MMFR2_EVT_8_5);
	eval 'sub ID_AA64MMFR2_E0PD_SHIFT () {60;}' unless defined(&ID_AA64MMFR2_E0PD_SHIFT);
	eval 'sub ID_AA64MMFR2_E0PD_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_E0PD_SHIFT);}' unless defined(&ID_AA64MMFR2_E0PD_MASK);
	eval 'sub ID_AA64MMFR2_E0PD_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR2_E0PD_MASK));
	}' unless defined(&ID_AA64MMFR2_E0PD_VAL);
	eval 'sub ID_AA64MMFR2_E0PD_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_E0PD_SHIFT);}' unless defined(&ID_AA64MMFR2_E0PD_NONE);
	eval 'sub ID_AA64MMFR2_E0PD_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_E0PD_SHIFT);}' unless defined(&ID_AA64MMFR2_E0PD_IMPL);
	eval 'sub ID_AA64MMFR3_EL1 () { &MRS_REG( &ID_AA64MMFR3_EL1);}' unless defined(&ID_AA64MMFR3_EL1);
	eval 'sub ID_AA64MMFR3_EL1_op0 () {3;}' unless defined(&ID_AA64MMFR3_EL1_op0);
	eval 'sub ID_AA64MMFR3_EL1_op1 () {0;}' unless defined(&ID_AA64MMFR3_EL1_op1);
	eval 'sub ID_AA64MMFR3_EL1_CRn () {0;}' unless defined(&ID_AA64MMFR3_EL1_CRn);
	eval 'sub ID_AA64MMFR3_EL1_CRm () {7;}' unless defined(&ID_AA64MMFR3_EL1_CRm);
	eval 'sub ID_AA64MMFR3_EL1_op2 () {3;}' unless defined(&ID_AA64MMFR3_EL1_op2);
	eval 'sub ID_AA64MMFR3_TCRX_SHIFT () {0;}' unless defined(&ID_AA64MMFR3_TCRX_SHIFT);
	eval 'sub ID_AA64MMFR3_TCRX_MASK () {( &UL(0xf) <<  &ID_AA64MMFR3_TCRX_SHIFT);}' unless defined(&ID_AA64MMFR3_TCRX_MASK);
	eval 'sub ID_AA64MMFR3_TCRX_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR3_TCRX_MASK));
	}' unless defined(&ID_AA64MMFR3_TCRX_VAL);
	eval 'sub ID_AA64MMFR3_TCRX_NONE () {( &UL(0x) <<  &ID_AA64MMFR3_TCRX_SHIFT);}' unless defined(&ID_AA64MMFR3_TCRX_NONE);
	eval 'sub ID_AA64MMFR3_TCRX_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR3_TCRX_SHIFT);}' unless defined(&ID_AA64MMFR3_TCRX_IMPL);
	eval 'sub ID_AA64MMFR3_SCTLRX_SHIFT () {4;}' unless defined(&ID_AA64MMFR3_SCTLRX_SHIFT);
	eval 'sub ID_AA64MMFR3_SCTLRX_MASK () {( &UL(0xf) <<  &ID_AA64MMFR3_SCTLRX_SHIFT);}' unless defined(&ID_AA64MMFR3_SCTLRX_MASK);
	eval 'sub ID_AA64MMFR3_SCTLRX_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR3_SCTLRX_MASK));
	}' unless defined(&ID_AA64MMFR3_SCTLRX_VAL);
	eval 'sub ID_AA64MMFR3_SCTLRX_NONE () {( &UL(0x) <<  &ID_AA64MMFR3_SCTLRX_SHIFT);}' unless defined(&ID_AA64MMFR3_SCTLRX_NONE);
	eval 'sub ID_AA64MMFR3_SCTLRX_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR3_SCTLRX_SHIFT);}' unless defined(&ID_AA64MMFR3_SCTLRX_IMPL);
	eval 'sub ID_AA64MMFR3_MEC_SHIFT () {28;}' unless defined(&ID_AA64MMFR3_MEC_SHIFT);
	eval 'sub ID_AA64MMFR3_MEC_MASK () {( &UL(0xf) <<  &ID_AA64MMFR3_MEC_SHIFT);}' unless defined(&ID_AA64MMFR3_MEC_MASK);
	eval 'sub ID_AA64MMFR3_MEC_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR3_MEC_MASK));
	}' unless defined(&ID_AA64MMFR3_MEC_VAL);
	eval 'sub ID_AA64MMFR3_MEC_NONE () {( &UL(0x) <<  &ID_AA64MMFR3_MEC_SHIFT);}' unless defined(&ID_AA64MMFR3_MEC_NONE);
	eval 'sub ID_AA64MMFR3_MEC_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR3_MEC_SHIFT);}' unless defined(&ID_AA64MMFR3_MEC_IMPL);
	eval 'sub ID_AA64MMFR3_Spec_FPACC_SHIFT () {60;}' unless defined(&ID_AA64MMFR3_Spec_FPACC_SHIFT);
	eval 'sub ID_AA64MMFR3_Spec_FPACC_MASK () {( &UL(0xf) <<  &ID_AA64MMFR3_Spec_FPACC_SHIFT);}' unless defined(&ID_AA64MMFR3_Spec_FPACC_MASK);
	eval 'sub ID_AA64MMFR3_Spec_FPACC_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64MMFR3_Spec_FPACC_MASK));
	}' unless defined(&ID_AA64MMFR3_Spec_FPACC_VAL);
	eval 'sub ID_AA64MMFR3_Spec_FPACC_NONE () {( &UL(0x) <<  &ID_AA64MMFR3_Spec_FPACC_SHIFT);}' unless defined(&ID_AA64MMFR3_Spec_FPACC_NONE);
	eval 'sub ID_AA64MMFR3_Spec_FPACC_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR3_Spec_FPACC_SHIFT);}' unless defined(&ID_AA64MMFR3_Spec_FPACC_IMPL);
	eval 'sub ID_AA64MMFR4_EL1 () { &MRS_REG( &ID_AA64MMFR4_EL1);}' unless defined(&ID_AA64MMFR4_EL1);
	eval 'sub ID_AA64MMFR4_EL1_op0 () {3;}' unless defined(&ID_AA64MMFR4_EL1_op0);
	eval 'sub ID_AA64MMFR4_EL1_op1 () {0;}' unless defined(&ID_AA64MMFR4_EL1_op1);
	eval 'sub ID_AA64MMFR4_EL1_CRn () {0;}' unless defined(&ID_AA64MMFR4_EL1_CRn);
	eval 'sub ID_AA64MMFR4_EL1_CRm () {7;}' unless defined(&ID_AA64MMFR4_EL1_CRm);
	eval 'sub ID_AA64MMFR4_EL1_op2 () {4;}' unless defined(&ID_AA64MMFR4_EL1_op2);
	eval 'sub ID_AA64PFR0_EL1 () { &MRS_REG( &ID_AA64PFR0_EL1);}' unless defined(&ID_AA64PFR0_EL1);
	eval 'sub ID_AA64PFR0_EL1_op0 () {3;}' unless defined(&ID_AA64PFR0_EL1_op0);
	eval 'sub ID_AA64PFR0_EL1_op1 () {0;}' unless defined(&ID_AA64PFR0_EL1_op1);
	eval 'sub ID_AA64PFR0_EL1_CRn () {0;}' unless defined(&ID_AA64PFR0_EL1_CRn);
	eval 'sub ID_AA64PFR0_EL1_CRm () {4;}' unless defined(&ID_AA64PFR0_EL1_CRm);
	eval 'sub ID_AA64PFR0_EL1_op2 () {0;}' unless defined(&ID_AA64PFR0_EL1_op2);
	eval 'sub ID_AA64PFR0_EL0_SHIFT () {0;}' unless defined(&ID_AA64PFR0_EL0_SHIFT);
	eval 'sub ID_AA64PFR0_EL0_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_EL0_SHIFT);}' unless defined(&ID_AA64PFR0_EL0_MASK);
	eval 'sub ID_AA64PFR0_EL0_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_EL0_MASK));
	}' unless defined(&ID_AA64PFR0_EL0_VAL);
	eval 'sub ID_AA64PFR0_EL0_64 () {( &UL(0x1) <<  &ID_AA64PFR0_EL0_SHIFT);}' unless defined(&ID_AA64PFR0_EL0_64);
	eval 'sub ID_AA64PFR0_EL0_64_32 () {( &UL(0x2) <<  &ID_AA64PFR0_EL0_SHIFT);}' unless defined(&ID_AA64PFR0_EL0_64_32);
	eval 'sub ID_AA64PFR0_EL1_SHIFT () {4;}' unless defined(&ID_AA64PFR0_EL1_SHIFT);
	eval 'sub ID_AA64PFR0_EL1_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_EL1_SHIFT);}' unless defined(&ID_AA64PFR0_EL1_MASK);
	eval 'sub ID_AA64PFR0_EL1_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_EL1_MASK));
	}' unless defined(&ID_AA64PFR0_EL1_VAL);
	eval 'sub ID_AA64PFR0_EL1_64 () {( &UL(0x1) <<  &ID_AA64PFR0_EL1_SHIFT);}' unless defined(&ID_AA64PFR0_EL1_64);
	eval 'sub ID_AA64PFR0_EL1_64_32 () {( &UL(0x2) <<  &ID_AA64PFR0_EL1_SHIFT);}' unless defined(&ID_AA64PFR0_EL1_64_32);
	eval 'sub ID_AA64PFR0_EL2_SHIFT () {8;}' unless defined(&ID_AA64PFR0_EL2_SHIFT);
	eval 'sub ID_AA64PFR0_EL2_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_MASK);
	eval 'sub ID_AA64PFR0_EL2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_EL2_MASK));
	}' unless defined(&ID_AA64PFR0_EL2_VAL);
	eval 'sub ID_AA64PFR0_EL2_NONE () {( &UL(0x) <<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_NONE);
	eval 'sub ID_AA64PFR0_EL2_64 () {( &UL(0x1) <<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_64);
	eval 'sub ID_AA64PFR0_EL2_64_32 () {( &UL(0x2) <<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_64_32);
	eval 'sub ID_AA64PFR0_EL3_SHIFT () {12;}' unless defined(&ID_AA64PFR0_EL3_SHIFT);
	eval 'sub ID_AA64PFR0_EL3_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_MASK);
	eval 'sub ID_AA64PFR0_EL3_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_EL3_MASK));
	}' unless defined(&ID_AA64PFR0_EL3_VAL);
	eval 'sub ID_AA64PFR0_EL3_NONE () {( &UL(0x) <<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_NONE);
	eval 'sub ID_AA64PFR0_EL3_64 () {( &UL(0x1) <<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_64);
	eval 'sub ID_AA64PFR0_EL3_64_32 () {( &UL(0x2) <<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_64_32);
	eval 'sub ID_AA64PFR0_FP_SHIFT () {16;}' unless defined(&ID_AA64PFR0_FP_SHIFT);
	eval 'sub ID_AA64PFR0_FP_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_MASK);
	eval 'sub ID_AA64PFR0_FP_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_FP_MASK));
	}' unless defined(&ID_AA64PFR0_FP_VAL);
	eval 'sub ID_AA64PFR0_FP_IMPL () {( &UL(0x) <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_IMPL);
	eval 'sub ID_AA64PFR0_FP_HP () {( &UL(0x1) <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_HP);
	eval 'sub ID_AA64PFR0_FP_NONE () {( &UL(0xf) <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_NONE);
	eval 'sub ID_AA64PFR0_AdvSIMD_SHIFT () {20;}' unless defined(&ID_AA64PFR0_AdvSIMD_SHIFT);
	eval 'sub ID_AA64PFR0_AdvSIMD_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_AdvSIMD_SHIFT);}' unless defined(&ID_AA64PFR0_AdvSIMD_MASK);
	eval 'sub ID_AA64PFR0_AdvSIMD_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_AdvSIMD_MASK));
	}' unless defined(&ID_AA64PFR0_AdvSIMD_VAL);
	eval 'sub ID_AA64PFR0_AdvSIMD_IMPL () {( &UL(0x) <<  &ID_AA64PFR0_AdvSIMD_SHIFT);}' unless defined(&ID_AA64PFR0_AdvSIMD_IMPL);
	eval 'sub ID_AA64PFR0_AdvSIMD_HP () {( &UL(0x1) <<  &ID_AA64PFR0_AdvSIMD_SHIFT);}' unless defined(&ID_AA64PFR0_AdvSIMD_HP);
	eval 'sub ID_AA64PFR0_AdvSIMD_NONE () {( &UL(0xf) <<  &ID_AA64PFR0_AdvSIMD_SHIFT);}' unless defined(&ID_AA64PFR0_AdvSIMD_NONE);
	eval 'sub ID_AA64PFR0_GIC_BITS () {0x4;}' unless defined(&ID_AA64PFR0_GIC_BITS);
	eval 'sub ID_AA64PFR0_GIC_SHIFT () {24;}' unless defined(&ID_AA64PFR0_GIC_SHIFT);
	eval 'sub ID_AA64PFR0_GIC_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_MASK);
	eval 'sub ID_AA64PFR0_GIC_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_GIC_MASK));
	}' unless defined(&ID_AA64PFR0_GIC_VAL);
	eval 'sub ID_AA64PFR0_GIC_CPUIF_NONE () {( &UL(0x) <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_CPUIF_NONE);
	eval 'sub ID_AA64PFR0_GIC_CPUIF_EN () {( &UL(0x1) <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_CPUIF_EN);
	eval 'sub ID_AA64PFR0_GIC_CPUIF_4_1 () {( &UL(0x3) <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_CPUIF_4_1);
	eval 'sub ID_AA64PFR0_RAS_SHIFT () {28;}' unless defined(&ID_AA64PFR0_RAS_SHIFT);
	eval 'sub ID_AA64PFR0_RAS_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_RAS_SHIFT);}' unless defined(&ID_AA64PFR0_RAS_MASK);
	eval 'sub ID_AA64PFR0_RAS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_RAS_MASK));
	}' unless defined(&ID_AA64PFR0_RAS_VAL);
	eval 'sub ID_AA64PFR0_RAS_NONE () {( &UL(0x) <<  &ID_AA64PFR0_RAS_SHIFT);}' unless defined(&ID_AA64PFR0_RAS_NONE);
	eval 'sub ID_AA64PFR0_RAS_IMPL () {( &UL(0x1) <<  &ID_AA64PFR0_RAS_SHIFT);}' unless defined(&ID_AA64PFR0_RAS_IMPL);
	eval 'sub ID_AA64PFR0_RAS_8_4 () {( &UL(0x2) <<  &ID_AA64PFR0_RAS_SHIFT);}' unless defined(&ID_AA64PFR0_RAS_8_4);
	eval 'sub ID_AA64PFR0_SVE_SHIFT () {32;}' unless defined(&ID_AA64PFR0_SVE_SHIFT);
	eval 'sub ID_AA64PFR0_SVE_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_SVE_SHIFT);}' unless defined(&ID_AA64PFR0_SVE_MASK);
	eval 'sub ID_AA64PFR0_SVE_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_SVE_MASK));
	}' unless defined(&ID_AA64PFR0_SVE_VAL);
	eval 'sub ID_AA64PFR0_SVE_NONE () {( &UL(0x) <<  &ID_AA64PFR0_SVE_SHIFT);}' unless defined(&ID_AA64PFR0_SVE_NONE);
	eval 'sub ID_AA64PFR0_SVE_IMPL () {( &UL(0x1) <<  &ID_AA64PFR0_SVE_SHIFT);}' unless defined(&ID_AA64PFR0_SVE_IMPL);
	eval 'sub ID_AA64PFR0_SEL2_SHIFT () {36;}' unless defined(&ID_AA64PFR0_SEL2_SHIFT);
	eval 'sub ID_AA64PFR0_SEL2_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_SEL2_SHIFT);}' unless defined(&ID_AA64PFR0_SEL2_MASK);
	eval 'sub ID_AA64PFR0_SEL2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_SEL2_MASK));
	}' unless defined(&ID_AA64PFR0_SEL2_VAL);
	eval 'sub ID_AA64PFR0_SEL2_NONE () {( &UL(0x) <<  &ID_AA64PFR0_SEL2_SHIFT);}' unless defined(&ID_AA64PFR0_SEL2_NONE);
	eval 'sub ID_AA64PFR0_SEL2_IMPL () {( &UL(0x1) <<  &ID_AA64PFR0_SEL2_SHIFT);}' unless defined(&ID_AA64PFR0_SEL2_IMPL);
	eval 'sub ID_AA64PFR0_MPAM_SHIFT () {40;}' unless defined(&ID_AA64PFR0_MPAM_SHIFT);
	eval 'sub ID_AA64PFR0_MPAM_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_MPAM_SHIFT);}' unless defined(&ID_AA64PFR0_MPAM_MASK);
	eval 'sub ID_AA64PFR0_MPAM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_MPAM_MASK));
	}' unless defined(&ID_AA64PFR0_MPAM_VAL);
	eval 'sub ID_AA64PFR0_MPAM_NONE () {( &UL(0x) <<  &ID_AA64PFR0_MPAM_SHIFT);}' unless defined(&ID_AA64PFR0_MPAM_NONE);
	eval 'sub ID_AA64PFR0_MPAM_IMPL () {( &UL(0x1) <<  &ID_AA64PFR0_MPAM_SHIFT);}' unless defined(&ID_AA64PFR0_MPAM_IMPL);
	eval 'sub ID_AA64PFR0_AMU_SHIFT () {44;}' unless defined(&ID_AA64PFR0_AMU_SHIFT);
	eval 'sub ID_AA64PFR0_AMU_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_AMU_SHIFT);}' unless defined(&ID_AA64PFR0_AMU_MASK);
	eval 'sub ID_AA64PFR0_AMU_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_AMU_MASK));
	}' unless defined(&ID_AA64PFR0_AMU_VAL);
	eval 'sub ID_AA64PFR0_AMU_NONE () {( &UL(0x) <<  &ID_AA64PFR0_AMU_SHIFT);}' unless defined(&ID_AA64PFR0_AMU_NONE);
	eval 'sub ID_AA64PFR0_AMU_V1 () {( &UL(0x1) <<  &ID_AA64PFR0_AMU_SHIFT);}' unless defined(&ID_AA64PFR0_AMU_V1);
	eval 'sub ID_AA64PFR0_AMU_V1_1 () {( &UL(0x2) <<  &ID_AA64PFR0_AMU_SHIFT);}' unless defined(&ID_AA64PFR0_AMU_V1_1);
	eval 'sub ID_AA64PFR0_DIT_SHIFT () {48;}' unless defined(&ID_AA64PFR0_DIT_SHIFT);
	eval 'sub ID_AA64PFR0_DIT_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_DIT_SHIFT);}' unless defined(&ID_AA64PFR0_DIT_MASK);
	eval 'sub ID_AA64PFR0_DIT_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_DIT_MASK));
	}' unless defined(&ID_AA64PFR0_DIT_VAL);
	eval 'sub ID_AA64PFR0_DIT_NONE () {( &UL(0x) <<  &ID_AA64PFR0_DIT_SHIFT);}' unless defined(&ID_AA64PFR0_DIT_NONE);
	eval 'sub ID_AA64PFR0_DIT_PSTATE () {( &UL(0x1) <<  &ID_AA64PFR0_DIT_SHIFT);}' unless defined(&ID_AA64PFR0_DIT_PSTATE);
	eval 'sub ID_AA64PFR0_RME_SHIFT () {52;}' unless defined(&ID_AA64PFR0_RME_SHIFT);
	eval 'sub ID_AA64PFR0_RME_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_RME_SHIFT);}' unless defined(&ID_AA64PFR0_RME_MASK);
	eval 'sub ID_AA64PFR0_RME_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_RME_MASK));
	}' unless defined(&ID_AA64PFR0_RME_VAL);
	eval 'sub ID_AA64PFR0_RME_NONE () {( &UL(0x) <<  &ID_AA64PFR0_RME_SHIFT);}' unless defined(&ID_AA64PFR0_RME_NONE);
	eval 'sub ID_AA64PFR0_RME_IMPL () {( &UL(0x1) <<  &ID_AA64PFR0_RME_SHIFT);}' unless defined(&ID_AA64PFR0_RME_IMPL);
	eval 'sub ID_AA64PFR0_CSV2_SHIFT () {56;}' unless defined(&ID_AA64PFR0_CSV2_SHIFT);
	eval 'sub ID_AA64PFR0_CSV2_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_CSV2_SHIFT);}' unless defined(&ID_AA64PFR0_CSV2_MASK);
	eval 'sub ID_AA64PFR0_CSV2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_CSV2_MASK));
	}' unless defined(&ID_AA64PFR0_CSV2_VAL);
	eval 'sub ID_AA64PFR0_CSV2_NONE () {( &UL(0x) <<  &ID_AA64PFR0_CSV2_SHIFT);}' unless defined(&ID_AA64PFR0_CSV2_NONE);
	eval 'sub ID_AA64PFR0_CSV2_ISOLATED () {( &UL(0x1) <<  &ID_AA64PFR0_CSV2_SHIFT);}' unless defined(&ID_AA64PFR0_CSV2_ISOLATED);
	eval 'sub ID_AA64PFR0_CSV2_SCXTNUM () {( &UL(0x2) <<  &ID_AA64PFR0_CSV2_SHIFT);}' unless defined(&ID_AA64PFR0_CSV2_SCXTNUM);
	eval 'sub ID_AA64PFR0_CSV2_3 () {( &UL(0x3) <<  &ID_AA64PFR0_CSV2_SHIFT);}' unless defined(&ID_AA64PFR0_CSV2_3);
	eval 'sub ID_AA64PFR0_CSV3_SHIFT () {60;}' unless defined(&ID_AA64PFR0_CSV3_SHIFT);
	eval 'sub ID_AA64PFR0_CSV3_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_CSV3_SHIFT);}' unless defined(&ID_AA64PFR0_CSV3_MASK);
	eval 'sub ID_AA64PFR0_CSV3_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR0_CSV3_MASK));
	}' unless defined(&ID_AA64PFR0_CSV3_VAL);
	eval 'sub ID_AA64PFR0_CSV3_NONE () {( &UL(0x) <<  &ID_AA64PFR0_CSV3_SHIFT);}' unless defined(&ID_AA64PFR0_CSV3_NONE);
	eval 'sub ID_AA64PFR0_CSV3_ISOLATED () {( &UL(0x1) <<  &ID_AA64PFR0_CSV3_SHIFT);}' unless defined(&ID_AA64PFR0_CSV3_ISOLATED);
	eval 'sub ID_AA64PFR1_EL1 () { &MRS_REG( &ID_AA64PFR1_EL1);}' unless defined(&ID_AA64PFR1_EL1);
	eval 'sub ID_AA64PFR1_EL1_op0 () {3;}' unless defined(&ID_AA64PFR1_EL1_op0);
	eval 'sub ID_AA64PFR1_EL1_op1 () {0;}' unless defined(&ID_AA64PFR1_EL1_op1);
	eval 'sub ID_AA64PFR1_EL1_CRn () {0;}' unless defined(&ID_AA64PFR1_EL1_CRn);
	eval 'sub ID_AA64PFR1_EL1_CRm () {4;}' unless defined(&ID_AA64PFR1_EL1_CRm);
	eval 'sub ID_AA64PFR1_EL1_op2 () {1;}' unless defined(&ID_AA64PFR1_EL1_op2);
	eval 'sub ID_AA64PFR1_BT_SHIFT () {0;}' unless defined(&ID_AA64PFR1_BT_SHIFT);
	eval 'sub ID_AA64PFR1_BT_MASK () {( &UL(0xf) <<  &ID_AA64PFR1_BT_SHIFT);}' unless defined(&ID_AA64PFR1_BT_MASK);
	eval 'sub ID_AA64PFR1_BT_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR1_BT_MASK));
	}' unless defined(&ID_AA64PFR1_BT_VAL);
	eval 'sub ID_AA64PFR1_BT_NONE () {( &UL(0x) <<  &ID_AA64PFR1_BT_SHIFT);}' unless defined(&ID_AA64PFR1_BT_NONE);
	eval 'sub ID_AA64PFR1_BT_IMPL () {( &UL(0x1) <<  &ID_AA64PFR1_BT_SHIFT);}' unless defined(&ID_AA64PFR1_BT_IMPL);
	eval 'sub ID_AA64PFR1_SSBS_SHIFT () {4;}' unless defined(&ID_AA64PFR1_SSBS_SHIFT);
	eval 'sub ID_AA64PFR1_SSBS_MASK () {( &UL(0xf) <<  &ID_AA64PFR1_SSBS_SHIFT);}' unless defined(&ID_AA64PFR1_SSBS_MASK);
	eval 'sub ID_AA64PFR1_SSBS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR1_SSBS_MASK));
	}' unless defined(&ID_AA64PFR1_SSBS_VAL);
	eval 'sub ID_AA64PFR1_SSBS_NONE () {( &UL(0x) <<  &ID_AA64PFR1_SSBS_SHIFT);}' unless defined(&ID_AA64PFR1_SSBS_NONE);
	eval 'sub ID_AA64PFR1_SSBS_PSTATE () {( &UL(0x1) <<  &ID_AA64PFR1_SSBS_SHIFT);}' unless defined(&ID_AA64PFR1_SSBS_PSTATE);
	eval 'sub ID_AA64PFR1_SSBS_PSTATE_MSR () {( &UL(0x2) <<  &ID_AA64PFR1_SSBS_SHIFT);}' unless defined(&ID_AA64PFR1_SSBS_PSTATE_MSR);
	eval 'sub ID_AA64PFR1_MTE_SHIFT () {8;}' unless defined(&ID_AA64PFR1_MTE_SHIFT);
	eval 'sub ID_AA64PFR1_MTE_MASK () {( &UL(0xf) <<  &ID_AA64PFR1_MTE_SHIFT);}' unless defined(&ID_AA64PFR1_MTE_MASK);
	eval 'sub ID_AA64PFR1_MTE_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR1_MTE_MASK));
	}' unless defined(&ID_AA64PFR1_MTE_VAL);
	eval 'sub ID_AA64PFR1_MTE_NONE () {( &UL(0x) <<  &ID_AA64PFR1_MTE_SHIFT);}' unless defined(&ID_AA64PFR1_MTE_NONE);
	eval 'sub ID_AA64PFR1_MTE_MTE () {( &UL(0x1) <<  &ID_AA64PFR1_MTE_SHIFT);}' unless defined(&ID_AA64PFR1_MTE_MTE);
	eval 'sub ID_AA64PFR1_MTE_MTE2 () {( &UL(0x2) <<  &ID_AA64PFR1_MTE_SHIFT);}' unless defined(&ID_AA64PFR1_MTE_MTE2);
	eval 'sub ID_AA64PFR1_MTE_MTE3 () {( &UL(0x3) <<  &ID_AA64PFR1_MTE_SHIFT);}' unless defined(&ID_AA64PFR1_MTE_MTE3);
	eval 'sub ID_AA64PFR1_RAS_frac_SHIFT () {12;}' unless defined(&ID_AA64PFR1_RAS_frac_SHIFT);
	eval 'sub ID_AA64PFR1_RAS_frac_MASK () {( &UL(0xf) <<  &ID_AA64PFR1_RAS_frac_SHIFT);}' unless defined(&ID_AA64PFR1_RAS_frac_MASK);
	eval 'sub ID_AA64PFR1_RAS_frac_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR1_RAS_frac_MASK));
	}' unless defined(&ID_AA64PFR1_RAS_frac_VAL);
	eval 'sub ID_AA64PFR1_RAS_frac_p0 () {( &UL(0x) <<  &ID_AA64PFR1_RAS_frac_SHIFT);}' unless defined(&ID_AA64PFR1_RAS_frac_p0);
	eval 'sub ID_AA64PFR1_RAS_frac_p1 () {( &UL(0x1) <<  &ID_AA64PFR1_RAS_frac_SHIFT);}' unless defined(&ID_AA64PFR1_RAS_frac_p1);
	eval 'sub ID_AA64PFR1_MPAM_frac_SHIFT () {16;}' unless defined(&ID_AA64PFR1_MPAM_frac_SHIFT);
	eval 'sub ID_AA64PFR1_MPAM_frac_MASK () {( &UL(0xf) <<  &ID_AA64PFR1_MPAM_frac_SHIFT);}' unless defined(&ID_AA64PFR1_MPAM_frac_MASK);
	eval 'sub ID_AA64PFR1_MPAM_frac_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR1_MPAM_frac_MASK));
	}' unless defined(&ID_AA64PFR1_MPAM_frac_VAL);
	eval 'sub ID_AA64PFR1_MPAM_frac_p0 () {( &UL(0x) <<  &ID_AA64PFR1_MPAM_frac_SHIFT);}' unless defined(&ID_AA64PFR1_MPAM_frac_p0);
	eval 'sub ID_AA64PFR1_MPAM_frac_p1 () {( &UL(0x1) <<  &ID_AA64PFR1_MPAM_frac_SHIFT);}' unless defined(&ID_AA64PFR1_MPAM_frac_p1);
	eval 'sub ID_AA64PFR1_SME_SHIFT () {24;}' unless defined(&ID_AA64PFR1_SME_SHIFT);
	eval 'sub ID_AA64PFR1_SME_MASK () {( &UL(0xf) <<  &ID_AA64PFR1_SME_SHIFT);}' unless defined(&ID_AA64PFR1_SME_MASK);
	eval 'sub ID_AA64PFR1_SME_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR1_SME_MASK));
	}' unless defined(&ID_AA64PFR1_SME_VAL);
	eval 'sub ID_AA64PFR1_SME_NONE () {( &UL(0x) <<  &ID_AA64PFR1_SME_SHIFT);}' unless defined(&ID_AA64PFR1_SME_NONE);
	eval 'sub ID_AA64PFR1_SME_SME () {( &UL(0x1) <<  &ID_AA64PFR1_SME_SHIFT);}' unless defined(&ID_AA64PFR1_SME_SME);
	eval 'sub ID_AA64PFR1_SME_SME2 () {( &UL(0x2) <<  &ID_AA64PFR1_SME_SHIFT);}' unless defined(&ID_AA64PFR1_SME_SME2);
	eval 'sub ID_AA64PFR1_RNDR_trap_SHIFT () {28;}' unless defined(&ID_AA64PFR1_RNDR_trap_SHIFT);
	eval 'sub ID_AA64PFR1_RNDR_trap_MASK () {( &UL(0xf) <<  &ID_AA64PFR1_RNDR_trap_SHIFT);}' unless defined(&ID_AA64PFR1_RNDR_trap_MASK);
	eval 'sub ID_AA64PFR1_RNDR_trap_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR1_RNDR_trap_MASK));
	}' unless defined(&ID_AA64PFR1_RNDR_trap_VAL);
	eval 'sub ID_AA64PFR1_RNDR_trap_NONE () {( &UL(0x) <<  &ID_AA64PFR1_RNDR_trap_SHIFT);}' unless defined(&ID_AA64PFR1_RNDR_trap_NONE);
	eval 'sub ID_AA64PFR1_RNDR_trap_IMPL () {( &UL(0x1) <<  &ID_AA64PFR1_RNDR_trap_SHIFT);}' unless defined(&ID_AA64PFR1_RNDR_trap_IMPL);
	eval 'sub ID_AA64PFR1_CSV2_frac_SHIFT () {32;}' unless defined(&ID_AA64PFR1_CSV2_frac_SHIFT);
	eval 'sub ID_AA64PFR1_CSV2_frac_MASK () {( &UL(0xf) <<  &ID_AA64PFR1_CSV2_frac_SHIFT);}' unless defined(&ID_AA64PFR1_CSV2_frac_MASK);
	eval 'sub ID_AA64PFR1_CSV2_frac_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR1_CSV2_frac_MASK));
	}' unless defined(&ID_AA64PFR1_CSV2_frac_VAL);
	eval 'sub ID_AA64PFR1_CSV2_frac_p0 () {( &UL(0x) <<  &ID_AA64PFR1_CSV2_frac_SHIFT);}' unless defined(&ID_AA64PFR1_CSV2_frac_p0);
	eval 'sub ID_AA64PFR1_CSV2_frac_p1 () {( &UL(0x1) <<  &ID_AA64PFR1_CSV2_frac_SHIFT);}' unless defined(&ID_AA64PFR1_CSV2_frac_p1);
	eval 'sub ID_AA64PFR1_CSV2_frac_p2 () {( &UL(0x2) <<  &ID_AA64PFR1_CSV2_frac_SHIFT);}' unless defined(&ID_AA64PFR1_CSV2_frac_p2);
	eval 'sub ID_AA64PFR1_NMI_SHIFT () {36;}' unless defined(&ID_AA64PFR1_NMI_SHIFT);
	eval 'sub ID_AA64PFR1_NMI_MASK () {( &UL(0xf) <<  &ID_AA64PFR1_NMI_SHIFT);}' unless defined(&ID_AA64PFR1_NMI_MASK);
	eval 'sub ID_AA64PFR1_NMI_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64PFR1_NMI_MASK));
	}' unless defined(&ID_AA64PFR1_NMI_VAL);
	eval 'sub ID_AA64PFR1_NMI_NONE () {( &UL(0x) <<  &ID_AA64PFR1_NMI_SHIFT);}' unless defined(&ID_AA64PFR1_NMI_NONE);
	eval 'sub ID_AA64PFR1_NMI_IMPL () {( &UL(0x1) <<  &ID_AA64PFR1_NMI_SHIFT);}' unless defined(&ID_AA64PFR1_NMI_IMPL);
	eval 'sub ID_AA64PFR2_EL1 () { &MRS_REG( &ID_AA64PFR2_EL1);}' unless defined(&ID_AA64PFR2_EL1);
	eval 'sub ID_AA64PFR2_EL1_op0 () {3;}' unless defined(&ID_AA64PFR2_EL1_op0);
	eval 'sub ID_AA64PFR2_EL1_op1 () {0;}' unless defined(&ID_AA64PFR2_EL1_op1);
	eval 'sub ID_AA64PFR2_EL1_CRn () {0;}' unless defined(&ID_AA64PFR2_EL1_CRn);
	eval 'sub ID_AA64PFR2_EL1_CRm () {4;}' unless defined(&ID_AA64PFR2_EL1_CRm);
	eval 'sub ID_AA64PFR2_EL1_op2 () {2;}' unless defined(&ID_AA64PFR2_EL1_op2);
	eval 'sub ID_AA64ZFR0_EL1 () { &MRS_REG( &ID_AA64ZFR0_EL1);}' unless defined(&ID_AA64ZFR0_EL1);
	eval 'sub ID_AA64ZFR0_EL1_REG () { &MRS_REG_ALT_NAME( &ID_AA64ZFR0_EL1);}' unless defined(&ID_AA64ZFR0_EL1_REG);
	eval 'sub ID_AA64ZFR0_EL1_op0 () {3;}' unless defined(&ID_AA64ZFR0_EL1_op0);
	eval 'sub ID_AA64ZFR0_EL1_op1 () {0;}' unless defined(&ID_AA64ZFR0_EL1_op1);
	eval 'sub ID_AA64ZFR0_EL1_CRn () {0;}' unless defined(&ID_AA64ZFR0_EL1_CRn);
	eval 'sub ID_AA64ZFR0_EL1_CRm () {4;}' unless defined(&ID_AA64ZFR0_EL1_CRm);
	eval 'sub ID_AA64ZFR0_EL1_op2 () {4;}' unless defined(&ID_AA64ZFR0_EL1_op2);
	eval 'sub ID_AA64ZFR0_SVEver_SHIFT () {0;}' unless defined(&ID_AA64ZFR0_SVEver_SHIFT);
	eval 'sub ID_AA64ZFR0_SVEver_MASK () {( &UL(0xf) <<  &ID_AA64ZFR0_SVEver_SHIFT);}' unless defined(&ID_AA64ZFR0_SVEver_MASK);
	eval 'sub ID_AA64ZFR0_SVEver_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ZFR0_SVEver_MASK);
	}' unless defined(&ID_AA64ZFR0_SVEver_VAL);
	eval 'sub ID_AA64ZFR0_SVEver_SVE1 () {( &UL(0x) <<  &ID_AA64ZFR0_SVEver_SHIFT);}' unless defined(&ID_AA64ZFR0_SVEver_SVE1);
	eval 'sub ID_AA64ZFR0_SVEver_SVE2 () {( &UL(0x1) <<  &ID_AA64ZFR0_SVEver_SHIFT);}' unless defined(&ID_AA64ZFR0_SVEver_SVE2);
	eval 'sub ID_AA64ZFR0_AES_SHIFT () {4;}' unless defined(&ID_AA64ZFR0_AES_SHIFT);
	eval 'sub ID_AA64ZFR0_AES_MASK () {( &UL(0xf) <<  &ID_AA64ZFR0_AES_SHIFT);}' unless defined(&ID_AA64ZFR0_AES_MASK);
	eval 'sub ID_AA64ZFR0_AES_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ZFR0_AES_MASK);
	}' unless defined(&ID_AA64ZFR0_AES_VAL);
	eval 'sub ID_AA64ZFR0_AES_NONE () {( &UL(0x) <<  &ID_AA64ZFR0_AES_SHIFT);}' unless defined(&ID_AA64ZFR0_AES_NONE);
	eval 'sub ID_AA64ZFR0_AES_BASE () {( &UL(0x1) <<  &ID_AA64ZFR0_AES_SHIFT);}' unless defined(&ID_AA64ZFR0_AES_BASE);
	eval 'sub ID_AA64ZFR0_AES_PMULL () {( &UL(0x2) <<  &ID_AA64ZFR0_AES_SHIFT);}' unless defined(&ID_AA64ZFR0_AES_PMULL);
	eval 'sub ID_AA64ZFR0_BitPerm_SHIFT () {16;}' unless defined(&ID_AA64ZFR0_BitPerm_SHIFT);
	eval 'sub ID_AA64ZFR0_BitPerm_MASK () {( &UL(0xf) <<  &ID_AA64ZFR0_BitPerm_SHIFT);}' unless defined(&ID_AA64ZFR0_BitPerm_MASK);
	eval 'sub ID_AA64ZFR0_BitPerm_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ZFR0_BitPerm_MASK);
	}' unless defined(&ID_AA64ZFR0_BitPerm_VAL);
	eval 'sub ID_AA64ZFR0_BitPerm_NONE () {( &UL(0x) <<  &ID_AA64ZFR0_BitPerm_SHIFT);}' unless defined(&ID_AA64ZFR0_BitPerm_NONE);
	eval 'sub ID_AA64ZFR0_BitPerm_IMPL () {( &UL(0x1) <<  &ID_AA64ZFR0_BitPerm_SHIFT);}' unless defined(&ID_AA64ZFR0_BitPerm_IMPL);
	eval 'sub ID_AA64ZFR0_BF16_SHIFT () {20;}' unless defined(&ID_AA64ZFR0_BF16_SHIFT);
	eval 'sub ID_AA64ZFR0_BF16_MASK () {( &UL(0xf) <<  &ID_AA64ZFR0_BF16_SHIFT);}' unless defined(&ID_AA64ZFR0_BF16_MASK);
	eval 'sub ID_AA64ZFR0_BF16_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ZFR0_BF16_MASK);
	}' unless defined(&ID_AA64ZFR0_BF16_VAL);
	eval 'sub ID_AA64ZFR0_BF16_NONE () {( &UL(0x) <<  &ID_AA64ZFR0_BF16_SHIFT);}' unless defined(&ID_AA64ZFR0_BF16_NONE);
	eval 'sub ID_AA64ZFR0_BF16_BASE () {( &UL(0x1) <<  &ID_AA64ZFR0_BF16_SHIFT);}' unless defined(&ID_AA64ZFR0_BF16_BASE);
	eval 'sub ID_AA64ZFR0_BF16_EBF () {( &UL(0x1) <<  &ID_AA64ZFR0_BF16_SHIFT);}' unless defined(&ID_AA64ZFR0_BF16_EBF);
	eval 'sub ID_AA64ZFR0_SHA3_SHIFT () {32;}' unless defined(&ID_AA64ZFR0_SHA3_SHIFT);
	eval 'sub ID_AA64ZFR0_SHA3_MASK () {( &UL(0xf) <<  &ID_AA64ZFR0_SHA3_SHIFT);}' unless defined(&ID_AA64ZFR0_SHA3_MASK);
	eval 'sub ID_AA64ZFR0_SHA3_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ZFR0_SHA3_MASK);
	}' unless defined(&ID_AA64ZFR0_SHA3_VAL);
	eval 'sub ID_AA64ZFR0_SHA3_NONE () {( &UL(0x) <<  &ID_AA64ZFR0_SHA3_SHIFT);}' unless defined(&ID_AA64ZFR0_SHA3_NONE);
	eval 'sub ID_AA64ZFR0_SHA3_IMPL () {( &UL(0x1) <<  &ID_AA64ZFR0_SHA3_SHIFT);}' unless defined(&ID_AA64ZFR0_SHA3_IMPL);
	eval 'sub ID_AA64ZFR0_SM4_SHIFT () {40;}' unless defined(&ID_AA64ZFR0_SM4_SHIFT);
	eval 'sub ID_AA64ZFR0_SM4_MASK () {( &UL(0xf) <<  &ID_AA64ZFR0_SM4_SHIFT);}' unless defined(&ID_AA64ZFR0_SM4_MASK);
	eval 'sub ID_AA64ZFR0_SM4_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ZFR0_SM4_MASK);
	}' unless defined(&ID_AA64ZFR0_SM4_VAL);
	eval 'sub ID_AA64ZFR0_SM4_NONE () {( &UL(0x) <<  &ID_AA64ZFR0_SM4_SHIFT);}' unless defined(&ID_AA64ZFR0_SM4_NONE);
	eval 'sub ID_AA64ZFR0_SM4_IMPL () {( &UL(0x1) <<  &ID_AA64ZFR0_SM4_SHIFT);}' unless defined(&ID_AA64ZFR0_SM4_IMPL);
	eval 'sub ID_AA64ZFR0_I8MM_SHIFT () {44;}' unless defined(&ID_AA64ZFR0_I8MM_SHIFT);
	eval 'sub ID_AA64ZFR0_I8MM_MASK () {( &UL(0xf) <<  &ID_AA64ZFR0_I8MM_SHIFT);}' unless defined(&ID_AA64ZFR0_I8MM_MASK);
	eval 'sub ID_AA64ZFR0_I8MM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ZFR0_I8MM_MASK);
	}' unless defined(&ID_AA64ZFR0_I8MM_VAL);
	eval 'sub ID_AA64ZFR0_I8MM_NONE () {( &UL(0x) <<  &ID_AA64ZFR0_I8MM_SHIFT);}' unless defined(&ID_AA64ZFR0_I8MM_NONE);
	eval 'sub ID_AA64ZFR0_I8MM_IMPL () {( &UL(0x1) <<  &ID_AA64ZFR0_I8MM_SHIFT);}' unless defined(&ID_AA64ZFR0_I8MM_IMPL);
	eval 'sub ID_AA64ZFR0_F32MM_SHIFT () {52;}' unless defined(&ID_AA64ZFR0_F32MM_SHIFT);
	eval 'sub ID_AA64ZFR0_F32MM_MASK () {( &UL(0xf) <<  &ID_AA64ZFR0_F32MM_SHIFT);}' unless defined(&ID_AA64ZFR0_F32MM_MASK);
	eval 'sub ID_AA64ZFR0_F32MM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ZFR0_F32MM_MASK);
	}' unless defined(&ID_AA64ZFR0_F32MM_VAL);
	eval 'sub ID_AA64ZFR0_F32MM_NONE () {( &UL(0x) <<  &ID_AA64ZFR0_F32MM_SHIFT);}' unless defined(&ID_AA64ZFR0_F32MM_NONE);
	eval 'sub ID_AA64ZFR0_F32MM_IMPL () {( &UL(0x1) <<  &ID_AA64ZFR0_F32MM_SHIFT);}' unless defined(&ID_AA64ZFR0_F32MM_IMPL);
	eval 'sub ID_AA64ZFR0_F64MM_SHIFT () {56;}' unless defined(&ID_AA64ZFR0_F64MM_SHIFT);
	eval 'sub ID_AA64ZFR0_F64MM_MASK () {( &UL(0xf) <<  &ID_AA64ZFR0_F64MM_SHIFT);}' unless defined(&ID_AA64ZFR0_F64MM_MASK);
	eval 'sub ID_AA64ZFR0_F64MM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_AA64ZFR0_F64MM_MASK);
	}' unless defined(&ID_AA64ZFR0_F64MM_VAL);
	eval 'sub ID_AA64ZFR0_F64MM_NONE () {( &UL(0x) <<  &ID_AA64ZFR0_F64MM_SHIFT);}' unless defined(&ID_AA64ZFR0_F64MM_NONE);
	eval 'sub ID_AA64ZFR0_F64MM_IMPL () {( &UL(0x1) <<  &ID_AA64ZFR0_F64MM_SHIFT);}' unless defined(&ID_AA64ZFR0_F64MM_IMPL);
	eval 'sub ID_ISAR5_EL1 () { &MRS_REG( &ID_ISAR5_EL1);}' unless defined(&ID_ISAR5_EL1);
	eval 'sub ID_ISAR5_EL1_op0 () {0x3;}' unless defined(&ID_ISAR5_EL1_op0);
	eval 'sub ID_ISAR5_EL1_op1 () {0x;}' unless defined(&ID_ISAR5_EL1_op1);
	eval 'sub ID_ISAR5_EL1_CRn () {0x;}' unless defined(&ID_ISAR5_EL1_CRn);
	eval 'sub ID_ISAR5_EL1_CRm () {0x2;}' unless defined(&ID_ISAR5_EL1_CRm);
	eval 'sub ID_ISAR5_EL1_op2 () {0x5;}' unless defined(&ID_ISAR5_EL1_op2);
	eval 'sub ID_ISAR5_SEVL_SHIFT () {0;}' unless defined(&ID_ISAR5_SEVL_SHIFT);
	eval 'sub ID_ISAR5_SEVL_MASK () {( &UL(0xf) <<  &ID_ISAR5_SEVL_SHIFT);}' unless defined(&ID_ISAR5_SEVL_MASK);
	eval 'sub ID_ISAR5_SEVL_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_ISAR5_SEVL_MASK));
	}' unless defined(&ID_ISAR5_SEVL_VAL);
	eval 'sub ID_ISAR5_SEVL_NOP () {( &UL(0x) <<  &ID_ISAR5_SEVL_SHIFT);}' unless defined(&ID_ISAR5_SEVL_NOP);
	eval 'sub ID_ISAR5_SEVL_IMPL () {( &UL(0x1) <<  &ID_ISAR5_SEVL_SHIFT);}' unless defined(&ID_ISAR5_SEVL_IMPL);
	eval 'sub ID_ISAR5_AES_SHIFT () {4;}' unless defined(&ID_ISAR5_AES_SHIFT);
	eval 'sub ID_ISAR5_AES_MASK () {( &UL(0xf) <<  &ID_ISAR5_AES_SHIFT);}' unless defined(&ID_ISAR5_AES_MASK);
	eval 'sub ID_ISAR5_AES_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_ISAR5_AES_MASK));
	}' unless defined(&ID_ISAR5_AES_VAL);
	eval 'sub ID_ISAR5_AES_NONE () {( &UL(0x) <<  &ID_ISAR5_AES_SHIFT);}' unless defined(&ID_ISAR5_AES_NONE);
	eval 'sub ID_ISAR5_AES_BASE () {( &UL(0x1) <<  &ID_ISAR5_AES_SHIFT);}' unless defined(&ID_ISAR5_AES_BASE);
	eval 'sub ID_ISAR5_AES_VMULL () {( &UL(0x2) <<  &ID_ISAR5_AES_SHIFT);}' unless defined(&ID_ISAR5_AES_VMULL);
	eval 'sub ID_ISAR5_SHA1_SHIFT () {8;}' unless defined(&ID_ISAR5_SHA1_SHIFT);
	eval 'sub ID_ISAR5_SHA1_MASK () {( &UL(0xf) <<  &ID_ISAR5_SHA1_SHIFT);}' unless defined(&ID_ISAR5_SHA1_MASK);
	eval 'sub ID_ISAR5_SHA1_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_ISAR5_SHA1_MASK));
	}' unless defined(&ID_ISAR5_SHA1_VAL);
	eval 'sub ID_ISAR5_SHA1_NONE () {( &UL(0x) <<  &ID_ISAR5_SHA1_SHIFT);}' unless defined(&ID_ISAR5_SHA1_NONE);
	eval 'sub ID_ISAR5_SHA1_IMPL () {( &UL(0x1) <<  &ID_ISAR5_SHA1_SHIFT);}' unless defined(&ID_ISAR5_SHA1_IMPL);
	eval 'sub ID_ISAR5_SHA2_SHIFT () {12;}' unless defined(&ID_ISAR5_SHA2_SHIFT);
	eval 'sub ID_ISAR5_SHA2_MASK () {( &UL(0xf) <<  &ID_ISAR5_SHA2_SHIFT);}' unless defined(&ID_ISAR5_SHA2_MASK);
	eval 'sub ID_ISAR5_SHA2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_ISAR5_SHA2_MASK));
	}' unless defined(&ID_ISAR5_SHA2_VAL);
	eval 'sub ID_ISAR5_SHA2_NONE () {( &UL(0x) <<  &ID_ISAR5_SHA2_SHIFT);}' unless defined(&ID_ISAR5_SHA2_NONE);
	eval 'sub ID_ISAR5_SHA2_IMPL () {( &UL(0x1) <<  &ID_ISAR5_SHA2_SHIFT);}' unless defined(&ID_ISAR5_SHA2_IMPL);
	eval 'sub ID_ISAR5_CRC32_SHIFT () {16;}' unless defined(&ID_ISAR5_CRC32_SHIFT);
	eval 'sub ID_ISAR5_CRC32_MASK () {( &UL(0xf) <<  &ID_ISAR5_CRC32_SHIFT);}' unless defined(&ID_ISAR5_CRC32_MASK);
	eval 'sub ID_ISAR5_CRC32_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_ISAR5_CRC32_MASK));
	}' unless defined(&ID_ISAR5_CRC32_VAL);
	eval 'sub ID_ISAR5_CRC32_NONE () {( &UL(0x) <<  &ID_ISAR5_CRC32_SHIFT);}' unless defined(&ID_ISAR5_CRC32_NONE);
	eval 'sub ID_ISAR5_CRC32_IMPL () {( &UL(0x1) <<  &ID_ISAR5_CRC32_SHIFT);}' unless defined(&ID_ISAR5_CRC32_IMPL);
	eval 'sub ID_ISAR5_RDM_SHIFT () {24;}' unless defined(&ID_ISAR5_RDM_SHIFT);
	eval 'sub ID_ISAR5_RDM_MASK () {( &UL(0xf) <<  &ID_ISAR5_RDM_SHIFT);}' unless defined(&ID_ISAR5_RDM_MASK);
	eval 'sub ID_ISAR5_RDM_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_ISAR5_RDM_MASK));
	}' unless defined(&ID_ISAR5_RDM_VAL);
	eval 'sub ID_ISAR5_RDM_NONE () {( &UL(0x) <<  &ID_ISAR5_RDM_SHIFT);}' unless defined(&ID_ISAR5_RDM_NONE);
	eval 'sub ID_ISAR5_RDM_IMPL () {( &UL(0x1) <<  &ID_ISAR5_RDM_SHIFT);}' unless defined(&ID_ISAR5_RDM_IMPL);
	eval 'sub ID_ISAR5_VCMA_SHIFT () {28;}' unless defined(&ID_ISAR5_VCMA_SHIFT);
	eval 'sub ID_ISAR5_VCMA_MASK () {( &UL(0xf) <<  &ID_ISAR5_VCMA_SHIFT);}' unless defined(&ID_ISAR5_VCMA_MASK);
	eval 'sub ID_ISAR5_VCMA_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &ID_ISAR5_VCMA_MASK));
	}' unless defined(&ID_ISAR5_VCMA_VAL);
	eval 'sub ID_ISAR5_VCMA_NONE () {( &UL(0x) <<  &ID_ISAR5_VCMA_SHIFT);}' unless defined(&ID_ISAR5_VCMA_NONE);
	eval 'sub ID_ISAR5_VCMA_IMPL () {( &UL(0x1) <<  &ID_ISAR5_VCMA_SHIFT);}' unless defined(&ID_ISAR5_VCMA_IMPL);
	eval 'sub MAIR_ATTR_MASK {
	    my($idx) = @_;
    	    eval q(( &UL(0xff) << (( &n)* 8)));
	}' unless defined(&MAIR_ATTR_MASK);
	eval 'sub MAIR_ATTR {
	    my($attr, $idx) = @_;
    	    eval q((($attr) << (($idx) * 8)));
	}' unless defined(&MAIR_ATTR);
	eval 'sub MAIR_DEVICE_nGnRnE () { &UL(0x);}' unless defined(&MAIR_DEVICE_nGnRnE);
	eval 'sub MAIR_DEVICE_nGnRE () { &UL(0x4);}' unless defined(&MAIR_DEVICE_nGnRE);
	eval 'sub MAIR_NORMAL_NC () { &UL(0x44);}' unless defined(&MAIR_NORMAL_NC);
	eval 'sub MAIR_NORMAL_WT () { &UL(0xbb);}' unless defined(&MAIR_NORMAL_WT);
	eval 'sub MAIR_NORMAL_WB () { &UL(0xff);}' unless defined(&MAIR_NORMAL_WB);
	eval 'sub MDCCINT_EL1 () { &MRS_REG( &MDCCINT_EL1);}' unless defined(&MDCCINT_EL1);
	eval 'sub MDCCINT_EL1_op0 () {2;}' unless defined(&MDCCINT_EL1_op0);
	eval 'sub MDCCINT_EL1_op1 () {0;}' unless defined(&MDCCINT_EL1_op1);
	eval 'sub MDCCINT_EL1_CRn () {0;}' unless defined(&MDCCINT_EL1_CRn);
	eval 'sub MDCCINT_EL1_CRm () {2;}' unless defined(&MDCCINT_EL1_CRm);
	eval 'sub MDCCINT_EL1_op2 () {0;}' unless defined(&MDCCINT_EL1_op2);
	eval 'sub MDCCSR_EL0 () { &MRS_REG( &MDCCSR_EL0);}' unless defined(&MDCCSR_EL0);
	eval 'sub MDCCSR_EL0_op0 () {2;}' unless defined(&MDCCSR_EL0_op0);
	eval 'sub MDCCSR_EL0_op1 () {3;}' unless defined(&MDCCSR_EL0_op1);
	eval 'sub MDCCSR_EL0_CRn () {0;}' unless defined(&MDCCSR_EL0_CRn);
	eval 'sub MDCCSR_EL0_CRm () {1;}' unless defined(&MDCCSR_EL0_CRm);
	eval 'sub MDCCSR_EL0_op2 () {0;}' unless defined(&MDCCSR_EL0_op2);
	eval 'sub MDSCR_EL1 () { &MRS_REG( &MDSCR_EL1);}' unless defined(&MDSCR_EL1);
	eval 'sub MDSCR_EL1_op0 () {2;}' unless defined(&MDSCR_EL1_op0);
	eval 'sub MDSCR_EL1_op1 () {0;}' unless defined(&MDSCR_EL1_op1);
	eval 'sub MDSCR_EL1_CRn () {0;}' unless defined(&MDSCR_EL1_CRn);
	eval 'sub MDSCR_EL1_CRm () {2;}' unless defined(&MDSCR_EL1_CRm);
	eval 'sub MDSCR_EL1_op2 () {2;}' unless defined(&MDSCR_EL1_op2);
	eval 'sub MDSCR_SS_SHIFT () {0;}' unless defined(&MDSCR_SS_SHIFT);
	eval 'sub MDSCR_SS () {( &UL(0x1) <<  &MDSCR_SS_SHIFT);}' unless defined(&MDSCR_SS);
	eval 'sub MDSCR_KDE_SHIFT () {13;}' unless defined(&MDSCR_KDE_SHIFT);
	eval 'sub MDSCR_KDE () {( &UL(0x1) <<  &MDSCR_KDE_SHIFT);}' unless defined(&MDSCR_KDE);
	eval 'sub MDSCR_MDE_SHIFT () {15;}' unless defined(&MDSCR_MDE_SHIFT);
	eval 'sub MDSCR_MDE () {( &UL(0x1) <<  &MDSCR_MDE_SHIFT);}' unless defined(&MDSCR_MDE);
	eval 'sub MIDR_EL1 () { &MRS_REG( &MIDR_EL1);}' unless defined(&MIDR_EL1);
	eval 'sub MIDR_EL1_op0 () {3;}' unless defined(&MIDR_EL1_op0);
	eval 'sub MIDR_EL1_op1 () {0;}' unless defined(&MIDR_EL1_op1);
	eval 'sub MIDR_EL1_CRn () {0;}' unless defined(&MIDR_EL1_CRn);
	eval 'sub MIDR_EL1_CRm () {0;}' unless defined(&MIDR_EL1_CRm);
	eval 'sub MIDR_EL1_op2 () {0;}' unless defined(&MIDR_EL1_op2);
	eval 'sub MPIDR_EL1 () { &MRS_REG( &MPIDR_EL1);}' unless defined(&MPIDR_EL1);
	eval 'sub MPIDR_EL1_op0 () {3;}' unless defined(&MPIDR_EL1_op0);
	eval 'sub MPIDR_EL1_op1 () {0;}' unless defined(&MPIDR_EL1_op1);
	eval 'sub MPIDR_EL1_CRn () {0;}' unless defined(&MPIDR_EL1_CRn);
	eval 'sub MPIDR_EL1_CRm () {0;}' unless defined(&MPIDR_EL1_CRm);
	eval 'sub MPIDR_EL1_op2 () {5;}' unless defined(&MPIDR_EL1_op2);
	eval 'sub MPIDR_AFF0_SHIFT () {0;}' unless defined(&MPIDR_AFF0_SHIFT);
	eval 'sub MPIDR_AFF0_MASK () {( &UL(0xff) <<  &MPIDR_AFF0_SHIFT);}' unless defined(&MPIDR_AFF0_MASK);
	eval 'sub MPIDR_AFF0_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MPIDR_AFF0_MASK));
	}' unless defined(&MPIDR_AFF0_VAL);
	eval 'sub MPIDR_AFF1_SHIFT () {8;}' unless defined(&MPIDR_AFF1_SHIFT);
	eval 'sub MPIDR_AFF1_MASK () {( &UL(0xff) <<  &MPIDR_AFF1_SHIFT);}' unless defined(&MPIDR_AFF1_MASK);
	eval 'sub MPIDR_AFF1_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MPIDR_AFF1_MASK));
	}' unless defined(&MPIDR_AFF1_VAL);
	eval 'sub MPIDR_AFF2_SHIFT () {16;}' unless defined(&MPIDR_AFF2_SHIFT);
	eval 'sub MPIDR_AFF2_MASK () {( &UL(0xff) <<  &MPIDR_AFF2_SHIFT);}' unless defined(&MPIDR_AFF2_MASK);
	eval 'sub MPIDR_AFF2_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MPIDR_AFF2_MASK));
	}' unless defined(&MPIDR_AFF2_VAL);
	eval 'sub MPIDR_MT_SHIFT () {24;}' unless defined(&MPIDR_MT_SHIFT);
	eval 'sub MPIDR_MT_MASK () {( &UL(0x1) <<  &MPIDR_MT_SHIFT);}' unless defined(&MPIDR_MT_MASK);
	eval 'sub MPIDR_U_SHIFT () {30;}' unless defined(&MPIDR_U_SHIFT);
	eval 'sub MPIDR_U_MASK () {( &UL(0x1) <<  &MPIDR_U_SHIFT);}' unless defined(&MPIDR_U_MASK);
	eval 'sub MPIDR_AFF3_SHIFT () {32;}' unless defined(&MPIDR_AFF3_SHIFT);
	eval 'sub MPIDR_AFF3_MASK () {( &UL(0xff) <<  &MPIDR_AFF3_SHIFT);}' unless defined(&MPIDR_AFF3_MASK);
	eval 'sub MPIDR_AFF3_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MPIDR_AFF3_MASK));
	}' unless defined(&MPIDR_AFF3_VAL);
	eval 'sub MVFR0_EL1 () { &MRS_REG( &MVFR0_EL1);}' unless defined(&MVFR0_EL1);
	eval 'sub MVFR0_EL1_op0 () {0x3;}' unless defined(&MVFR0_EL1_op0);
	eval 'sub MVFR0_EL1_op1 () {0x;}' unless defined(&MVFR0_EL1_op1);
	eval 'sub MVFR0_EL1_CRn () {0x;}' unless defined(&MVFR0_EL1_CRn);
	eval 'sub MVFR0_EL1_CRm () {0x3;}' unless defined(&MVFR0_EL1_CRm);
	eval 'sub MVFR0_EL1_op2 () {0x;}' unless defined(&MVFR0_EL1_op2);
	eval 'sub MVFR0_SIMDReg_SHIFT () {0;}' unless defined(&MVFR0_SIMDReg_SHIFT);
	eval 'sub MVFR0_SIMDReg_MASK () {( &UL(0xf) <<  &MVFR0_SIMDReg_SHIFT);}' unless defined(&MVFR0_SIMDReg_MASK);
	eval 'sub MVFR0_SIMDReg_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR0_SIMDReg_MASK));
	}' unless defined(&MVFR0_SIMDReg_VAL);
	eval 'sub MVFR0_SIMDReg_NONE () {( &UL(0x) <<  &MVFR0_SIMDReg_SHIFT);}' unless defined(&MVFR0_SIMDReg_NONE);
	eval 'sub MVFR0_SIMDReg_FP () {( &UL(0x1) <<  &MVFR0_SIMDReg_SHIFT);}' unless defined(&MVFR0_SIMDReg_FP);
	eval 'sub MVFR0_SIMDReg_AdvSIMD () {( &UL(0x2) <<  &MVFR0_SIMDReg_SHIFT);}' unless defined(&MVFR0_SIMDReg_AdvSIMD);
	eval 'sub MVFR0_FPSP_SHIFT () {4;}' unless defined(&MVFR0_FPSP_SHIFT);
	eval 'sub MVFR0_FPSP_MASK () {( &UL(0xf) <<  &MVFR0_FPSP_SHIFT);}' unless defined(&MVFR0_FPSP_MASK);
	eval 'sub MVFR0_FPSP_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR0_FPSP_MASK));
	}' unless defined(&MVFR0_FPSP_VAL);
	eval 'sub MVFR0_FPSP_NONE () {( &UL(0x) <<  &MVFR0_FPSP_SHIFT);}' unless defined(&MVFR0_FPSP_NONE);
	eval 'sub MVFR0_FPSP_VFP_v2 () {( &UL(0x1) <<  &MVFR0_FPSP_SHIFT);}' unless defined(&MVFR0_FPSP_VFP_v2);
	eval 'sub MVFR0_FPSP_VFP_v3_v4 () {( &UL(0x2) <<  &MVFR0_FPSP_SHIFT);}' unless defined(&MVFR0_FPSP_VFP_v3_v4);
	eval 'sub MVFR0_FPDP_SHIFT () {8;}' unless defined(&MVFR0_FPDP_SHIFT);
	eval 'sub MVFR0_FPDP_MASK () {( &UL(0xf) <<  &MVFR0_FPDP_SHIFT);}' unless defined(&MVFR0_FPDP_MASK);
	eval 'sub MVFR0_FPDP_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR0_FPDP_MASK));
	}' unless defined(&MVFR0_FPDP_VAL);
	eval 'sub MVFR0_FPDP_NONE () {( &UL(0x) <<  &MVFR0_FPDP_SHIFT);}' unless defined(&MVFR0_FPDP_NONE);
	eval 'sub MVFR0_FPDP_VFP_v2 () {( &UL(0x1) <<  &MVFR0_FPDP_SHIFT);}' unless defined(&MVFR0_FPDP_VFP_v2);
	eval 'sub MVFR0_FPDP_VFP_v3_v4 () {( &UL(0x2) <<  &MVFR0_FPDP_SHIFT);}' unless defined(&MVFR0_FPDP_VFP_v3_v4);
	eval 'sub MVFR0_FPTrap_SHIFT () {12;}' unless defined(&MVFR0_FPTrap_SHIFT);
	eval 'sub MVFR0_FPTrap_MASK () {( &UL(0xf) <<  &MVFR0_FPTrap_SHIFT);}' unless defined(&MVFR0_FPTrap_MASK);
	eval 'sub MVFR0_FPTrap_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR0_FPTrap_MASK));
	}' unless defined(&MVFR0_FPTrap_VAL);
	eval 'sub MVFR0_FPTrap_NONE () {( &UL(0x) <<  &MVFR0_FPTrap_SHIFT);}' unless defined(&MVFR0_FPTrap_NONE);
	eval 'sub MVFR0_FPTrap_IMPL () {( &UL(0x1) <<  &MVFR0_FPTrap_SHIFT);}' unless defined(&MVFR0_FPTrap_IMPL);
	eval 'sub MVFR0_FPDivide_SHIFT () {16;}' unless defined(&MVFR0_FPDivide_SHIFT);
	eval 'sub MVFR0_FPDivide_MASK () {( &UL(0xf) <<  &MVFR0_FPDivide_SHIFT);}' unless defined(&MVFR0_FPDivide_MASK);
	eval 'sub MVFR0_FPDivide_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR0_FPDivide_MASK));
	}' unless defined(&MVFR0_FPDivide_VAL);
	eval 'sub MVFR0_FPDivide_NONE () {( &UL(0x) <<  &MVFR0_FPDivide_SHIFT);}' unless defined(&MVFR0_FPDivide_NONE);
	eval 'sub MVFR0_FPDivide_IMPL () {( &UL(0x1) <<  &MVFR0_FPDivide_SHIFT);}' unless defined(&MVFR0_FPDivide_IMPL);
	eval 'sub MVFR0_FPSqrt_SHIFT () {20;}' unless defined(&MVFR0_FPSqrt_SHIFT);
	eval 'sub MVFR0_FPSqrt_MASK () {( &UL(0xf) <<  &MVFR0_FPSqrt_SHIFT);}' unless defined(&MVFR0_FPSqrt_MASK);
	eval 'sub MVFR0_FPSqrt_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR0_FPSqrt_MASK));
	}' unless defined(&MVFR0_FPSqrt_VAL);
	eval 'sub MVFR0_FPSqrt_NONE () {( &UL(0x) <<  &MVFR0_FPSqrt_SHIFT);}' unless defined(&MVFR0_FPSqrt_NONE);
	eval 'sub MVFR0_FPSqrt_IMPL () {( &UL(0x1) <<  &MVFR0_FPSqrt_SHIFT);}' unless defined(&MVFR0_FPSqrt_IMPL);
	eval 'sub MVFR0_FPShVec_SHIFT () {24;}' unless defined(&MVFR0_FPShVec_SHIFT);
	eval 'sub MVFR0_FPShVec_MASK () {( &UL(0xf) <<  &MVFR0_FPShVec_SHIFT);}' unless defined(&MVFR0_FPShVec_MASK);
	eval 'sub MVFR0_FPShVec_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR0_FPShVec_MASK));
	}' unless defined(&MVFR0_FPShVec_VAL);
	eval 'sub MVFR0_FPShVec_NONE () {( &UL(0x) <<  &MVFR0_FPShVec_SHIFT);}' unless defined(&MVFR0_FPShVec_NONE);
	eval 'sub MVFR0_FPShVec_IMPL () {( &UL(0x1) <<  &MVFR0_FPShVec_SHIFT);}' unless defined(&MVFR0_FPShVec_IMPL);
	eval 'sub MVFR0_FPRound_SHIFT () {28;}' unless defined(&MVFR0_FPRound_SHIFT);
	eval 'sub MVFR0_FPRound_MASK () {( &UL(0xf) <<  &MVFR0_FPRound_SHIFT);}' unless defined(&MVFR0_FPRound_MASK);
	eval 'sub MVFR0_FPRound_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR0_FPRound_MASK));
	}' unless defined(&MVFR0_FPRound_VAL);
	eval 'sub MVFR0_FPRound_NONE () {( &UL(0x) <<  &MVFR0_FPRound_SHIFT);}' unless defined(&MVFR0_FPRound_NONE);
	eval 'sub MVFR0_FPRound_IMPL () {( &UL(0x1) <<  &MVFR0_FPRound_SHIFT);}' unless defined(&MVFR0_FPRound_IMPL);
	eval 'sub MVFR1_EL1 () { &MRS_REG( &MVFR1_EL1);}' unless defined(&MVFR1_EL1);
	eval 'sub MVFR1_EL1_op0 () {0x3;}' unless defined(&MVFR1_EL1_op0);
	eval 'sub MVFR1_EL1_op1 () {0x;}' unless defined(&MVFR1_EL1_op1);
	eval 'sub MVFR1_EL1_CRn () {0x;}' unless defined(&MVFR1_EL1_CRn);
	eval 'sub MVFR1_EL1_CRm () {0x3;}' unless defined(&MVFR1_EL1_CRm);
	eval 'sub MVFR1_EL1_op2 () {0x1;}' unless defined(&MVFR1_EL1_op2);
	eval 'sub MVFR1_FPFtZ_SHIFT () {0;}' unless defined(&MVFR1_FPFtZ_SHIFT);
	eval 'sub MVFR1_FPFtZ_MASK () {( &UL(0xf) <<  &MVFR1_FPFtZ_SHIFT);}' unless defined(&MVFR1_FPFtZ_MASK);
	eval 'sub MVFR1_FPFtZ_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR1_FPFtZ_MASK));
	}' unless defined(&MVFR1_FPFtZ_VAL);
	eval 'sub MVFR1_FPFtZ_NONE () {( &UL(0x) <<  &MVFR1_FPFtZ_SHIFT);}' unless defined(&MVFR1_FPFtZ_NONE);
	eval 'sub MVFR1_FPFtZ_IMPL () {( &UL(0x1) <<  &MVFR1_FPFtZ_SHIFT);}' unless defined(&MVFR1_FPFtZ_IMPL);
	eval 'sub MVFR1_FPDNaN_SHIFT () {4;}' unless defined(&MVFR1_FPDNaN_SHIFT);
	eval 'sub MVFR1_FPDNaN_MASK () {( &UL(0xf) <<  &MVFR1_FPDNaN_SHIFT);}' unless defined(&MVFR1_FPDNaN_MASK);
	eval 'sub MVFR1_FPDNaN_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR1_FPDNaN_MASK));
	}' unless defined(&MVFR1_FPDNaN_VAL);
	eval 'sub MVFR1_FPDNaN_NONE () {( &UL(0x) <<  &MVFR1_FPDNaN_SHIFT);}' unless defined(&MVFR1_FPDNaN_NONE);
	eval 'sub MVFR1_FPDNaN_IMPL () {( &UL(0x1) <<  &MVFR1_FPDNaN_SHIFT);}' unless defined(&MVFR1_FPDNaN_IMPL);
	eval 'sub MVFR1_SIMDLS_SHIFT () {8;}' unless defined(&MVFR1_SIMDLS_SHIFT);
	eval 'sub MVFR1_SIMDLS_MASK () {( &UL(0xf) <<  &MVFR1_SIMDLS_SHIFT);}' unless defined(&MVFR1_SIMDLS_MASK);
	eval 'sub MVFR1_SIMDLS_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR1_SIMDLS_MASK));
	}' unless defined(&MVFR1_SIMDLS_VAL);
	eval 'sub MVFR1_SIMDLS_NONE () {( &UL(0x) <<  &MVFR1_SIMDLS_SHIFT);}' unless defined(&MVFR1_SIMDLS_NONE);
	eval 'sub MVFR1_SIMDLS_IMPL () {( &UL(0x1) <<  &MVFR1_SIMDLS_SHIFT);}' unless defined(&MVFR1_SIMDLS_IMPL);
	eval 'sub MVFR1_SIMDInt_SHIFT () {12;}' unless defined(&MVFR1_SIMDInt_SHIFT);
	eval 'sub MVFR1_SIMDInt_MASK () {( &UL(0xf) <<  &MVFR1_SIMDInt_SHIFT);}' unless defined(&MVFR1_SIMDInt_MASK);
	eval 'sub MVFR1_SIMDInt_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR1_SIMDInt_MASK));
	}' unless defined(&MVFR1_SIMDInt_VAL);
	eval 'sub MVFR1_SIMDInt_NONE () {( &UL(0x) <<  &MVFR1_SIMDInt_SHIFT);}' unless defined(&MVFR1_SIMDInt_NONE);
	eval 'sub MVFR1_SIMDInt_IMPL () {( &UL(0x1) <<  &MVFR1_SIMDInt_SHIFT);}' unless defined(&MVFR1_SIMDInt_IMPL);
	eval 'sub MVFR1_SIMDSP_SHIFT () {16;}' unless defined(&MVFR1_SIMDSP_SHIFT);
	eval 'sub MVFR1_SIMDSP_MASK () {( &UL(0xf) <<  &MVFR1_SIMDSP_SHIFT);}' unless defined(&MVFR1_SIMDSP_MASK);
	eval 'sub MVFR1_SIMDSP_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR1_SIMDSP_MASK));
	}' unless defined(&MVFR1_SIMDSP_VAL);
	eval 'sub MVFR1_SIMDSP_NONE () {( &UL(0x) <<  &MVFR1_SIMDSP_SHIFT);}' unless defined(&MVFR1_SIMDSP_NONE);
	eval 'sub MVFR1_SIMDSP_IMPL () {( &UL(0x1) <<  &MVFR1_SIMDSP_SHIFT);}' unless defined(&MVFR1_SIMDSP_IMPL);
	eval 'sub MVFR1_SIMDHP_SHIFT () {20;}' unless defined(&MVFR1_SIMDHP_SHIFT);
	eval 'sub MVFR1_SIMDHP_MASK () {( &UL(0xf) <<  &MVFR1_SIMDHP_SHIFT);}' unless defined(&MVFR1_SIMDHP_MASK);
	eval 'sub MVFR1_SIMDHP_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR1_SIMDHP_MASK));
	}' unless defined(&MVFR1_SIMDHP_VAL);
	eval 'sub MVFR1_SIMDHP_NONE () {( &UL(0x) <<  &MVFR1_SIMDHP_SHIFT);}' unless defined(&MVFR1_SIMDHP_NONE);
	eval 'sub MVFR1_SIMDHP_CONV_SP () {( &UL(0x1) <<  &MVFR1_SIMDHP_SHIFT);}' unless defined(&MVFR1_SIMDHP_CONV_SP);
	eval 'sub MVFR1_SIMDHP_ARITH () {( &UL(0x2) <<  &MVFR1_SIMDHP_SHIFT);}' unless defined(&MVFR1_SIMDHP_ARITH);
	eval 'sub MVFR1_FPHP_SHIFT () {24;}' unless defined(&MVFR1_FPHP_SHIFT);
	eval 'sub MVFR1_FPHP_MASK () {( &UL(0xf) <<  &MVFR1_FPHP_SHIFT);}' unless defined(&MVFR1_FPHP_MASK);
	eval 'sub MVFR1_FPHP_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR1_FPHP_MASK));
	}' unless defined(&MVFR1_FPHP_VAL);
	eval 'sub MVFR1_FPHP_NONE () {( &UL(0x) <<  &MVFR1_FPHP_SHIFT);}' unless defined(&MVFR1_FPHP_NONE);
	eval 'sub MVFR1_FPHP_CONV_SP () {( &UL(0x1) <<  &MVFR1_FPHP_SHIFT);}' unless defined(&MVFR1_FPHP_CONV_SP);
	eval 'sub MVFR1_FPHP_CONV_DP () {( &UL(0x2) <<  &MVFR1_FPHP_SHIFT);}' unless defined(&MVFR1_FPHP_CONV_DP);
	eval 'sub MVFR1_FPHP_ARITH () {( &UL(0x3) <<  &MVFR1_FPHP_SHIFT);}' unless defined(&MVFR1_FPHP_ARITH);
	eval 'sub MVFR1_SIMDFMAC_SHIFT () {28;}' unless defined(&MVFR1_SIMDFMAC_SHIFT);
	eval 'sub MVFR1_SIMDFMAC_MASK () {( &UL(0xf) <<  &MVFR1_SIMDFMAC_SHIFT);}' unless defined(&MVFR1_SIMDFMAC_MASK);
	eval 'sub MVFR1_SIMDFMAC_VAL {
	    my($x) = @_;
    	    eval q((($x) &  &MVFR1_SIMDFMAC_MASK));
	}' unless defined(&MVFR1_SIMDFMAC_VAL);
	eval 'sub MVFR1_SIMDFMAC_NONE () {( &UL(0x) <<  &MVFR1_SIMDFMAC_SHIFT);}' unless defined(&MVFR1_SIMDFMAC_NONE);
	eval 'sub MVFR1_SIMDFMAC_IMPL () {( &UL(0x1) <<  &MVFR1_SIMDFMAC_SHIFT);}' unless defined(&MVFR1_SIMDFMAC_IMPL);
	eval 'sub OSDLR_EL1 () { &MRS_REG( &OSDLR_EL1);}' unless defined(&OSDLR_EL1);
	eval 'sub OSDLR_EL1_op0 () {2;}' unless defined(&OSDLR_EL1_op0);
	eval 'sub OSDLR_EL1_op1 () {0;}' unless defined(&OSDLR_EL1_op1);
	eval 'sub OSDLR_EL1_CRn () {1;}' unless defined(&OSDLR_EL1_CRn);
	eval 'sub OSDLR_EL1_CRm () {3;}' unless defined(&OSDLR_EL1_CRm);
	eval 'sub OSDLR_EL1_op2 () {4;}' unless defined(&OSDLR_EL1_op2);
	eval 'sub OSLAR_EL1 () { &MRS_REG( &OSLAR_EL1);}' unless defined(&OSLAR_EL1);
	eval 'sub OSLAR_EL1_op0 () {2;}' unless defined(&OSLAR_EL1_op0);
	eval 'sub OSLAR_EL1_op1 () {0;}' unless defined(&OSLAR_EL1_op1);
	eval 'sub OSLAR_EL1_CRn () {1;}' unless defined(&OSLAR_EL1_CRn);
	eval 'sub OSLAR_EL1_CRm () {0;}' unless defined(&OSLAR_EL1_CRm);
	eval 'sub OSLAR_EL1_op2 () {4;}' unless defined(&OSLAR_EL1_op2);
	eval 'sub OSLSR_EL1 () { &MRS_REG( &OSLSR_EL1);}' unless defined(&OSLSR_EL1);
	eval 'sub OSLSR_EL1_op0 () {2;}' unless defined(&OSLSR_EL1_op0);
	eval 'sub OSLSR_EL1_op1 () {0;}' unless defined(&OSLSR_EL1_op1);
	eval 'sub OSLSR_EL1_CRn () {1;}' unless defined(&OSLSR_EL1_CRn);
	eval 'sub OSLSR_EL1_CRm () {1;}' unless defined(&OSLSR_EL1_CRm);
	eval 'sub OSLSR_EL1_op2 () {4;}' unless defined(&OSLSR_EL1_op2);
	eval 'sub PAR_F_SHIFT () {0;}' unless defined(&PAR_F_SHIFT);
	eval 'sub PAR_F () {(0x1 <<  &PAR_F_SHIFT);}' unless defined(&PAR_F);
	eval 'sub PAR_SUCCESS {
	    my($x) = @_;
    	    eval q(((($x) &  &PAR_F) == 0));
	}' unless defined(&PAR_SUCCESS);
	eval 'sub PAR_LOW_MASK () {0xfff;}' unless defined(&PAR_LOW_MASK);
	eval 'sub PAR_SH_SHIFT () {7;}' unless defined(&PAR_SH_SHIFT);
	eval 'sub PAR_SH_MASK () {(0x3 <<  &PAR_SH_SHIFT);}' unless defined(&PAR_SH_MASK);
	eval 'sub PAR_NS_SHIFT () {9;}' unless defined(&PAR_NS_SHIFT);
	eval 'sub PAR_NS_MASK () {(0x3 <<  &PAR_NS_SHIFT);}' unless defined(&PAR_NS_MASK);
	eval 'sub PAR_PA_SHIFT () {12;}' unless defined(&PAR_PA_SHIFT);
	eval 'sub PAR_PA_MASK () {0xfffffffff000;}' unless defined(&PAR_PA_MASK);
	eval 'sub PAR_ATTR_SHIFT () {56;}' unless defined(&PAR_ATTR_SHIFT);
	eval 'sub PAR_ATTR_MASK () {(0xff <<  &PAR_ATTR_SHIFT);}' unless defined(&PAR_ATTR_MASK);
	eval 'sub PAR_FST_SHIFT () {1;}' unless defined(&PAR_FST_SHIFT);
	eval 'sub PAR_FST_MASK () {(0x3f <<  &PAR_FST_SHIFT);}' unless defined(&PAR_FST_MASK);
	eval 'sub PAR_PTW_SHIFT () {8;}' unless defined(&PAR_PTW_SHIFT);
	eval 'sub PAR_PTW_MASK () {(0x1 <<  &PAR_PTW_SHIFT);}' unless defined(&PAR_PTW_MASK);
	eval 'sub PAR_S_SHIFT () {9;}' unless defined(&PAR_S_SHIFT);
	eval 'sub PAR_S_MASK () {(0x1 <<  &PAR_S_SHIFT);}' unless defined(&PAR_S_MASK);
	eval 'sub PMBIDR_EL1 () { &MRS_REG( &PMBIDR_EL1);}' unless defined(&PMBIDR_EL1);
	eval 'sub PMBIDR_EL1_op0 () {0x3;}' unless defined(&PMBIDR_EL1_op0);
	eval 'sub PMBIDR_EL1_op1 () {0x;}' unless defined(&PMBIDR_EL1_op1);
	eval 'sub PMBIDR_EL1_CRn () {0x9;}' unless defined(&PMBIDR_EL1_CRn);
	eval 'sub PMBIDR_EL1_CRm () {0xa;}' unless defined(&PMBIDR_EL1_CRm);
	eval 'sub PMBIDR_EL1_op2 () {0x7;}' unless defined(&PMBIDR_EL1_op2);
	eval 'sub PMBIDR_Align_SHIFT () {0;}' unless defined(&PMBIDR_Align_SHIFT);
	eval 'sub PMBIDR_Align_MASK () {( &UL(0xf) <<  &PMBIDR_Align_SHIFT);}' unless defined(&PMBIDR_Align_MASK);
	eval 'sub PMBIDR_P_SHIFT () {4;}' unless defined(&PMBIDR_P_SHIFT);
	eval 'sub PMBIDR_P () {( &UL(0x1) <<  &PMBIDR_P_SHIFT);}' unless defined(&PMBIDR_P);
	eval 'sub PMBIDR_F_SHIFT () {5;}' unless defined(&PMBIDR_F_SHIFT);
	eval 'sub PMBIDR_F () {( &UL(0x1) <<  &PMBIDR_F_SHIFT);}' unless defined(&PMBIDR_F);
	eval 'sub PMBLIMITR_EL1 () { &MRS_REG( &PMBLIMITR_EL1);}' unless defined(&PMBLIMITR_EL1);
	eval 'sub PMBLIMITR_EL1_op0 () {0x3;}' unless defined(&PMBLIMITR_EL1_op0);
	eval 'sub PMBLIMITR_EL1_op1 () {0x;}' unless defined(&PMBLIMITR_EL1_op1);
	eval 'sub PMBLIMITR_EL1_CRn () {0x9;}' unless defined(&PMBLIMITR_EL1_CRn);
	eval 'sub PMBLIMITR_EL1_CRm () {0xa;}' unless defined(&PMBLIMITR_EL1_CRm);
	eval 'sub PMBLIMITR_EL1_op2 () {0x;}' unless defined(&PMBLIMITR_EL1_op2);
	eval 'sub PMBLIMITR_E_SHIFT () {0;}' unless defined(&PMBLIMITR_E_SHIFT);
	eval 'sub PMBLIMITR_E () {( &UL(0x1) <<  &PMBLIMITR_E_SHIFT);}' unless defined(&PMBLIMITR_E);
	eval 'sub PMBLIMITR_FM_SHIFT () {1;}' unless defined(&PMBLIMITR_FM_SHIFT);
	eval 'sub PMBLIMITR_FM_MASK () {( &UL(0x3) <<  &PMBLIMITR_FM_SHIFT);}' unless defined(&PMBLIMITR_FM_MASK);
	eval 'sub PMBLIMITR_PMFZ_SHIFT () {5;}' unless defined(&PMBLIMITR_PMFZ_SHIFT);
	eval 'sub PMBLIMITR_PMFZ () {( &UL(0x1) <<  &PMBLIMITR_PMFZ_SHIFT);}' unless defined(&PMBLIMITR_PMFZ);
	eval 'sub PMBLIMITR_LIMIT_SHIFT () {12;}' unless defined(&PMBLIMITR_LIMIT_SHIFT);
	eval 'sub PMBLIMITR_LIMIT_MASK () {( &UL(0xfffffffffffff) <<  &PMBLIMITR_LIMIT_SHIFT);}' unless defined(&PMBLIMITR_LIMIT_MASK);
	eval 'sub PMBPTR_EL1 () { &MRS_REG( &PMBPTR_EL1);}' unless defined(&PMBPTR_EL1);
	eval 'sub PMBPTR_EL1_op0 () {0x3;}' unless defined(&PMBPTR_EL1_op0);
	eval 'sub PMBPTR_EL1_op1 () {0x;}' unless defined(&PMBPTR_EL1_op1);
	eval 'sub PMBPTR_EL1_CRn () {0x9;}' unless defined(&PMBPTR_EL1_CRn);
	eval 'sub PMBPTR_EL1_CRm () {0xa;}' unless defined(&PMBPTR_EL1_CRm);
	eval 'sub PMBPTR_EL1_op2 () {0x1;}' unless defined(&PMBPTR_EL1_op2);
	eval 'sub PMBPTR_PTR_SHIFT () {0;}' unless defined(&PMBPTR_PTR_SHIFT);
	eval 'sub PMBPTR_PTR_MASK () {( &UL(0xffffffffffffffff) <<  &PMBPTR_PTR_SHIFT);}' unless defined(&PMBPTR_PTR_MASK);
	eval 'sub PMBSR_EL1 () { &MRS_REG( &PMBSR_EL1);}' unless defined(&PMBSR_EL1);
	eval 'sub PMBSR_EL1_op0 () {0x3;}' unless defined(&PMBSR_EL1_op0);
	eval 'sub PMBSR_EL1_op1 () {0x;}' unless defined(&PMBSR_EL1_op1);
	eval 'sub PMBSR_EL1_CRn () {0x9;}' unless defined(&PMBSR_EL1_CRn);
	eval 'sub PMBSR_EL1_CRm () {0xa;}' unless defined(&PMBSR_EL1_CRm);
	eval 'sub PMBSR_EL1_op2 () {0x3;}' unless defined(&PMBSR_EL1_op2);
	eval 'sub PMBSR_MSS_SHIFT () {0;}' unless defined(&PMBSR_MSS_SHIFT);
	eval 'sub PMBSR_MSS_MASK () {( &UL(0xffff) <<  &PMBSR_MSS_SHIFT);}' unless defined(&PMBSR_MSS_MASK);
	eval 'sub PMBSR_COLL_SHIFT () {16;}' unless defined(&PMBSR_COLL_SHIFT);
	eval 'sub PMBSR_COLL () {( &UL(0x1) <<  &PMBSR_COLL_SHIFT);}' unless defined(&PMBSR_COLL);
	eval 'sub PMBSR_S_SHIFT () {17;}' unless defined(&PMBSR_S_SHIFT);
	eval 'sub PMBSR_S () {( &UL(0x1) <<  &PMBSR_S_SHIFT);}' unless defined(&PMBSR_S);
	eval 'sub PMBSR_EA_SHIFT () {18;}' unless defined(&PMBSR_EA_SHIFT);
	eval 'sub PMBSR_EA () {( &UL(0x1) <<  &PMBSR_EA_SHIFT);}' unless defined(&PMBSR_EA);
	eval 'sub PMBSR_DL_SHIFT () {19;}' unless defined(&PMBSR_DL_SHIFT);
	eval 'sub PMBSR_DL () {( &UL(0x1) <<  &PMBSR_DL_SHIFT);}' unless defined(&PMBSR_DL);
	eval 'sub PMBSR_EC_SHIFT () {26;}' unless defined(&PMBSR_EC_SHIFT);
	eval 'sub PMBSR_EC_MASK () {( &UL(0x3f) <<  &PMBSR_EC_SHIFT);}' unless defined(&PMBSR_EC_MASK);
	eval 'sub PMCCFILTR_EL0 () { &MRS_REG( &PMCCFILTR_EL0);}' unless defined(&PMCCFILTR_EL0);
	eval 'sub PMCCFILTR_EL0_op0 () {3;}' unless defined(&PMCCFILTR_EL0_op0);
	eval 'sub PMCCFILTR_EL0_op1 () {3;}' unless defined(&PMCCFILTR_EL0_op1);
	eval 'sub PMCCFILTR_EL0_CRn () {14;}' unless defined(&PMCCFILTR_EL0_CRn);
	eval 'sub PMCCFILTR_EL0_CRm () {15;}' unless defined(&PMCCFILTR_EL0_CRm);
	eval 'sub PMCCFILTR_EL0_op2 () {7;}' unless defined(&PMCCFILTR_EL0_op2);
	eval 'sub PMCCNTR_EL0 () { &MRS_REG( &PMCCNTR_EL0);}' unless defined(&PMCCNTR_EL0);
	eval 'sub PMCCNTR_EL0_op0 () {3;}' unless defined(&PMCCNTR_EL0_op0);
	eval 'sub PMCCNTR_EL0_op1 () {3;}' unless defined(&PMCCNTR_EL0_op1);
	eval 'sub PMCCNTR_EL0_CRn () {9;}' unless defined(&PMCCNTR_EL0_CRn);
	eval 'sub PMCCNTR_EL0_CRm () {13;}' unless defined(&PMCCNTR_EL0_CRm);
	eval 'sub PMCCNTR_EL0_op2 () {0;}' unless defined(&PMCCNTR_EL0_op2);
	eval 'sub PMCEID0_EL0 () { &MRS_REG( &PMCEID0_EL0);}' unless defined(&PMCEID0_EL0);
	eval 'sub PMCEID0_EL0_op0 () {3;}' unless defined(&PMCEID0_EL0_op0);
	eval 'sub PMCEID0_EL0_op1 () {3;}' unless defined(&PMCEID0_EL0_op1);
	eval 'sub PMCEID0_EL0_CRn () {9;}' unless defined(&PMCEID0_EL0_CRn);
	eval 'sub PMCEID0_EL0_CRm () {12;}' unless defined(&PMCEID0_EL0_CRm);
	eval 'sub PMCEID0_EL0_op2 () {6;}' unless defined(&PMCEID0_EL0_op2);
	eval 'sub PMCEID1_EL0 () { &MRS_REG( &PMCEID1_EL0);}' unless defined(&PMCEID1_EL0);
	eval 'sub PMCEID1_EL0_op0 () {3;}' unless defined(&PMCEID1_EL0_op0);
	eval 'sub PMCEID1_EL0_op1 () {3;}' unless defined(&PMCEID1_EL0_op1);
	eval 'sub PMCEID1_EL0_CRn () {9;}' unless defined(&PMCEID1_EL0_CRn);
	eval 'sub PMCEID1_EL0_CRm () {12;}' unless defined(&PMCEID1_EL0_CRm);
	eval 'sub PMCEID1_EL0_op2 () {7;}' unless defined(&PMCEID1_EL0_op2);
	eval 'sub PMCNTENCLR_EL0 () { &MRS_REG( &PMCNTENCLR_EL0);}' unless defined(&PMCNTENCLR_EL0);
	eval 'sub PMCNTENCLR_EL0_op0 () {3;}' unless defined(&PMCNTENCLR_EL0_op0);
	eval 'sub PMCNTENCLR_EL0_op1 () {3;}' unless defined(&PMCNTENCLR_EL0_op1);
	eval 'sub PMCNTENCLR_EL0_CRn () {9;}' unless defined(&PMCNTENCLR_EL0_CRn);
	eval 'sub PMCNTENCLR_EL0_CRm () {12;}' unless defined(&PMCNTENCLR_EL0_CRm);
	eval 'sub PMCNTENCLR_EL0_op2 () {2;}' unless defined(&PMCNTENCLR_EL0_op2);
	eval 'sub PMCNTENSET_EL0 () { &MRS_REG( &PMCNTENSET_EL0);}' unless defined(&PMCNTENSET_EL0);
	eval 'sub PMCNTENSET_EL0_op0 () {3;}' unless defined(&PMCNTENSET_EL0_op0);
	eval 'sub PMCNTENSET_EL0_op1 () {3;}' unless defined(&PMCNTENSET_EL0_op1);
	eval 'sub PMCNTENSET_EL0_CRn () {9;}' unless defined(&PMCNTENSET_EL0_CRn);
	eval 'sub PMCNTENSET_EL0_CRm () {12;}' unless defined(&PMCNTENSET_EL0_CRm);
	eval 'sub PMCNTENSET_EL0_op2 () {1;}' unless defined(&PMCNTENSET_EL0_op2);
	eval 'sub PMCR_EL0 () { &MRS_REG( &PMCR_EL0);}' unless defined(&PMCR_EL0);
	eval 'sub PMCR_EL0_op0 () {3;}' unless defined(&PMCR_EL0_op0);
	eval 'sub PMCR_EL0_op1 () {3;}' unless defined(&PMCR_EL0_op1);
	eval 'sub PMCR_EL0_CRn () {9;}' unless defined(&PMCR_EL0_CRn);
	eval 'sub PMCR_EL0_CRm () {12;}' unless defined(&PMCR_EL0_CRm);
	eval 'sub PMCR_EL0_op2 () {0;}' unless defined(&PMCR_EL0_op2);
	eval 'sub PMCR_E () {(1<< 0);}' unless defined(&PMCR_E);
	eval 'sub PMCR_P () {(1<< 1);}' unless defined(&PMCR_P);
	eval 'sub PMCR_C () {(1<< 2);}' unless defined(&PMCR_C);
	eval 'sub PMCR_D () {(1<< 3);}' unless defined(&PMCR_D);
	eval 'sub PMCR_X () {(1<< 4);}' unless defined(&PMCR_X);
	eval 'sub PMCR_DP () {(1<< 5);}' unless defined(&PMCR_DP);
	eval 'sub PMCR_LC () {(1<< 6);}' unless defined(&PMCR_LC);
	eval 'sub PMCR_IMP_SHIFT () {24;}' unless defined(&PMCR_IMP_SHIFT);
	eval 'sub PMCR_IMP_MASK () {(0xff <<  &PMCR_IMP_SHIFT);}' unless defined(&PMCR_IMP_MASK);
	eval 'sub PMCR_IMP_ARM () {0x41;}' unless defined(&PMCR_IMP_ARM);
	eval 'sub PMCR_IDCODE_SHIFT () {16;}' unless defined(&PMCR_IDCODE_SHIFT);
	eval 'sub PMCR_IDCODE_MASK () {(0xff <<  &PMCR_IDCODE_SHIFT);}' unless defined(&PMCR_IDCODE_MASK);
	eval 'sub PMCR_IDCODE_CORTEX_A57 () {0x1;}' unless defined(&PMCR_IDCODE_CORTEX_A57);
	eval 'sub PMCR_IDCODE_CORTEX_A72 () {0x2;}' unless defined(&PMCR_IDCODE_CORTEX_A72);
	eval 'sub PMCR_IDCODE_CORTEX_A53 () {0x3;}' unless defined(&PMCR_IDCODE_CORTEX_A53);
	eval 'sub PMCR_IDCODE_CORTEX_A73 () {0x4;}' unless defined(&PMCR_IDCODE_CORTEX_A73);
	eval 'sub PMCR_IDCODE_CORTEX_A35 () {0xa;}' unless defined(&PMCR_IDCODE_CORTEX_A35);
	eval 'sub PMCR_IDCODE_CORTEX_A76 () {0xb;}' unless defined(&PMCR_IDCODE_CORTEX_A76);
	eval 'sub PMCR_IDCODE_NEOVERSE_N1 () {0xc;}' unless defined(&PMCR_IDCODE_NEOVERSE_N1);
	eval 'sub PMCR_IDCODE_CORTEX_A77 () {0x10;}' unless defined(&PMCR_IDCODE_CORTEX_A77);
	eval 'sub PMCR_IDCODE_CORTEX_A55 () {0x45;}' unless defined(&PMCR_IDCODE_CORTEX_A55);
	eval 'sub PMCR_IDCODE_NEOVERSE_E1 () {0x46;}' unless defined(&PMCR_IDCODE_NEOVERSE_E1);
	eval 'sub PMCR_IDCODE_CORTEX_A75 () {0x4a;}' unless defined(&PMCR_IDCODE_CORTEX_A75);
	eval 'sub PMCR_N_SHIFT () {11;}' unless defined(&PMCR_N_SHIFT);
	eval 'sub PMCR_N_MASK () {(0x1f <<  &PMCR_N_SHIFT);}' unless defined(&PMCR_N_MASK);
	eval 'sub PMEVCNTR_EL0_op0 () {3;}' unless defined(&PMEVCNTR_EL0_op0);
	eval 'sub PMEVCNTR_EL0_op1 () {3;}' unless defined(&PMEVCNTR_EL0_op1);
	eval 'sub PMEVCNTR_EL0_CRn () {14;}' unless defined(&PMEVCNTR_EL0_CRn);
	eval 'sub PMEVCNTR_EL0_CRm () {8;}' unless defined(&PMEVCNTR_EL0_CRm);
	eval 'sub PMEVTYPER_EL0_op0 () {3;}' unless defined(&PMEVTYPER_EL0_op0);
	eval 'sub PMEVTYPER_EL0_op1 () {3;}' unless defined(&PMEVTYPER_EL0_op1);
	eval 'sub PMEVTYPER_EL0_CRn () {14;}' unless defined(&PMEVTYPER_EL0_CRn);
	eval 'sub PMEVTYPER_EL0_CRm () {12;}' unless defined(&PMEVTYPER_EL0_CRm);
	eval 'sub PMEVTYPER_EVTCOUNT_MASK () {0x3ff;}' unless defined(&PMEVTYPER_EVTCOUNT_MASK);
	eval 'sub PMEVTYPER_EVTCOUNT_8_1_MASK () {0xffff;}' unless defined(&PMEVTYPER_EVTCOUNT_8_1_MASK);
	eval 'sub PMEVTYPER_MT () {(1<< 25);}' unless defined(&PMEVTYPER_MT);
	eval 'sub PMEVTYPER_M () {(1<< 26);}' unless defined(&PMEVTYPER_M);
	eval 'sub PMEVTYPER_NSH () {(1<< 27);}' unless defined(&PMEVTYPER_NSH);
	eval 'sub PMEVTYPER_NSU () {(1<< 28);}' unless defined(&PMEVTYPER_NSU);
	eval 'sub PMEVTYPER_NSK () {(1<< 29);}' unless defined(&PMEVTYPER_NSK);
	eval 'sub PMEVTYPER_U () {(1<< 30);}' unless defined(&PMEVTYPER_U);
	eval 'sub PMEVTYPER_P () {(1<< 31);}' unless defined(&PMEVTYPER_P);
	eval 'sub PMINTENCLR_EL1 () { &MRS_REG( &PMINTENCLR_EL1);}' unless defined(&PMINTENCLR_EL1);
	eval 'sub PMINTENCLR_EL1_op0 () {3;}' unless defined(&PMINTENCLR_EL1_op0);
	eval 'sub PMINTENCLR_EL1_op1 () {0;}' unless defined(&PMINTENCLR_EL1_op1);
	eval 'sub PMINTENCLR_EL1_CRn () {9;}' unless defined(&PMINTENCLR_EL1_CRn);
	eval 'sub PMINTENCLR_EL1_CRm () {14;}' unless defined(&PMINTENCLR_EL1_CRm);
	eval 'sub PMINTENCLR_EL1_op2 () {2;}' unless defined(&PMINTENCLR_EL1_op2);
	eval 'sub PMINTENSET_EL1 () { &MRS_REG( &PMINTENSET_EL1);}' unless defined(&PMINTENSET_EL1);
	eval 'sub PMINTENSET_EL1_op0 () {3;}' unless defined(&PMINTENSET_EL1_op0);
	eval 'sub PMINTENSET_EL1_op1 () {0;}' unless defined(&PMINTENSET_EL1_op1);
	eval 'sub PMINTENSET_EL1_CRn () {9;}' unless defined(&PMINTENSET_EL1_CRn);
	eval 'sub PMINTENSET_EL1_CRm () {14;}' unless defined(&PMINTENSET_EL1_CRm);
	eval 'sub PMINTENSET_EL1_op2 () {1;}' unless defined(&PMINTENSET_EL1_op2);
	eval 'sub PMMIR_EL1 () { &MRS_REG( &PMMIR_EL1);}' unless defined(&PMMIR_EL1);
	eval 'sub PMMIR_EL1_op0 () {3;}' unless defined(&PMMIR_EL1_op0);
	eval 'sub PMMIR_EL1_op1 () {0;}' unless defined(&PMMIR_EL1_op1);
	eval 'sub PMMIR_EL1_CRn () {9;}' unless defined(&PMMIR_EL1_CRn);
	eval 'sub PMMIR_EL1_CRm () {14;}' unless defined(&PMMIR_EL1_CRm);
	eval 'sub PMMIR_EL1_op2 () {6;}' unless defined(&PMMIR_EL1_op2);
	eval 'sub PMOVSCLR_EL0 () { &MRS_REG( &PMOVSCLR_EL0);}' unless defined(&PMOVSCLR_EL0);
	eval 'sub PMOVSCLR_EL0_op0 () {3;}' unless defined(&PMOVSCLR_EL0_op0);
	eval 'sub PMOVSCLR_EL0_op1 () {3;}' unless defined(&PMOVSCLR_EL0_op1);
	eval 'sub PMOVSCLR_EL0_CRn () {9;}' unless defined(&PMOVSCLR_EL0_CRn);
	eval 'sub PMOVSCLR_EL0_CRm () {12;}' unless defined(&PMOVSCLR_EL0_CRm);
	eval 'sub PMOVSCLR_EL0_op2 () {3;}' unless defined(&PMOVSCLR_EL0_op2);
	eval 'sub PMOVSSET_EL0 () { &MRS_REG( &PMOVSSET_EL0);}' unless defined(&PMOVSSET_EL0);
	eval 'sub PMOVSSET_EL0_op0 () {3;}' unless defined(&PMOVSSET_EL0_op0);
	eval 'sub PMOVSSET_EL0_op1 () {3;}' unless defined(&PMOVSSET_EL0_op1);
	eval 'sub PMOVSSET_EL0_CRn () {9;}' unless defined(&PMOVSSET_EL0_CRn);
	eval 'sub PMOVSSET_EL0_CRm () {14;}' unless defined(&PMOVSSET_EL0_CRm);
	eval 'sub PMOVSSET_EL0_op2 () {3;}' unless defined(&PMOVSSET_EL0_op2);
	eval 'sub PMSCR_EL1 () { &MRS_REG( &PMSCR_EL1);}' unless defined(&PMSCR_EL1);
	eval 'sub PMSCR_EL1_op0 () {0x3;}' unless defined(&PMSCR_EL1_op0);
	eval 'sub PMSCR_EL1_op1 () {0x;}' unless defined(&PMSCR_EL1_op1);
	eval 'sub PMSCR_EL1_CRn () {0x9;}' unless defined(&PMSCR_EL1_CRn);
	eval 'sub PMSCR_EL1_CRm () {0x9;}' unless defined(&PMSCR_EL1_CRm);
	eval 'sub PMSCR_EL1_op2 () {0x;}' unless defined(&PMSCR_EL1_op2);
	eval 'sub PMSCR_E0SPE_SHIFT () {0;}' unless defined(&PMSCR_E0SPE_SHIFT);
	eval 'sub PMSCR_E0SPE () {( &UL(0x1) <<  &PMSCR_E0SPE_SHIFT);}' unless defined(&PMSCR_E0SPE);
	eval 'sub PMSCR_E1SPE_SHIFT () {1;}' unless defined(&PMSCR_E1SPE_SHIFT);
	eval 'sub PMSCR_E1SPE () {( &UL(0x1) <<  &PMSCR_E1SPE_SHIFT);}' unless defined(&PMSCR_E1SPE);
	eval 'sub PMSCR_CX_SHIFT () {3;}' unless defined(&PMSCR_CX_SHIFT);
	eval 'sub PMSCR_CX () {( &UL(0x1) <<  &PMSCR_CX_SHIFT);}' unless defined(&PMSCR_CX);
	eval 'sub PMSCR_PA_SHIFT () {4;}' unless defined(&PMSCR_PA_SHIFT);
	eval 'sub PMSCR_PA () {( &UL(0x1) <<  &PMSCR_PA_SHIFT);}' unless defined(&PMSCR_PA);
	eval 'sub PMSCR_TS_SHIFT () {5;}' unless defined(&PMSCR_TS_SHIFT);
	eval 'sub PMSCR_TS () {( &UL(0x1) <<  &PMSCR_TS_SHIFT);}' unless defined(&PMSCR_TS);
	eval 'sub PMSCR_PCT_SHIFT () {6;}' unless defined(&PMSCR_PCT_SHIFT);
	eval 'sub PMSCR_PCT_MASK () {( &UL(0x3) <<  &PMSCR_PCT_SHIFT);}' unless defined(&PMSCR_PCT_MASK);
	eval 'sub PMSELR_EL0 () { &MRS_REG( &PMSELR_EL0);}' unless defined(&PMSELR_EL0);
	eval 'sub PMSELR_EL0_op0 () {3;}' unless defined(&PMSELR_EL0_op0);
	eval 'sub PMSELR_EL0_op1 () {3;}' unless defined(&PMSELR_EL0_op1);
	eval 'sub PMSELR_EL0_CRn () {9;}' unless defined(&PMSELR_EL0_CRn);
	eval 'sub PMSELR_EL0_CRm () {12;}' unless defined(&PMSELR_EL0_CRm);
	eval 'sub PMSELR_EL0_op2 () {5;}' unless defined(&PMSELR_EL0_op2);
	eval 'sub PMSELR_SEL_MASK () {0x1f;}' unless defined(&PMSELR_SEL_MASK);
	eval 'sub PMSEVFR_EL1 () { &MRS_REG( &PMSEVFR_EL1);}' unless defined(&PMSEVFR_EL1);
	eval 'sub PMSEVFR_EL1_op0 () {0x3;}' unless defined(&PMSEVFR_EL1_op0);
	eval 'sub PMSEVFR_EL1_op1 () {0x;}' unless defined(&PMSEVFR_EL1_op1);
	eval 'sub PMSEVFR_EL1_CRn () {0x9;}' unless defined(&PMSEVFR_EL1_CRn);
	eval 'sub PMSEVFR_EL1_CRm () {0x9;}' unless defined(&PMSEVFR_EL1_CRm);
	eval 'sub PMSEVFR_EL1_op2 () {0x5;}' unless defined(&PMSEVFR_EL1_op2);
	eval 'sub PMSFCR_EL1 () { &MRS_REG( &PMSFCR_EL1);}' unless defined(&PMSFCR_EL1);
	eval 'sub PMSFCR_EL1_op0 () {0x3;}' unless defined(&PMSFCR_EL1_op0);
	eval 'sub PMSFCR_EL1_op1 () {0x;}' unless defined(&PMSFCR_EL1_op1);
	eval 'sub PMSFCR_EL1_CRn () {0x9;}' unless defined(&PMSFCR_EL1_CRn);
	eval 'sub PMSFCR_EL1_CRm () {0x9;}' unless defined(&PMSFCR_EL1_CRm);
	eval 'sub PMSFCR_EL1_op2 () {0x4;}' unless defined(&PMSFCR_EL1_op2);
	eval 'sub PMSFCR_FE_SHIFT () {0;}' unless defined(&PMSFCR_FE_SHIFT);
	eval 'sub PMSFCR_FE () {( &UL(0x1) <<  &PMSFCR_FE_SHIFT);}' unless defined(&PMSFCR_FE);
	eval 'sub PMSFCR_FT_SHIFT () {1;}' unless defined(&PMSFCR_FT_SHIFT);
	eval 'sub PMSFCR_FT () {( &UL(0x1) <<  &PMSFCR_FT_SHIFT);}' unless defined(&PMSFCR_FT);
	eval 'sub PMSFCR_FL_SHIFT () {2;}' unless defined(&PMSFCR_FL_SHIFT);
	eval 'sub PMSFCR_FL () {( &UL(0x1) <<  &PMSFCR_FL_SHIFT);}' unless defined(&PMSFCR_FL);
	eval 'sub PMSFCR_FnE_SHIFT () {3;}' unless defined(&PMSFCR_FnE_SHIFT);
	eval 'sub PMSFCR_FnE () {( &UL(0x1) <<  &PMSFCR_FnE_SHIFT);}' unless defined(&PMSFCR_FnE);
	eval 'sub PMSFCR_B_SHIFT () {16;}' unless defined(&PMSFCR_B_SHIFT);
	eval 'sub PMSFCR_B () {( &UL(0x1) <<  &PMSFCR_B_SHIFT);}' unless defined(&PMSFCR_B);
	eval 'sub PMSFCR_LD_SHIFT () {17;}' unless defined(&PMSFCR_LD_SHIFT);
	eval 'sub PMSFCR_LD () {( &UL(0x1) <<  &PMSFCR_LD_SHIFT);}' unless defined(&PMSFCR_LD);
	eval 'sub PMSFCR_ST_SHIFT () {18;}' unless defined(&PMSFCR_ST_SHIFT);
	eval 'sub PMSFCR_ST () {( &UL(0x1) <<  &PMSFCR_ST_SHIFT);}' unless defined(&PMSFCR_ST);
	eval 'sub PMSICR_EL1 () { &MRS_REG( &PMSICR_EL1);}' unless defined(&PMSICR_EL1);
	eval 'sub PMSICR_EL1_op0 () {0x3;}' unless defined(&PMSICR_EL1_op0);
	eval 'sub PMSICR_EL1_op1 () {0x;}' unless defined(&PMSICR_EL1_op1);
	eval 'sub PMSICR_EL1_CRn () {0x9;}' unless defined(&PMSICR_EL1_CRn);
	eval 'sub PMSICR_EL1_CRm () {0x9;}' unless defined(&PMSICR_EL1_CRm);
	eval 'sub PMSICR_EL1_op2 () {0x2;}' unless defined(&PMSICR_EL1_op2);
	eval 'sub PMSICR_COUNT_SHIFT () {0;}' unless defined(&PMSICR_COUNT_SHIFT);
	eval 'sub PMSICR_COUNT_MASK () {( &UL(0xffffffff) <<  &PMSICR_COUNT_SHIFT);}' unless defined(&PMSICR_COUNT_MASK);
	eval 'sub PMSICR_ECOUNT_SHIFT () {56;}' unless defined(&PMSICR_ECOUNT_SHIFT);
	eval 'sub PMSICR_ECOUNT_MASK () {( &UL(0xff) <<  &PMSICR_ECOUNT_SHIFT);}' unless defined(&PMSICR_ECOUNT_MASK);
	eval 'sub PMSIDR_EL1 () { &MRS_REG( &PMSIDR_EL1);}' unless defined(&PMSIDR_EL1);
	eval 'sub PMSIDR_EL1_op0 () {0x3;}' unless defined(&PMSIDR_EL1_op0);
	eval 'sub PMSIDR_EL1_op1 () {0x;}' unless defined(&PMSIDR_EL1_op1);
	eval 'sub PMSIDR_EL1_CRn () {0x9;}' unless defined(&PMSIDR_EL1_CRn);
	eval 'sub PMSIDR_EL1_CRm () {0x9;}' unless defined(&PMSIDR_EL1_CRm);
	eval 'sub PMSIDR_EL1_op2 () {0x7;}' unless defined(&PMSIDR_EL1_op2);
	eval 'sub PMSIDR_FE_SHIFT () {0;}' unless defined(&PMSIDR_FE_SHIFT);
	eval 'sub PMSIDR_FE () {( &UL(0x1) <<  &PMSIDR_FE_SHIFT);}' unless defined(&PMSIDR_FE);
	eval 'sub PMSIDR_FT_SHIFT () {1;}' unless defined(&PMSIDR_FT_SHIFT);
	eval 'sub PMSIDR_FT () {( &UL(0x1) <<  &PMSIDR_FT_SHIFT);}' unless defined(&PMSIDR_FT);
	eval 'sub PMSIDR_FL_SHIFT () {2;}' unless defined(&PMSIDR_FL_SHIFT);
	eval 'sub PMSIDR_FL () {( &UL(0x1) <<  &PMSIDR_FL_SHIFT);}' unless defined(&PMSIDR_FL);
	eval 'sub PMSIDR_ArchInst_SHIFT () {3;}' unless defined(&PMSIDR_ArchInst_SHIFT);
	eval 'sub PMSIDR_ArchInst () {( &UL(0x1) <<  &PMSIDR_ArchInst_SHIFT);}' unless defined(&PMSIDR_ArchInst);
	eval 'sub PMSIDR_LDS_SHIFT () {4;}' unless defined(&PMSIDR_LDS_SHIFT);
	eval 'sub PMSIDR_LDS () {( &UL(0x1) <<  &PMSIDR_LDS_SHIFT);}' unless defined(&PMSIDR_LDS);
	eval 'sub PMSIDR_ERnd_SHIFT () {5;}' unless defined(&PMSIDR_ERnd_SHIFT);
	eval 'sub PMSIDR_ERnd () {( &UL(0x1) <<  &PMSIDR_ERnd_SHIFT);}' unless defined(&PMSIDR_ERnd);
	eval 'sub PMSIDR_FnE_SHIFT () {6;}' unless defined(&PMSIDR_FnE_SHIFT);
	eval 'sub PMSIDR_FnE () {( &UL(0x1) <<  &PMSIDR_FnE_SHIFT);}' unless defined(&PMSIDR_FnE);
	eval 'sub PMSIDR_Interval_SHIFT () {8;}' unless defined(&PMSIDR_Interval_SHIFT);
	eval 'sub PMSIDR_Interval_MASK () {( &UL(0xf) <<  &PMSIDR_Interval_SHIFT);}' unless defined(&PMSIDR_Interval_MASK);
	eval 'sub PMSIDR_MaxSize_SHIFT () {12;}' unless defined(&PMSIDR_MaxSize_SHIFT);
	eval 'sub PMSIDR_MaxSize_MASK () {( &UL(0xf) <<  &PMSIDR_MaxSize_SHIFT);}' unless defined(&PMSIDR_MaxSize_MASK);
	eval 'sub PMSIDR_CountSize_SHIFT () {16;}' unless defined(&PMSIDR_CountSize_SHIFT);
	eval 'sub PMSIDR_CountSize_MASK () {( &UL(0xf) <<  &PMSIDR_CountSize_SHIFT);}' unless defined(&PMSIDR_CountSize_MASK);
	eval 'sub PMSIDR_Format_SHIFT () {20;}' unless defined(&PMSIDR_Format_SHIFT);
	eval 'sub PMSIDR_Format_MASK () {( &UL(0xf) <<  &PMSIDR_Format_SHIFT);}' unless defined(&PMSIDR_Format_MASK);
	eval 'sub PMSIDR_PBT_SHIFT () {24;}' unless defined(&PMSIDR_PBT_SHIFT);
	eval 'sub PMSIDR_PBT () {( &UL(0x1) <<  &PMSIDR_PBT_SHIFT);}' unless defined(&PMSIDR_PBT);
	eval 'sub PMSIRR_EL1 () { &MRS_REG( &PMSIRR_EL1);}' unless defined(&PMSIRR_EL1);
	eval 'sub PMSIRR_EL1_op0 () {0x3;}' unless defined(&PMSIRR_EL1_op0);
	eval 'sub PMSIRR_EL1_op1 () {0x;}' unless defined(&PMSIRR_EL1_op1);
	eval 'sub PMSIRR_EL1_CRn () {0x9;}' unless defined(&PMSIRR_EL1_CRn);
	eval 'sub PMSIRR_EL1_CRm () {0x9;}' unless defined(&PMSIRR_EL1_CRm);
	eval 'sub PMSIRR_EL1_op2 () {0x3;}' unless defined(&PMSIRR_EL1_op2);
	eval 'sub PMSIRR_RND_SHIFT () {0;}' unless defined(&PMSIRR_RND_SHIFT);
	eval 'sub PMSIRR_RND () {( &UL(0x1) <<  &PMSIRR_RND_SHIFT);}' unless defined(&PMSIRR_RND);
	eval 'sub PMSIRR_INTERVAL_SHIFT () {8;}' unless defined(&PMSIRR_INTERVAL_SHIFT);
	eval 'sub PMSIRR_INTERVAL_MASK () {( &UL(0xffffff) <<  &PMSIRR_INTERVAL_SHIFT);}' unless defined(&PMSIRR_INTERVAL_MASK);
	eval 'sub PMSLATFR_EL1 () { &MRS_REG( &PMSLATFR_EL1);}' unless defined(&PMSLATFR_EL1);
	eval 'sub PMSLATFR_EL1_op0 () {0x3;}' unless defined(&PMSLATFR_EL1_op0);
	eval 'sub PMSLATFR_EL1_op1 () {0x;}' unless defined(&PMSLATFR_EL1_op1);
	eval 'sub PMSLATFR_EL1_CRn () {0x9;}' unless defined(&PMSLATFR_EL1_CRn);
	eval 'sub PMSLATFR_EL1_CRm () {0x9;}' unless defined(&PMSLATFR_EL1_CRm);
	eval 'sub PMSLATFR_EL1_op2 () {0x6;}' unless defined(&PMSLATFR_EL1_op2);
	eval 'sub PMSLATFR_MINLAT_SHIFT () {0;}' unless defined(&PMSLATFR_MINLAT_SHIFT);
	eval 'sub PMSLATFR_MINLAT_MASK () {( &UL(0xfff) <<  &PMSLATFR_MINLAT_SHIFT);}' unless defined(&PMSLATFR_MINLAT_MASK);
	eval 'sub PMSNEVFR_EL1 () { &MRS_REG( &PMSNEVFR_EL1);}' unless defined(&PMSNEVFR_EL1);
	eval 'sub PMSNEVFR_EL1_op0 () {0x3;}' unless defined(&PMSNEVFR_EL1_op0);
	eval 'sub PMSNEVFR_EL1_op1 () {0x;}' unless defined(&PMSNEVFR_EL1_op1);
	eval 'sub PMSNEVFR_EL1_CRn () {0x9;}' unless defined(&PMSNEVFR_EL1_CRn);
	eval 'sub PMSNEVFR_EL1_CRm () {0x9;}' unless defined(&PMSNEVFR_EL1_CRm);
	eval 'sub PMSNEVFR_EL1_op2 () {0x1;}' unless defined(&PMSNEVFR_EL1_op2);
	eval 'sub PMSWINC_EL0 () { &MRS_REG( &PMSWINC_EL0);}' unless defined(&PMSWINC_EL0);
	eval 'sub PMSWINC_EL0_op0 () {3;}' unless defined(&PMSWINC_EL0_op0);
	eval 'sub PMSWINC_EL0_op1 () {3;}' unless defined(&PMSWINC_EL0_op1);
	eval 'sub PMSWINC_EL0_CRn () {9;}' unless defined(&PMSWINC_EL0_CRn);
	eval 'sub PMSWINC_EL0_CRm () {12;}' unless defined(&PMSWINC_EL0_CRm);
	eval 'sub PMSWINC_EL0_op2 () {4;}' unless defined(&PMSWINC_EL0_op2);
	eval 'sub PMUSERENR_EL0 () { &MRS_REG( &PMUSERENR_EL0);}' unless defined(&PMUSERENR_EL0);
	eval 'sub PMUSERENR_EL0_op0 () {3;}' unless defined(&PMUSERENR_EL0_op0);
	eval 'sub PMUSERENR_EL0_op1 () {3;}' unless defined(&PMUSERENR_EL0_op1);
	eval 'sub PMUSERENR_EL0_CRn () {9;}' unless defined(&PMUSERENR_EL0_CRn);
	eval 'sub PMUSERENR_EL0_CRm () {14;}' unless defined(&PMUSERENR_EL0_CRm);
	eval 'sub PMUSERENR_EL0_op2 () {0;}' unless defined(&PMUSERENR_EL0_op2);
	eval 'sub PMXEVCNTR_EL0 () { &MRS_REG( &PMXEVCNTR_EL0);}' unless defined(&PMXEVCNTR_EL0);
	eval 'sub PMXEVCNTR_EL0_op0 () {3;}' unless defined(&PMXEVCNTR_EL0_op0);
	eval 'sub PMXEVCNTR_EL0_op1 () {3;}' unless defined(&PMXEVCNTR_EL0_op1);
	eval 'sub PMXEVCNTR_EL0_CRn () {9;}' unless defined(&PMXEVCNTR_EL0_CRn);
	eval 'sub PMXEVCNTR_EL0_CRm () {13;}' unless defined(&PMXEVCNTR_EL0_CRm);
	eval 'sub PMXEVCNTR_EL0_op2 () {2;}' unless defined(&PMXEVCNTR_EL0_op2);
	eval 'sub PMXEVTYPER_EL0 () { &MRS_REG( &PMXEVTYPER_EL0);}' unless defined(&PMXEVTYPER_EL0);
	eval 'sub PMXEVTYPER_EL0_op0 () {3;}' unless defined(&PMXEVTYPER_EL0_op0);
	eval 'sub PMXEVTYPER_EL0_op1 () {3;}' unless defined(&PMXEVTYPER_EL0_op1);
	eval 'sub PMXEVTYPER_EL0_CRn () {9;}' unless defined(&PMXEVTYPER_EL0_CRn);
	eval 'sub PMXEVTYPER_EL0_CRm () {13;}' unless defined(&PMXEVTYPER_EL0_CRm);
	eval 'sub PMXEVTYPER_EL0_op2 () {1;}' unless defined(&PMXEVTYPER_EL0_op2);
	eval 'sub SCTLR_RES1 () {0x30d00800;}' unless defined(&SCTLR_RES1);
	eval 'sub SCTLR_M () {( &UL(0x1) << 0);}' unless defined(&SCTLR_M);
	eval 'sub SCTLR_A () {( &UL(0x1) << 1);}' unless defined(&SCTLR_A);
	eval 'sub SCTLR_C () {( &UL(0x1) << 2);}' unless defined(&SCTLR_C);
	eval 'sub SCTLR_SA () {( &UL(0x1) << 3);}' unless defined(&SCTLR_SA);
	eval 'sub SCTLR_SA0 () {( &UL(0x1) << 4);}' unless defined(&SCTLR_SA0);
	eval 'sub SCTLR_CP15BEN () {( &UL(0x1) << 5);}' unless defined(&SCTLR_CP15BEN);
	eval 'sub SCTLR_nAA () {( &UL(0x1) << 6);}' unless defined(&SCTLR_nAA);
	eval 'sub SCTLR_ITD () {( &UL(0x1) << 7);}' unless defined(&SCTLR_ITD);
	eval 'sub SCTLR_SED () {( &UL(0x1) << 8);}' unless defined(&SCTLR_SED);
	eval 'sub SCTLR_UMA () {( &UL(0x1) << 9);}' unless defined(&SCTLR_UMA);
	eval 'sub SCTLR_EnRCTX () {( &UL(0x1) << 10);}' unless defined(&SCTLR_EnRCTX);
	eval 'sub SCTLR_EOS () {( &UL(0x1) << 11);}' unless defined(&SCTLR_EOS);
	eval 'sub SCTLR_I () {( &UL(0x1) << 12);}' unless defined(&SCTLR_I);
	eval 'sub SCTLR_EnDB () {( &UL(0x1) << 13);}' unless defined(&SCTLR_EnDB);
	eval 'sub SCTLR_DZE () {( &UL(0x1) << 14);}' unless defined(&SCTLR_DZE);
	eval 'sub SCTLR_UCT () {( &UL(0x1) << 15);}' unless defined(&SCTLR_UCT);
	eval 'sub SCTLR_nTWI () {( &UL(0x1) << 16);}' unless defined(&SCTLR_nTWI);
	eval 'sub SCTLR_nTWE () {( &UL(0x1) << 18);}' unless defined(&SCTLR_nTWE);
	eval 'sub SCTLR_WXN () {( &UL(0x1) << 19);}' unless defined(&SCTLR_WXN);
	eval 'sub SCTLR_TSCXT () {( &UL(0x1) << 20);}' unless defined(&SCTLR_TSCXT);
	eval 'sub SCTLR_IESB () {( &UL(0x1) << 21);}' unless defined(&SCTLR_IESB);
	eval 'sub SCTLR_EIS () {( &UL(0x1) << 22);}' unless defined(&SCTLR_EIS);
	eval 'sub SCTLR_SPAN () {( &UL(0x1) << 23);}' unless defined(&SCTLR_SPAN);
	eval 'sub SCTLR_E0E () {( &UL(0x1) << 24);}' unless defined(&SCTLR_E0E);
	eval 'sub SCTLR_EE () {( &UL(0x1) << 25);}' unless defined(&SCTLR_EE);
	eval 'sub SCTLR_UCI () {( &UL(0x1) << 26);}' unless defined(&SCTLR_UCI);
	eval 'sub SCTLR_EnDA () {( &UL(0x1) << 27);}' unless defined(&SCTLR_EnDA);
	eval 'sub SCTLR_nTLSMD () {( &UL(0x1) << 28);}' unless defined(&SCTLR_nTLSMD);
	eval 'sub SCTLR_LSMAOE () {( &UL(0x1) << 29);}' unless defined(&SCTLR_LSMAOE);
	eval 'sub SCTLR_EnIB () {( &UL(0x1) << 30);}' unless defined(&SCTLR_EnIB);
	eval 'sub SCTLR_EnIA () {( &UL(0x1) << 31);}' unless defined(&SCTLR_EnIA);
	eval 'sub SCTLR_BT0 () {( &UL(0x1) << 35);}' unless defined(&SCTLR_BT0);
	eval 'sub SCTLR_BT1 () {( &UL(0x1) << 36);}' unless defined(&SCTLR_BT1);
	eval 'sub SCTLR_ITFSB () {( &UL(0x1) << 37);}' unless defined(&SCTLR_ITFSB);
	eval 'sub SCTLR_TCF0_MASK () {( &UL(0x3) << 38);}' unless defined(&SCTLR_TCF0_MASK);
	eval 'sub SCTLR_TCF_MASK () {( &UL(0x3) << 40);}' unless defined(&SCTLR_TCF_MASK);
	eval 'sub SCTLR_ATA0 () {( &UL(0x1) << 42);}' unless defined(&SCTLR_ATA0);
	eval 'sub SCTLR_ATA () {( &UL(0x1) << 43);}' unless defined(&SCTLR_ATA);
	eval 'sub SCTLR_DSSBS () {( &UL(0x1) << 44);}' unless defined(&SCTLR_DSSBS);
	eval 'sub SCTLR_TWEDEn () {( &UL(0x1) << 45);}' unless defined(&SCTLR_TWEDEn);
	eval 'sub SCTLR_TWEDEL_MASK () {( &UL(0xf) << 46);}' unless defined(&SCTLR_TWEDEL_MASK);
	eval 'sub SCTLR_EnASR () {( &UL(0x1) << 54);}' unless defined(&SCTLR_EnASR);
	eval 'sub SCTLR_EnAS0 () {( &UL(0x1) << 55);}' unless defined(&SCTLR_EnAS0);
	eval 'sub SCTLR_EnALS () {( &UL(0x1) << 56);}' unless defined(&SCTLR_EnALS);
	eval 'sub SCTLR_EPAN () {( &UL(0x1) << 57);}' unless defined(&SCTLR_EPAN);
	eval 'sub PSR_M_EL0t () {0x;}' unless defined(&PSR_M_EL0t);
	eval 'sub PSR_M_EL1t () {0x4;}' unless defined(&PSR_M_EL1t);
	eval 'sub PSR_M_EL1h () {0x5;}' unless defined(&PSR_M_EL1h);
	eval 'sub PSR_M_EL2t () {0x8;}' unless defined(&PSR_M_EL2t);
	eval 'sub PSR_M_EL2h () {0x9;}' unless defined(&PSR_M_EL2h);
	eval 'sub PSR_M_64 () {0x;}' unless defined(&PSR_M_64);
	eval 'sub PSR_M_32 () {0x10;}' unless defined(&PSR_M_32);
	eval 'sub PSR_M_MASK () {0xf;}' unless defined(&PSR_M_MASK);
	eval 'sub PSR_T () {0x20;}' unless defined(&PSR_T);
	eval 'sub PSR_AARCH32 () {0x10;}' unless defined(&PSR_AARCH32);
	eval 'sub PSR_F () {0x40;}' unless defined(&PSR_F);
	eval 'sub PSR_I () {0x80;}' unless defined(&PSR_I);
	eval 'sub PSR_A () {0x100;}' unless defined(&PSR_A);
	eval 'sub PSR_D () {0x200;}' unless defined(&PSR_D);
	eval 'sub PSR_DAIF () {( &PSR_D |  &PSR_A |  &PSR_I |  &PSR_F);}' unless defined(&PSR_DAIF);
	eval 'sub PSR_DAIF_DEFAULT () {( &PSR_F);}' unless defined(&PSR_DAIF_DEFAULT);
	eval 'sub PSR_IL () {0x100000;}' unless defined(&PSR_IL);
	eval 'sub PSR_SS () {0x200000;}' unless defined(&PSR_SS);
	eval 'sub PSR_V () {0x10000000;}' unless defined(&PSR_V);
	eval 'sub PSR_C () {0x20000000;}' unless defined(&PSR_C);
	eval 'sub PSR_Z () {0x40000000;}' unless defined(&PSR_Z);
	eval 'sub PSR_N () {0x80000000;}' unless defined(&PSR_N);
	eval 'sub PSR_FLAGS () {0xf0000000;}' unless defined(&PSR_FLAGS);
	eval 'sub PSR_SETTABLE_32 () { &PSR_FLAGS;}' unless defined(&PSR_SETTABLE_32);
	eval 'sub PSR_SETTABLE_64 () {( &PSR_FLAGS |  &PSR_SS);}' unless defined(&PSR_SETTABLE_64);
	eval 'sub REVIDR_EL1 () { &MRS_REG( &REVIDR_EL1);}' unless defined(&REVIDR_EL1);
	eval 'sub REVIDR_EL1_op0 () {3;}' unless defined(&REVIDR_EL1_op0);
	eval 'sub REVIDR_EL1_op1 () {0;}' unless defined(&REVIDR_EL1_op1);
	eval 'sub REVIDR_EL1_CRn () {0;}' unless defined(&REVIDR_EL1_CRn);
	eval 'sub REVIDR_EL1_CRm () {0;}' unless defined(&REVIDR_EL1_CRm);
	eval 'sub REVIDR_EL1_op2 () {6;}' unless defined(&REVIDR_EL1_op2);
	eval 'sub TCR_TCMA1_SHIFT () {58;}' unless defined(&TCR_TCMA1_SHIFT);
	eval 'sub TCR_TCMA1 () {(1 <<  &TCR_TCMA1_SHIFT);}' unless defined(&TCR_TCMA1);
	eval 'sub TCR_TCMA0_SHIFT () {57;}' unless defined(&TCR_TCMA0_SHIFT);
	eval 'sub TCR_TCMA0 () {(1 <<  &TCR_TCMA0_SHIFT);}' unless defined(&TCR_TCMA0);
	eval 'sub TCR_E0PD1_SHIFT () {56;}' unless defined(&TCR_E0PD1_SHIFT);
	eval 'sub TCR_E0PD1 () {(1 <<  &TCR_E0PD1_SHIFT);}' unless defined(&TCR_E0PD1);
	eval 'sub TCR_E0PD0_SHIFT () {55;}' unless defined(&TCR_E0PD0_SHIFT);
	eval 'sub TCR_E0PD0 () {(1 <<  &TCR_E0PD0_SHIFT);}' unless defined(&TCR_E0PD0);
	eval 'sub TCR_NFD1_SHIFT () {54;}' unless defined(&TCR_NFD1_SHIFT);
	eval 'sub TCR_NFD1 () {(1 <<  &TCR_NFD1_SHIFT);}' unless defined(&TCR_NFD1);
	eval 'sub TCR_NFD0_SHIFT () {53;}' unless defined(&TCR_NFD0_SHIFT);
	eval 'sub TCR_NFD0 () {(1 <<  &TCR_NFD0_SHIFT);}' unless defined(&TCR_NFD0);
	eval 'sub TCR_TBID1_SHIFT () {52;}' unless defined(&TCR_TBID1_SHIFT);
	eval 'sub TCR_TBID1 () {(1 <<  &TCR_TBID1_SHIFT);}' unless defined(&TCR_TBID1);
	eval 'sub TCR_TBID0_SHIFT () {51;}' unless defined(&TCR_TBID0_SHIFT);
	eval 'sub TCR_TBID0 () {(1 <<  &TCR_TBID0_SHIFT);}' unless defined(&TCR_TBID0);
	eval 'sub TCR_HWU162_SHIFT () {50;}' unless defined(&TCR_HWU162_SHIFT);
	eval 'sub TCR_HWU162 () {(1 <<  &TCR_HWU162_SHIFT);}' unless defined(&TCR_HWU162);
	eval 'sub TCR_HWU161_SHIFT () {49;}' unless defined(&TCR_HWU161_SHIFT);
	eval 'sub TCR_HWU161 () {(1 <<  &TCR_HWU161_SHIFT);}' unless defined(&TCR_HWU161);
	eval 'sub TCR_HWU160_SHIFT () {48;}' unless defined(&TCR_HWU160_SHIFT);
	eval 'sub TCR_HWU160 () {(1 <<  &TCR_HWU160_SHIFT);}' unless defined(&TCR_HWU160);
	eval 'sub TCR_HWU159_SHIFT () {47;}' unless defined(&TCR_HWU159_SHIFT);
	eval 'sub TCR_HWU159 () {(1 <<  &TCR_HWU159_SHIFT);}' unless defined(&TCR_HWU159);
	eval 'sub TCR_HWU1 () {( &TCR_HWU159 |  &TCR_HWU160 |  &TCR_HWU161 |  &TCR_HWU162);}' unless defined(&TCR_HWU1);
	eval 'sub TCR_HWU062_SHIFT () {46;}' unless defined(&TCR_HWU062_SHIFT);
	eval 'sub TCR_HWU062 () {(1 <<  &TCR_HWU062_SHIFT);}' unless defined(&TCR_HWU062);
	eval 'sub TCR_HWU061_SHIFT () {45;}' unless defined(&TCR_HWU061_SHIFT);
	eval 'sub TCR_HWU061 () {(1 <<  &TCR_HWU061_SHIFT);}' unless defined(&TCR_HWU061);
	eval 'sub TCR_HWU060_SHIFT () {44;}' unless defined(&TCR_HWU060_SHIFT);
	eval 'sub TCR_HWU060 () {(1 <<  &TCR_HWU060_SHIFT);}' unless defined(&TCR_HWU060);
	eval 'sub TCR_HWU059_SHIFT () {43;}' unless defined(&TCR_HWU059_SHIFT);
	eval 'sub TCR_HWU059 () {(1 <<  &TCR_HWU059_SHIFT);}' unless defined(&TCR_HWU059);
	eval 'sub TCR_HWU0 () {( &TCR_HWU059 |  &TCR_HWU060 |  &TCR_HWU061 |  &TCR_HWU062);}' unless defined(&TCR_HWU0);
	eval 'sub TCR_HPD1_SHIFT () {42;}' unless defined(&TCR_HPD1_SHIFT);
	eval 'sub TCR_HPD1 () {(1 <<  &TCR_HPD1_SHIFT);}' unless defined(&TCR_HPD1);
	eval 'sub TCR_HPD0_SHIFT () {41;}' unless defined(&TCR_HPD0_SHIFT);
	eval 'sub TCR_HPD0 () {(1 <<  &TCR_HPD0_SHIFT);}' unless defined(&TCR_HPD0);
	eval 'sub TCR_HD_SHIFT () {40;}' unless defined(&TCR_HD_SHIFT);
	eval 'sub TCR_HD () {(1 <<  &TCR_HD_SHIFT);}' unless defined(&TCR_HD);
	eval 'sub TCR_HA_SHIFT () {39;}' unless defined(&TCR_HA_SHIFT);
	eval 'sub TCR_HA () {(1 <<  &TCR_HA_SHIFT);}' unless defined(&TCR_HA);
	eval 'sub TCR_TBI1_SHIFT () {38;}' unless defined(&TCR_TBI1_SHIFT);
	eval 'sub TCR_TBI1 () {(1 <<  &TCR_TBI1_SHIFT);}' unless defined(&TCR_TBI1);
	eval 'sub TCR_TBI0_SHIFT () {37;}' unless defined(&TCR_TBI0_SHIFT);
	eval 'sub TCR_TBI0 () {(1 <<  &TCR_TBI0_SHIFT);}' unless defined(&TCR_TBI0);
	eval 'sub TCR_ASID_SHIFT () {36;}' unless defined(&TCR_ASID_SHIFT);
	eval 'sub TCR_ASID_WIDTH () {1;}' unless defined(&TCR_ASID_WIDTH);
	eval 'sub TCR_ASID_16 () {(1 <<  &TCR_ASID_SHIFT);}' unless defined(&TCR_ASID_16);
	eval 'sub TCR_IPS_SHIFT () {32;}' unless defined(&TCR_IPS_SHIFT);
	eval 'sub TCR_IPS_WIDTH () {3;}' unless defined(&TCR_IPS_WIDTH);
	eval 'sub TCR_IPS_32BIT () {(0 <<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_32BIT);
	eval 'sub TCR_IPS_36BIT () {(1 <<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_36BIT);
	eval 'sub TCR_IPS_40BIT () {(2 <<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_40BIT);
	eval 'sub TCR_IPS_42BIT () {(3 <<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_42BIT);
	eval 'sub TCR_IPS_44BIT () {(4 <<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_44BIT);
	eval 'sub TCR_IPS_48BIT () {(5 <<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_48BIT);
	eval 'sub TCR_TG1_SHIFT () {30;}' unless defined(&TCR_TG1_SHIFT);
	eval 'sub TCR_TG1_MASK () {(3 <<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_MASK);
	eval 'sub TCR_TG1_16K () {(1 <<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_16K);
	eval 'sub TCR_TG1_4K () {(2 <<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_4K);
	eval 'sub TCR_TG1_64K () {(3 <<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_64K);
	eval 'sub TCR_SH1_SHIFT () {28;}' unless defined(&TCR_SH1_SHIFT);
	eval 'sub TCR_SH1_IS () {(3 <<  &TCR_SH1_SHIFT);}' unless defined(&TCR_SH1_IS);
	eval 'sub TCR_ORGN1_SHIFT () {26;}' unless defined(&TCR_ORGN1_SHIFT);
	eval 'sub TCR_ORGN1_WBWA () {(1 <<  &TCR_ORGN1_SHIFT);}' unless defined(&TCR_ORGN1_WBWA);
	eval 'sub TCR_IRGN1_SHIFT () {24;}' unless defined(&TCR_IRGN1_SHIFT);
	eval 'sub TCR_IRGN1_WBWA () {(1 <<  &TCR_IRGN1_SHIFT);}' unless defined(&TCR_IRGN1_WBWA);
	eval 'sub TCR_EPD1_SHIFT () {23;}' unless defined(&TCR_EPD1_SHIFT);
	eval 'sub TCR_EPD1 () {(1 <<  &TCR_EPD1_SHIFT);}' unless defined(&TCR_EPD1);
	eval 'sub TCR_A1_SHIFT () {22;}' unless defined(&TCR_A1_SHIFT);
	eval 'sub TCR_A1 () {(0x1 <<  &TCR_A1_SHIFT);}' unless defined(&TCR_A1);
	eval 'sub TCR_T1SZ_SHIFT () {16;}' unless defined(&TCR_T1SZ_SHIFT);
	eval 'sub TCR_T1SZ_MASK () {(0x3f <<  &TCR_T1SZ_SHIFT);}' unless defined(&TCR_T1SZ_MASK);
	eval 'sub TCR_T1SZ {
	    my($x) = @_;
    	    eval q((($x) <<  &TCR_T1SZ_SHIFT));
	}' unless defined(&TCR_T1SZ);
	eval 'sub TCR_TG0_SHIFT () {14;}' unless defined(&TCR_TG0_SHIFT);
	eval 'sub TCR_TG0_MASK () {(3 <<  &TCR_TG0_SHIFT);}' unless defined(&TCR_TG0_MASK);
	eval 'sub TCR_TG0_4K () {(0 <<  &TCR_TG0_SHIFT);}' unless defined(&TCR_TG0_4K);
	eval 'sub TCR_TG0_64K () {(1 <<  &TCR_TG0_SHIFT);}' unless defined(&TCR_TG0_64K);
	eval 'sub TCR_TG0_16K () {(2 <<  &TCR_TG0_SHIFT);}' unless defined(&TCR_TG0_16K);
	eval 'sub TCR_SH0_SHIFT () {12;}' unless defined(&TCR_SH0_SHIFT);
	eval 'sub TCR_SH0_IS () {(3 <<  &TCR_SH0_SHIFT);}' unless defined(&TCR_SH0_IS);
	eval 'sub TCR_ORGN0_SHIFT () {10;}' unless defined(&TCR_ORGN0_SHIFT);
	eval 'sub TCR_ORGN0_WBWA () {(1 <<  &TCR_ORGN0_SHIFT);}' unless defined(&TCR_ORGN0_WBWA);
	eval 'sub TCR_IRGN0_SHIFT () {8;}' unless defined(&TCR_IRGN0_SHIFT);
	eval 'sub TCR_IRGN0_WBWA () {(1 <<  &TCR_IRGN0_SHIFT);}' unless defined(&TCR_IRGN0_WBWA);
	eval 'sub TCR_EPD0_SHIFT () {7;}' unless defined(&TCR_EPD0_SHIFT);
	eval 'sub TCR_EPD0 () {(1 <<  &TCR_EPD0_SHIFT);}' unless defined(&TCR_EPD0);
	eval 'sub TCR_T0SZ_SHIFT () {0;}' unless defined(&TCR_T0SZ_SHIFT);
	eval 'sub TCR_T0SZ_MASK () {(0x3f <<  &TCR_T0SZ_SHIFT);}' unless defined(&TCR_T0SZ_MASK);
	eval 'sub TCR_T0SZ {
	    my($x) = @_;
    	    eval q((($x) <<  &TCR_T0SZ_SHIFT));
	}' unless defined(&TCR_T0SZ);
	eval 'sub TCR_TxSZ {
	    my($x) = @_;
    	    eval q(( &TCR_T1SZ($x) |  &TCR_T0SZ($x)));
	}' unless defined(&TCR_TxSZ);
	eval 'sub TCR_CACHE_ATTRS () {(( &TCR_IRGN0_WBWA |  &TCR_IRGN1_WBWA) | ( &TCR_ORGN0_WBWA |  &TCR_ORGN1_WBWA));}' unless defined(&TCR_CACHE_ATTRS);
	if(defined(&SMP)) {
	    eval 'sub TCR_SMP_ATTRS () {( &TCR_SH0_IS |  &TCR_SH1_IS);}' unless defined(&TCR_SMP_ATTRS);
	} else {
	    eval 'sub TCR_SMP_ATTRS () {0;}' unless defined(&TCR_SMP_ATTRS);
	}
	eval 'sub TTBR_ASID_SHIFT () {48;}' unless defined(&TTBR_ASID_SHIFT);
	eval 'sub TTBR_ASID_MASK () {(0xffff <<  &TTBR_ASID_SHIFT);}' unless defined(&TTBR_ASID_MASK);
	eval 'sub TTBR_BADDR () {0xfffffffffffe;}' unless defined(&TTBR_BADDR);
	eval 'sub TTBR_CnP_SHIFT () {0;}' unless defined(&TTBR_CnP_SHIFT);
	eval 'sub TTBR_CnP () {(1 <<  &TTBR_CnP_SHIFT);}' unless defined(&TTBR_CnP);
	eval 'sub ZCR_LEN_SHIFT () {0;}' unless defined(&ZCR_LEN_SHIFT);
	eval 'sub ZCR_LEN_MASK () {(0xf <<  &ZCR_LEN_SHIFT);}' unless defined(&ZCR_LEN_MASK);
	eval 'sub ZCR_LEN_BYTES {
	    my($x) = @_;
    	    eval q((((($x) &  &ZCR_LEN_MASK) + 1) * 16));
	}' unless defined(&ZCR_LEN_BYTES);
    }
}
1;
